      SUBROUTINE BUILD(ATPR,ITPR,NAT,NPRS,NPRSO,NPC,NPIEK,FT,JFAT,FO,
     1 AC,BC,SN,H,K,IL,XYZ,POINT,NR,C,S,R,R2,HEAV,NLEES,IPAT,
     2 PRES,R2OLD,R2ANC,FOBS,VER,ACALC,BCALC,ST,SR2E,WORK,NATS,IWORK,
     3 READY,NATO)
      DIMENSION C(NAT),S(NAT),XYZ(4,NPIEK),WORK(NATS),IWORK(NAT)
      DIMENSION FT(JFAT),FO(NR),AC(NR),BC(NR),SN(NR),
     1 H(NR),K(NR),IL(NR)
	DIMENSION FOBS(NR),VER(10,NR),ACALC(NR),BCALC(NR),ST(NR)
      DIMENSION ATPR(6,NAT),ITPR(2,NAT)
      COMMON/PNTR/IPNT(10),JPNT(10),Q(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),ATOM(10),EXCL(10)
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
	INTEGER H,POINT(NAT,2)
C	REAL*8 DIJ,VC,DE
      LOGICAL HEAV,READY
C
C  Routine builds the new model
C  If ready=true a difference map was used, check is not called
C  Npiek: number of peaks in XYZ
C  Npc  : maximum number of atoms in the new model
C  Check whether we are dealing with a heavy atom structure
C  If R2 is already below 0.2 then heavy atoms and such like are OK.
C  If Ipat <>1 then symmetry of the model is too high
C  Solve is called to remedy this
C
	NPRSO=NPRS
      IF(IPAT.NE.1)THEN
      CALL CHECK(ATPR,ITPR,XYZ,NAT,NPRS,NPIEK,FT,JFAT,R2)
	N1=MIN(NPRS+1,NAT)
      CALL SOLVE(ATPR,ITPR,XYZ,NAT,NPRS,NPIEK,IPAT)
      CALL HEAVY3(ATPR,ITPR,NAT,NPRS,FT,JFAT,FO,AC,BC,SN,H,K,
     1            IL,POINT,NR,C,S,R,R2,HEAV,NLEES,R2OLD,R2ANC,
     2            FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,SR2E,JFT)
	IF(JFT.GT.0)NPRS=N1
	DO 1 I=1,NPRS
      IF(ITPR(1,I).EQ.0)ITPR(1,I)=JFAT
1     CONTINUE
      RETURN
      ENDIF
C
C  New model is created, atpr, itpr and nprs are adapted
C
	IF(READY)THEN
C	IF(PRES.GE.0.7.AND.NAT.GT.NPRS.AND.R2.LT.0.2)THEN
C     CALL CHECK(ATPR,ITPR,XYZ,NAT,NPRS,NPIEK,FT,JFAT,R2)
	NPRS=MIN(NPRS,NAT)
      CALL HEAVY(ATPR,ITPR,NAT,NPRS,XYZ,NPIEK,FT,JFAT,FO,AC,BC,
     1 SN,H,K,IL,POINT,NR,C,S,R,R2,
     2            FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,SR2E)
	RETURN
	ELSE
      CALL CHECK(ATPR,ITPR,XYZ,NAT,NPRS,NPIEK,FT,JFAT,R2)
	IF(NPRS.NE.NPRSO)THEN
	NPC=NPC-NPRSO+NPRS
	NPIEK=NPIEK-NPRSO+NPRS
	ENDIF
	IF(NPRS.LT.NAT)THEN
	I=0
2	I=I+1
	IF(I.LE.NPIEK.AND.NPRS.LT.NAT)THEN
	NPRS=NPRS+1
      ITPR(2,NPRS)=XYZ(4,I)+0.5
      ITPR(1,NPRS)=0
      CALL SMLT(XYZ(1,I),BGR)
      DO 308 II=1,3
308   ATPR(II,NPRS)=XYZ(II,I)
      IF(ATPR(4,NPRS).LT.0.1)ATPR(4,NPRS)=1./BGR
      ATPR(5,NPRS)=0.0
      ATPR(6,NPRS)=1.0
	IF(NPRS.LT.NPC)GOTO 2
	ENDIF
	ENDIF
	NPRS1=NPRS
      CALL HEAVY3(ATPR,ITPR,NAT,NPRS,FT,JFAT,FO,AC,BC,SN,H,K,
     1            IL,POINT,NR,C,S,R,R2,HEAV,NLEES,R2OLD,R2ANC,
     2            FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,SR2E,JFT)
	IF(NATO.NE.NAT)NPRS=NPRS1
	ENDIF
      RETURN
      END
