      SUBROUTINE DEVINE(IO,IH,IK,IL,SN,FAT,NR,JFAT,FT,NFAT,B,DE,C,S,M,
     1  N1,ATPR,ITPR,NAME,NPRS,NAT,NP,ETA,FOBS,VER,ACALC,BCALC,ST,
     2  WORK,NATS,NATMAX,IWORK)
C
C  DRIVER FOR THE CALCULATION OF ATOMIC NUMBERS
C  VAX ADAPTATION, SPACE C TWO TIMES AS BIG C(N1*2)
C
      REAL*8 DE,M,B
	DIMENSION FOBS(NR),VER(10,NR),ACALC(NR),BCALC(NR),ST(NR)
      DIMENSION IO(NR),IH(NR),IK(NR),IL(NR),SN(NR),FAT(JFAT)
      DIMENSION FT(32,NFAT),B(N1),DE(N1),C(N1*2),S(N1),M(N1,N1),
     1 ATPR(6,NAT),ITPR(2,NAT),NAME(NAT),WORK(NATS),IWORK(NAT)
      CHARACTER*8 NAME,NAAM
      DIMENSION NAAM(92),NUMBER(92)
      REAL IO
      COMMON/PNTR/IPNT(10),JPNT(10),Q(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),ATOM(10),EXCL(10)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11),
     1 ISER(10),SFF,SQ,DN,XN,MH(3),ITLE(20),DM,XM
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      DATA NAAM/' H','HE','LI','BE',' B',' C',' N',' O',' F',
     8 'NE','NA','MG',
     1 'AL','SI',' P',' S','CL','AR',' K','CA','SC','TI',' V','CR','MN',
     2 'FE','CO','NI','CU','ZN','GA','GE','AS','SE','BR','KR','RB',
     3 'SR',' Y','ZR','NB','MO','TC','RU','RH','PD','AG','CD','IN','SN',
     4 'SB','TE',' I','XE','CS','BA','LA','CE','PR','ND','PM','SM',
     5 'EU','GD','TB','DY','HO','ER','TM','YB','LU','HF','TA',' W',
     6 'RE','OS','IR','PT','AU','HG','TL','PB','BI','PO','AT','RN',
     7 'FR','RA','AC','TH','PA',' U'/
      SF=0.
      SF0=0.
      DO 66 I=1,92
66    NUMBER(I)=0
      DO 6 I=1,NFAT
      ITF=FT(1,I)+.5
      IF(ITF.EQ.1)GOTO 6
      TF=FT(1,I)*FT(1,I)
      NM=NUM(I)
C     DO 68 IJ=1,NVAST
C     IF(I.EQ.KVO(IJ))GOTO 6
C68    CONTINUE
      SF0=SF0+NM*FT(1,I)
      SF=SF+NM*TF
    6 CONTINUE
C      SF0=SF0/NQV
      DO 4 I=1,NPRS
      K=ITPR(1,I)
      ATPR(6,I)=FT(1,KPNT(IPNT(K)))
    4 CONTINUE
C      SF=SF/NQV
      IF(NP.NE.0.AND.NPRS.EQ.NAT.AND.NAT.LT.NATMAX)CALL HEAVY2(IO,IH,IK
     1 ,IL,SN,FAT,NR,JFAT,ATPR,ITPR,NAT,NP,C,S,B,DE,M,N1,ETA,SF0,SF,
     2 FOBS,VER,ACALC,BCALC,WORK,NATS,IWORK)
      DO 5 I=1,NPRS
      FP=ATPR(6,I)
      D=1000.
      DO 8 IFT=1,NFAT
      FQ=FT(1,IFT)
      DT=ABS(FP-FQ)
      IF(DT.GT.D)GOTO 8
      D=DT
      IN=IFT
    8 CONTINUE
      IF(D.GT.5.0)WRITE(LO,1000)(ATPR(J,I),J=1,3)
1000  FORMAT(/,' DEVINE: Atom with coordinates: ',3F10.4,5X,' has no',
     1 ' proper atomic number')
      K=FT(1,IN)+.5
	ATPR(5,I)=K
      IF(NP.NE.0.AND.NPRS.EQ.NAT)THEN
	ATPR(6,I)=1.0
	ITPR(1,I)=IN
	ELSE
	ITPR(1,I)=1
      ATPR(6,I)=FT(1,IN)
	ENDIF
      NAME(I)=NAAM(K)
      NUMBER(K)=NUMBER(K)+1
      IF(NUMBER(K).LT.10)WRITE(NAME(I)(3:8),1001)NUMBER(K)
      IF(NUMBER(K).LT.100.AND.NUMBER(K).GE.10)
     1 WRITE(NAME(I)(3:8),1002)NUMBER(K)
      IF(NUMBER(K).LT.1000.AND.NUMBER(K).GE.100)
     1 WRITE(NAME(I)(3:8),1003)NUMBER(K)
      IF(NUMBER(K).LT.10000.AND.NUMBER(K).GE.1000)
     1 WRITE(NAME(I)(3:8),1004)NUMBER(K)
5     CONTINUE
1001  FORMAT(I1)
1002  FORMAT(I2)
1003  FORMAT(I3)
1004  FORMAT(I4)
      RETURN
      END
