      SUBROUTINE PP1(X,Y,IY,NSIZE,NX,NY,NZ,IH,G,NR,NEX,NRS3)
C
C  DRIVER OF FFT SECTION (CF MULTAN80)
C
      REAL X(NSIZE),Y(NSIZE)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11),
     1 ISER(10),SF,SQ,DN,XN,MH(3),ITLE(20),DM,XM
      DIMENSION IH(NR),G(2,NR),IY(NSIZE)
      INTEGER P1,P2,R,D(5)
      P1=NSIZE/(2*NY*(MH(3)+1))
      P2=NSIZE/(NX*NZ)
      IF(P1.GE.(2*MH(1)+1).AND.P2.GT.0)THEN
C
C  PASS ONE. TRANSFORM ON K
C
      REWIND LM
      R=-MH(1)
      P1=MH(1)+1-R
      CALL READ KL(X,NY,MH(3)+1,P1,R,IH,G,NR,NEX)
      D(1)=2*(NY*P1*(MH(3)+1))
      D(2)=2
      D(3)=D(1)
      D(4)=D(1)
      D(5)=2*NY
      CALL CMPLFT(X(1),X(2),NSIZE,NY,D)
      CALL WRITE Y(X,Y,NY,MH(3)+1,P1,NSIZE/2)
C
C  END OF PASS ONE.
C  PASS TWO CALCULATES FINAL FOURIERMAP
C
      P2=NY
      CALL READ HL(X,Y,NX,NZ/2,P2,MH(1),MH(3)+1,NSIZE/2)
C
C  X NOW CONTAINS INTERMEDIATE RESULTS STORED WITH L DOWN
C  THE COLUMNS AND H ACROSS THE ROWS
C
      D(1)=NX*NZ*P2
      D(2)=NZ
      D(3)=NZ*NX
      D(4)=2*(MH(3)+1)
      D(5)=2
      CALL CMPLFT(X(1),X(2),NSIZE,NX,D)
      D(2)=2
      D(3)=D(1)
      D(4)=D(1)
      D(5)=NZ
      CALL HERMFT (X(1),X(2),NSIZE,NZ/2,D)
      CALL OUTPUT(X,IY,NZ,NX,P2,NSIZE)
C
C  END OF JOB
C
      RETURN
      ELSE
      P1=2*NY*(MH(3)+1)*(2*MH(1)+1)
      P2=NX*NZ*NY
      WRITE (LO,350)NSIZE,P1,P2
  350 FORMAT(' ',33HPP1:REQUEST TOO LARGE. AVAILABLE:,I10/' ',25X,
     1 10HREQUESTED:,I10,4H AND,I10)
      STOP
      ENDIF
      END
