      SUBROUTINE SCHFT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,FT,JFAT,FO,
     1 AC,BC,SN,H,K,IL,NR,P1,DELR,PRW,C,S,NPRSO,GO_ON,STOPR,TOBAD,
     2 NLEES,HFLAG,R,R2,R2OLD,R2ANC,FOBS,VER,ACALC,BCALC,ST,WORK,
     3 NATS,IWORK,FLAG,FLAGO)
      DIMENSION FOBS(NR),VER(10,NR),ACALC(NR),BCALC(NR),ST(NR)
      DIMENSION C(NAT),S(NAT),WORK(NATS),IWORK(NAT)
C
C  USE R2-CRITERION TO DISCARD WRONG ATOMS
C
      DIMENSION FAT(32,NFAT),FT(JFAT),FO(NR),AC(NR),BC(NR),SN(NR),
     1 H(NR),K(NR),IL(NR)
      DIMENSION ATPR(6,NAT),ITPR(2,NAT)
      INTEGER H
      LOGICAL GO_ON,TOBAD,HFLAG,FLAG,FLAGO,FLOG
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
C      STORE R2OLD
	SAVE NOEX
      GO_ON=.TRUE.
	TOBAD=.FALSE.
	FLOG=(FLAG.AND.FLAGO).OR.(.NOT.FLAG.AND..NOT.FLAGO)
      IF(NPRS.LT.NLEES)THEN
      R2OLD=1.00
      R2ANC=1.00
      ENDIF
C
C  INITIALIZE R2 FACTOR AND CALCULATE STRUCTUREFACTORS
C
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
      CALL ESTMTE(R2E,SR2E,PRS,FO,SN,NR,0.0)
      WRITE(LO,1)R2,R2E,SR2E
    1 FORMAT(/,' SCHFT: Actual R2:',F7.4,1X,' Estimated R2:',F7.4,1X,
     1 ' Estimated random error:',F7.4)
C
C  TOBAD=.TRUE.: The model is not good enough, go to diverg or stop
C  Otherwise if GO_ON=.TRUE.
C  R2 is still decreasing, cycles should be continued.
C  If not, stop cycles and check whether R2>STOPR, R2<DREMPL etc.
C
	R2A=R2ANC-R2
	R2O=R2OLD-R2
      GO_ON=R2A.GT.3.0*SR2E.OR.R2O.GT.3.0*SR2E
C	Write(6,*)'SCHFT: ',R2A,R2O,GO_ON
      IF(NPRS.NE.1.AND.R2.GT.STOPR.AND.FLOG) THEN
      CALL ESTMTE(R2E,SR2E,PRS,FO,SN,NR,P1)
      DO 10 I=1,NPRS
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,I,0,
     1 R,ATPR(5,I),C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
   10 CONTINUE
      CALL SORT2(ATPR,6,NAT,NPRS,5,ITPR)
	IF(R2.GT.0.4)THEN
	CALL GEOM2(ATPR,NPRS,SR2E)
      CALL SORT2(ATPR,6,NAT,NPRS,5,ITPR)
	ENDIF
C
C  NEVER DELETE MORE THEN PRW OF KNOWN ATOMS
C  UNLESS GEOMETRY CONSIDERATIONS DICTATE OTHERWISE
C
	NPMIN=MIN(NAT,NPRSO+1)
C     NPMIN=MIN(NPRS,NINT(NPRSO+NAT/20.0))
      L=0
C
	DO 30 I=1,NPRS
      IF(ATPR(5,I).LT.0.0001)L=L+1
30    CONTINUE
      R2D=R2-DELR*SR2E
	NPRS=MAX(NPRS-L,NPMIN)
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
	IF(NPRS.EQ.NPMIN)RETURN
      CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,JFAT,P1,0)
      CALL ESTMTE(R2E,SR2E,PRS,FO,SN,NR,0.0)
      IWG=MAX(INT(PRW*NPRS),1)
C	TOBAD=STOPR.LT.0.305.AND.R2-R2E.GT.0.10
	
      IF(R2E-SR2E.LT.R2) THEN
C     DO 11 I=1,NPRS
C     CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,I,0,
C    1 R,ATPR(5,I),C,S,FOBS,VER,ACALC,BCALC,ST,RF)
C  11 CONTINUE
C     CALL SORT2(ATPR,6,NAT,NPRS,5,ITPR)
	Write(6,*)'Nprs,Nprso,Npmin,Iwg: ',Nprs,Nprso,Npmin,Iwg
      WRITE(LO,100)
100   FORMAT(/,' SCHFT: Not all atoms in the model are correct')
C
C  NEVER DELETE MORE THEN PRW OF KNOWN ATOMS
C  UNLESS GEOMETRY CONSIDERATIONS DICTATE OTHERWISE
C
      WRITE(LO,111)
111   FORMAT(/,' SCHFT: List of spurious peaks'//' ',4X,'X',7X,'Y',
     1 7X,'Z',6X,'Mult',5X,'R2',/)
      DO 20 I=1,IWG
      L=NPRS-I+1
      IF(ATPR(5,L).GT.R2D)GOTO 21
      IF(L.EQ.NPMIN)GOTO 21
C
C  DELETE NEXT PEAK
C
      WRITE(LO,102)(ATPR(J,L),J=1,5)
102   FORMAT(' ',5F8.4)
   20 CONTINUE
      L=L-1
   21 NPRS=L
      ENDIF
      ENDIF
C	IF(NPRS.GT.NPRSO.AND.R2.GT.STOPR)THEN
C	NOEX=0
C	ELSE
C	NOEX=NOEX+1
C	IF(NOEX.EQ.8)THEN
C	NOEX=0
C	TOBAD=.TRUE.
C	ELSE
C	NPRS=NPRS+1
C	ENDIF
C	ENDIF
      CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,JFAT,P1,1)
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
	CALL ESTMTE(R2E,SR2E,PRS,FO,SN,NR,0.0)
	TOBAD=(R2.GT.STOPR.AND.((R2-R2E).GT.0.05)).OR.TOBAD
	RETURN
      END
