      SUBROUTINE BLOCK(CORE,IFIRST,MCORE,RCORE,JFIRST,NR,REF,STR,
     1 STREX,W,NREF,NSTR,NSTREX,HAS,NM,MX,NNRM,IP,IBK,IBLOK,
     2 INMBK,ICRI,ICRA,ICRB,NN,MIR,NOTF)
      INTEGER CORE(MCORE)
      INTEGER LOCTO,LOCPO,LOCSR,LOCA,LOCHU,LOCHR
      INTEGER IBKDIM,OPBLOK
      INTEGER REF(NN,NREF),STR(NSTR),STREX(NSTREX),W(2,NSTR),HAS(2,1)
      REAL*4 MAXBLO
      DIMENSION MX(NM,NNRM),RCORE(NR)
C
C  IN- AND OUTPUTPARAMETERS
C
C  IBK  = MAXIMUM DIMENSION OF QUALITY MATRIX
C  IBLOK= NUMBER OF BLOCKS TO BE OPTIMIZED
C  INMBK= NUMBER OF BLOCK FROM WHICH KH-MATRIX IS CONSTRUCTED
C  ICRI,ICRA,ICRB DEFINE CRITERION
C  MIR =1 SIGINIFIES DIFFERENT OPTMISATION IS REQUIRED
C
C  LOCTO= LOCATION TOPO(*)   IN RCORE
C  LOCPO= LOCATION POINT(*)  IN CORE
C  LOCSR= LOCATION SOMRIJ(*) IN RCORE
C  LOCA = LOCATION A(*)      IN CORE
C  LOCHU= LOCATION HULP(*)   IN CORE
C  LOCHR= LOCATION HULPR(*)  IN RCORE
C
      WRITE(IP,*)' '
      IF(NNRM.GT.1) THEN
      WRITE(IP,*)'COMMON MINOR STRATEGY'
      WRITE(IP,*)'CONSTRUCT MATRICES USING QUALITY MATRIX'
      ISTART=0
      ELSE
      WRITE(IP,*)'CONSTRUCT MATRIX USING QUALITY MATRIX'
      ENDIF
      WRITE(IP,*)' '
C
C  TAKE IBK = NSTREX IF IBK > NSTREX
C
      IF (NSTREX.LE.IBK)THEN
      IBKDIM=NSTREX
      ELSE
      IBKDIM=IBK
      ENDIF
      WRITE(IP,11)IBKDIM
   11 FORMAT(' ORDER QUALITY MATRIX=',I6)
C
C  IN THE CASE OF SEVERAL LINKED KH-MATRICES OF ORDER NM
C  TO BE CONCTRUCTED A TOPROW OF NM-1
C  REFLEXIONS IS NEEDED
C  THE OVERALL MATRIX, CONTAINING ALL SUBMATRICES IS OF THE ORDER
C
C  ((1+SQR(1+8*NNRM))/2) *(NM-1)*0.5
C
C  NM IS TEMPORARELY INCREASED TO THE ORDER OF THE OVERALL MATRIX
C
      NMB=NM-1
      NM=INT(((1.+SQRT(1.+8.*NNRM))/2.)*(NMB)*0.5)
C
      WRITE(IP,10)NM
   10 FORMAT(' ORDER OVERALL MATRIX=',I5)
      NGRID=NM/(NMB/2)
C
      CALL RESERV(IFIRST,MCORE,JFIRST,NR,IP,IBKDIM,LOCTO,LOCPO,
     1 LOCSR,LOCA,LOCHU,LOCHR)
      CALL BKGEN(RCORE(LOCTO),IBKDIM,REF,STREX,W,NREF,NSTR,NSTREX,HAS,
     1 IP,ICRI,ICRA,ICRB,ISTART,NN,MIR,NOTF)
      CALL MATTL2(IBKDIM,RCORE(LOCTO),RCORE(LOCSR),IP)
      CALL MATSOR(RCORE(LOCSR),CORE(LOCPO),RCORE(LOCA),IBKDIM,IP)
      CALL SWAPAL(RCORE(LOCSR),IBKDIM,RCORE(LOCTO),CORE(LOCPO),
     1 CORE(LOCHU),RCORE(LOCHR),STREX,W,NSTR,NSTREX)
      CALL MAINTL(RCORE(LOCTO),RCORE(LOCSR),NM,IBKDIM,IP)
      CALL BLOKOP(IBKDIM,RCORE(LOCTO),RCORE(LOCSR),MAXBLO,OPBLOK,
     1 NM,IBLOK,STREX,W,NSTR,NSTREX,IP,ISTART)
      CALL OPWIS(IBKDIM,RCORE(LOCTO),NM,OPBLOK,RCORE(LOCSR),STREX,
     1 W,NSTR,NSTREX,IP,INMBK,ISTART)
C
C  ASSIGN OLD VALUE TO NM (ORDER SUBMATRIX - 1)
C
      NM=NMB
C
      CALL MXFILL(MX,NM,NNRM,STREX,NSTREX,NGRID,IP)
C
C  ASSIGN ORDER OF SUBMATRICES TO NM
C
      NM=NMB+1
      RETURN
      END
