      SUBROUTINE FASLO(AM,BM,PM,QM,IA,N)
C
C  COPIES LOWER TRIANGLE AM,BM TO LOWER TRIANGLE PM,QM IN MODULI AND
C  PHASES. OVERWRITING IS PERMITTED
C
      DIMENSION AM(IA,N),BM(IA,N),PM(IA,N),QM(IA,N)
      PM(1,1)=AM(1,1)
      IF (N.LT.2) GOTO 20
      DO 10 I=2,N
      PM(I,I)=AM(I,I)
      K=I-1
      DO 10 J=1,K
      A=AM(I,J)
      B=BM(I,J)
      PM(I,J)=SQRT(A**2+B**2)
      QM(I,J)=ATAN2(B,A)
   10 CONTINUE
   20 RETURN
      END
