      SUBROUTINE OMRELO(BM,QM,L1,L2,IA,N)
C
C  COPIES LOWER TRIANGLE BM INTO QM
C  CONVERTS FROM L1 TO L2
C  1= RADIANS
C  2= DEGREES
C  3= CYCLES
C  4= MILLICYCLES
C
      DIMENSION BM(IA,N),QM(IA,N),A(4)
C
      DATA A/
     1 1.0
     2 ,57.2957795
     3 ,0.159154943
     4 ,159.154943
     5 /
C
C  RESP: 1, 180/PI, 0.5/PI, 500/PI
C
      V=A(L2)/A(L1)
      DO 10 I=1,N
      DO 10 J=1,I
   10 QM(I,J)=V*BM(I,J)
      RETURN
      END
