      SUBROUTINE OPMATG(MX,NM,NNRM,STR,STREX,REF,NN,HAS,W,NSTR,NSTREX,
     1 NREF,IFIRST,MCORE,CORE,JFIRST,NR,B,IBK,IBLOK,INMBK,ICRI,
     2 ICRA,ICRB,MIR,NOTF)
C
C  PARAMETERS:
C
C  MX(NM,NNRM) = INPUT/OUTPUT = FIRST ROWS (HKL IN PACKED FORM)
C  H, K, L + 128 IN THREE BYTES
C  NM = INPUT = FIRST DECLARED DIMENSION OF MX = DIMENSION KH-MATRIX
C  NNRM = INPUT = NUMBER OF SUBMATRICES
C  STR: MULTAN REFLEXIONS = INPUT = INDEPENDENT STRONG REFLEXIONS
C  NSTR: DIMENSION STR = INPUT = NUMBER OF STRONG REFLEXIONS
C  STREX: ALL SYMMETRY DEPENDENT STRONG REFLEXIONS
C  NSTREX: DIMENSION STREX = INPUT = TOTAL NUMBER OF STRONG REFLEXIONS
C  (TOP ROW QUALITY MATRIX)
C  REF: REFLEXION LIST = INPUT = COMPLETE REFLEXION FILE
C  NREF: DIMENSION OF REF = INPUT = NUMBER OF REFLEXIONS
C  HAS: = INPUT = HASH TABLE
C  MCORE: MAXIMUM AVAILABLE CORE (INTEGER)
C  NR: MAXIMUM AVAILABLE CORE (REAL)
C  LO: PRINTER
C  MIR = INPUT = 1: DIFFERENT OPTIMISATION USED BECAUSE MIR PHASES
C                   PLUS WEIGHTS ARE PUT IN
C
      INTEGER CORE(MCORE),HMAX
      INTEGER REF(NN,NREF),HAS(2,1)
      INTEGER STR(NSTR),STREX(NSTREX),W(2,NSTR)
      DIMENSION MX(NM,NNRM),B(NR)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
C
C  LOCATE STRONG REFLEXIONS
C
      DO 2222 I=1,NSTR
2222  W(2,I)=STR(I)
C
      CALL FINHAS(HAS,W,NSTR,W,ITEL,0)
C
      DO 220 I=1,NSTR
C
C  LOCATION IN REF
C
      ILOC=W(2,I)
      IF(ILOC.NE.0) GOTO 220
      WRITE(LO,214)
      CALL PRIHKL(STR(I),1,LO)
      CALL STRACE
      STOP
  214 FORMAT(' OPMATG: REFLEXION NOT IN HASHTABLE'
     1 /,' FATAL ERROR')
  220 CONTINUE
C
      IP=LO
C
      CALL BLOCK(CORE,IFIRST,MCORE,B,JFIRST,NR,REF,STR,STREX,W,
     1 NREF,NSTR,NSTREX,HAS,NM,MX,NNRM,IP,IBK,IBLOK,INMBK,ICRI,
     2 ICRA,ICRB,NN,MIR,NOTF)
C
      RETURN
      END
