      SUBROUTINE OPTHAS(A,IA,N,W,IW,ITAPE,ITEL,ITELM,IT,IFAIL)
      INTEGER A,W,HMAX
      DIMENSION A(2,IA),W(2,IW)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
C
C  OPTIMIZE HASHTABLE
C  IT = INPUT = NUMBER OF ITERATIONS
C  IFAIL=0: A CONTAINS HASHTABLE
C  IFAIL=1: TRY OTHER VALUES FOR IHAS, NHAS OR IT
C  N = INPUT = NUMBER OF REFLEXIONS ON ITAPE
C  ITAPE MUST HAVE BLOCKS OF LENGTH IW (MULTAN FILE)
C  W: SCRATCH ARRAY
C  ITELM = INPUT = MAXIMUM ALLOWED NUMBER OF CHECKS IN HASHTABLE BEFORE
C  HIT; DEFAULT IS THEORETICAL VALUE
C  ITEL ACTUAL NUMBER OF CHECKS
C  ITEL>ITELM FOR ALL ITERATIONS: IFAIL=1
C  IA = INPUT = MAXIMUM DIMENSION OF A
C  IT=1: NO OPTIMIZATION
C
C  CALCULATE DEFAULTS
C
      IF(IHAS.EQ.0) IHAS=123456789
      IF(NHAS.EQ.0) NHAS=1.3*N+1
C
C  CHECK DIMENSION OF A
C
      IF(NHAS.GT.IA) GOTO 998
      NHASM=NHAS
      MITEL=ITELM
      MMITEL=ITELM
      MINI=1000*NHAS
      IFAIL=1
      DO 100 I=1,IT
C
C  DEFAULT ITELM
C
      IF(ITELM.EQ.0) MITEL=(1+1.0/(1.0-FLOAT(N)/FLOAT(NHAS)))*N+1
      CALL STOHAS(A,N,W,IW,ITAPE,ITEL,MITEL,IFA)
C     WRITE(LO,3) NHAS,ITEL,ITELM,IFA
      IF(IFA.EQ.0) IFAIL=0
      IF(MINI.LE.ITEL) GOTO 50
      NHASM=NHAS
      MINI=ITEL
      IF(ITELM.EQ.0) MMITEL=MITEL
    3 FORMAT(20H NHAS ITEL ITELM IFA,4I10)
   50 NHAS=NHAS-1
  100 CONTINUE
C
C  STORE HASH TABLE
C
      IF (NHAS.EQ.NHASM) GOTO 200
      NHAS=NHASM
      CALL STOHAS(A,N,W,IW,ITAPE,ITEL,MMITEL,IFA)
C
C  PRINT RESULT
C  CALCULATE NUMBER OF PROBES/REFLEXION
C  THEORY
C
  200 CONTINUE
      X=(1.0+1.0/(1.0-FLOAT(N)/FLOAT(NHAS)))/2.0
C
C  ACTUAL
C
      Y=FLOAT(ITEL)/FLOAT(N)
      WRITE(LO,2) N,IHAS,NHAS,X,Y
    2 FORMAT(' OPTHAS: HASHTABLE COMPLETE FOR',I7,' REFLEXIONS',/,
     1 ' HASH CONSTANTS:',/
     2 ' IHAS=',I10,' NHAS=',I10,/,
     3 ' AVERAGE NUMBER OF PROBES/REFL:',/,
     4 ' THEORETICAL:',F10.4,' ACTUAL:',F10.4)
      IF(IFA.EQ.0) GOTO 999
      WRITE (LO,1)
    1 FORMAT(' OPTHAS : UNSUCCESSFUL RUN')
  998 WRITE(LO,4) IA,NHAS
    4 FORMAT(' OPTHAS : DIMENSION OF A TO SMALL : IA,NHAS=',2I10)
      STOP
  999 CONTINUE
      RETURN
      END
