      SUBROUTINE PRMX2(MX,NM,NNRM,EMX,PMX,NHKLF)
C
C  PARAMETERS:
C
C  MX(NM,NNRM) = INPUT = FIRST ROW OF MATRICES
C  H, K, L + 128 IN BYTE 2, 3, 4
C  NM = INPUT = FIRST DECLARED DIMENSION OF MX
C  NNRM = INPUT = NUMBER OF MATRICES
C  EMX(NM,NM,NNRM) = INPUT = E-VALUES, ONLY LOWER TRIANGLE REQUIRED
C  PMX(NM,NM,NNRM) = INPUT = INPUT PHASES
C
      INTEGER HMAX
      DIMENSION LINE(30)
      DIMENSION MX(NM,NNRM)
      DIMENSION EMX(NM,NM,NNRM),PMX(NM,NM,NNRM)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
      M128=8421504
      PIR=3.14159265/180
C
C  LOOP OVER THE MATRICES
C
      DO 300 MA=1,NNRM
      WRITE(LO,301) MA,NM
  301 FORMAT(/,' MATRIX NUMBER',I5,' OF ORDER',I5)
C
C  LOOP OVER ROWS
C
      DO 200 I=1,NM
      IEI=0
   30 CONTINUE
      IF(IEI.EQ.NM) GOTO 200
      IBE=IEI+1
      IEI=MIN0(NM,IBE+4)
      K=1
      DO 100 J=IBE,IEI
      IH=M128+MX(J,MA)-MX(I,MA)
      CALL UNPK1(IH,LINE(K),LINE(K+1),LINE(K+2))
      K=K+3
  100 CONTINUE
      K=K-1
      WRITE(LO,1) I,(LINE(J),J=1,K)
      K=0
C
C  THE E-VALUES
C
      DO 150 J=IBE,IEI
      K=K+1
      IF(J.GT.I) GOTO 120
      LINE(K)=100*EMX(I,J,MA)+SIGN(0.5,EMX(I,J,MA))
      GOTO 150
  120 LINE(K)=100*EMX(J,I,MA)+SIGN(0.5,EMX(J,I,MA))
  150 CONTINUE
      WRITE(LO,2) (LINE(J),J=1,K)
C
C  The Phases
C
      IF(NHKLF.EQ.1)THEN
      K=0
      DO 151 J=IBE,IEI
      K=K+1
      IF(J.GT.I) GOTO 121
      LINE(K)=AMOD(PMX(I,J,MA)/pir,360.0)+SIGN(0.5,PMX(I,J,MA))
      GOTO 151
  121 LINE(K)=-AMOD(PMX(J,I,MA)/pir,360.0)+SIGN(0.5,PMX(J,I,MA))
  151 CONTINUE
      WRITE(LO,2) (LINE(J),J=1,K)
      ENDIF
      GOTO 30
  200 CONTINUE
  300 CONTINUE
      RETURN
    1 FORMAT(1H ,I3,1H),5(2X,3I3))
    2 FORMAT(' ',10X,5(I5,6X))
      END
