      SUBROUTINE RSTRC(A,MK)
      INTEGER A,HMAX
      DIMENSION KHL(4),IND(3)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
C
C  TAKEN FROM SUBROUTINE GROUP (MULTAN)
C  FINDS PHASE RESTRICTION OF REFLEXION IN A (BYTE 2, 3, 4)
C  MK=0: FORBIDDEN REFLEXION
C  MK=1: NO RESTRICTION
C  ELSE PHASE=12*(MK-1)+PI
C
C  UNPACK HKL
C
      CALL UNPK1(A,IND(1),IND(2),IND(3))
C
C  FORBIDDEN REFL?
C
      GOTO (10,20,30,40,50,60,70),LATT
   10 CONTINUE
C
C  PRIMITIVE LATTICE
C
      GOTO 1000
   20 CONTINUE
C
C  A-LATTICE
C
      IF(MOD(IND(2)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   30 CONTINUE
C
C  B-LATTICE
C
      IF(MOD(IND(1)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   40 CONTINUE
C
C  C-LATTICE
C
      IF(MOD(IND(1)+IND(2),2).NE.0) GOTO 2000
      GOTO 1000
   50 CONTINUE
C
C  I-LATTICE
C
      IF(MOD(IND(1)+IND(2)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   60 CONTINUE
C
C  F-LATTICE
C
      K=MOD(IND(1),2)
      IF(K.NE.MOD(IND(2),2)) GOTO 2000
      IF(K.NE.MOD(IND(3),2)) GOTO 2000
      GOTO 1000
   70 CONTINUE
C
C  R-LATTICE
C
      IF(MOD(IND(2)+IND(3)-IND(1),3).NE.0) GOTO 2000
 1000 CONTINUE
      DO 1180 J=1,NSYM
      DO 1080 K=1,4
      KHL(K)=0
 1080 CONTINUE
      DO 1140 K=1,3
      KHL(4)=KHL(4)+IND(K)*IFIX(TS(K,J)*24.0+0.01)
      DO 1120 L=1,2
      M=IABS(IS(L,K,J))
      IF(M.NE.0) KHL(M)=KHL(M)+IND(K)*ISIGN(1,IS(L,K,J))
 1120 CONTINUE
 1140 CONTINUE
      DO 1160 K=1,3
      IF(IND(K)-KHL(K)) 1180,1160,1180
 1160 CONTINUE
      IF(MOD(KHL(4),24).NE.0) GOTO 2000
 1180 CONTINUE
      GOTO 2900
 2000 CONTINUE
      MK=0
      GOTO 9001
 2900 CONTINUE
      IF(ICENT.NE.0) GOTO 9000
      MK=1
      DO 2180 J=1,NSYM
      DO 2080 K=1,4
      KHL(K)=0
 2080 CONTINUE
      DO 2140 K=1,3
      KHL(4)=KHL(4)+IND(K)*IFIX(TS(K,J)*12.0+0.1)
      DO 2120 L=1,2
      M=IABS(IS(L,K,J))
      IF(M.NE.0) KHL(M)=KHL(M)+IND(K)*ISIGN(1,IS(L,K,J))
 2120 CONTINUE
 2140 CONTINUE
      DO 2160 K=1,3
      IF(IND(K)+KHL(K)) 2180,2160,2180
 2160 CONTINUE
      MK=MOD(KHL(4),12)+1
      IF(MK.LE.1) MK=MK+12
      GOTO 2200
 2180 CONTINUE
 2200 CONTINUE
      GOTO 9001
 9000 MK=13
 9001 RETURN
      END
