      SUBROUTINE STOHAS(A,N,W,IW,ITAPE,ITEL,ITELM,IFAIL)
C
C  CREATES ORDERED HASHTABLE
C  REF: SCIENTIFIC AMERICAN APRIL 1977
C  INPUT FILE ITAPE MUST CONTAIN BLOCKS OF IW REFLEXIONS
C  THE HASHFUNCTION IS MOD(IHAS*IX,NHAS)+1
C  IX CONTAINS H, K, L + 128 IN BYTE 2, 3, 4
C
      INTEGER A(2,1),W(2,IW),HMAX
      INTEGER AJ1,WI1
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
      REWIND ITAPE
C
C  INITIALIZE A
C
      DO 1 I=1,NHAS
      DO 1 J=1,2
    1 A(J,I)=0
      ITEL=0
C
C  NN NUMBER OF REFLEXIONS STORED
C
      NN=0
    5 CONTINUE
C
C  READ BLOCK OF REFLEXIONS
C
      IF(NN.GE.N) GOTO 200
      READ(ITAPE) W
      DO 100 I=1,IW
C
C  KEEP COUNT
C
      NN=NN+1
      IF(NN.GT.N) GOTO 200
      ITEL=ITEL+1
      IF(ITEL.GT.ITELM) GOTO 300
C
C  REFLEXION TO BE STORED
C
C  GET HKL
C
      WI1=W(2,I)
C
C  HASHFUNCTION
C
      J=MOD(IABS(WI1*IHAS),NHAS)+1
   10 CONTINUE
C
C  GET HKL OF A(J)
C
      AJ1=A(1,J)
C
C  STORE WI IF WI1SAJ1
C
      IF(AJ1-WI1) 40,100,50
   40 CONTINUE
C
C  WI1>AJ1 : EXCHANGE WI AND A(J)
C
      ITEMP=A(1,J)
      A(1,J)=WI1
      WI1=ITEMP
      ITEMP=A(2,J)
      A(2,J)=W(1,I)
      W(1,I)=ITEMP
   50 CONTINUE
C
C  IF WI1=0 LOCATION JH FREE: READY
C
      IF(WI1.EQ.0) GOTO 100
C
C  IF NOT STORE WI ONE FURTHER DOWN
C
      ITEL=ITEL+1
      IF(ITEL.GT.ITELM) GOTO 300
      J=J-1
      IF(J.EQ.0) J=NHAS
      GOTO 10
  100 CONTINUE
      GOTO 5
  200 CONTINUE
C
C  SUCCESS AT LAST
C
      IFAIL=0
      GOTO 999
  300 CONTINUE
C
C  EFFICIENCY TO LOW
C
      IFAIL=1
  999 CONTINUE
      RETURN
      END
