C**** *************************** EXFFT ***********************82/10/02*00010010
C**** FAST FOURIER TRANSFORM PROGRAM   -    JANUARY  1980               00020003
C**** MODIFICATION OF PROGRAM BY L. F. TEN EYCK                         00030003
C**** ------------------------------------------------------------------00040003
C**** READ OUTPUT TAPE FROM MULTAN AND EXPAND DATA TO SPACE GROUP P1    00050003
C**** BEFORE CALLING FOURIER TRANSFORM ROUTINES                         00060003
      COMMON X(30000)                                                   00070001
      COMMON /REFL/ IH(100),G(2,100)                                    00080001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             00090001
      COMMON/CONST/NEX,KUSER1,DTOR,LC,LIN,NP(3)                         00100000
      COMMON /TRAN/ SCALE,ITLE(20),MH(3),LEVEL,IT4,XLIM(3)              00110001
      COMMON/TAPE/NOSET,PARA(6),NSYM,NCENT,LATT,NPIC,TS(3,24),IS(2,3,24)
     1 ,DDUM(173)
C     CALL ERRSET(214,256,-1,1)  Niet nodig op MicroVax                 00130015
      WRITE(6,4000)                                                     00140000
 4000 FORMAT('1',30X,                                                   00150014
     *'***   E X F F T 8 0   PROGRAM FOR FAST FOURIER    ***'//,        00160018
     *37X,'AUTHOR     : P.MAIN,ET AL. ,YORK,UNITED KINGDOM'//,          00170018
     *37X,'DATE       : APRIL 1, 1986 - LAST UPDATE'//,                 00180019
     *37X,'INQUIRIES  : S.GORTER & R. A. G. DE GRAAFF'//,               00190018
     *' ',33('****'),//)                                                00200014
C**** PRELIMINARY SECTION        DEFINE ALL NECESSARY PROGRAM PARAMETERS00210003
C**** SET LOGICAL NUMBERS FOR PERIPHERALS                               00220003
C**** LC = CARD READER                                                  00230003
      LC = 1                                                            00240001
C     CALL INPUT(5,LC,2,1000)   Niet nodig op MicroVax!                 00250001
C     CALL MSSGE(12)            Niet nodig op MicroVax!                 00260019
C**** LSCRA = FFT SCRATCH TAPE                                          00270003
      LSCRA = 8                                                         00280000
C**** LT = LINE PRINTER                                                 00290003
      LT = 6                                                            00300001
C**** LIN = INPUT FILE FROM MULTAN                                      00310003
      LIN = 10                                                          00320001
C**** LO = FILE OF EXPANDED DATA ( MAY BE THE SAME AS LMAP )            00330003
      LO = 13                                                           00340001
C**** LMAP = OUTPUT FILE FOR INTERPRETATION                             00350003
      LMAP = 13                                                         00360001
C**** DEFINE CONSTANTS                                                  00370003
C**** KUSER1 = DIMENSION OF ARRAYS IHKL,E,IPHAZ,EP = MAXIMUM NUMBER     00380003
C**** OF INDEPENDENT REFLECTIONS WHICH CAN BE INPUT  (KUSER1 .GE. NUMB) 00390003
C**** DIMENSION OF X = 3 * KUSER1                                       00400003
      KUSER1 = 10000                                                    00410001
      NSIZE = 3 * KUSER1 - 1                                            00420001
      DTOR = ATAN(1.0) / 45.0                                           00430001
      TWOPI = 360.0 * DTOR                                              00440001
      CALL EXPAND                                                       00450001
      CALL PP1(X,NSIZE,NP(1),NP(2),NP(3))                               00460001
      WRITE(6,4001)                                                     00470002
 4001 FORMAT(//,' ',11('****'),'**     E N D    O F    P R O G R A M    00480018
     * **',11('****'))                                                  00490018
      STOP                                                              00500001
      END                                                               00510000
C**** ----------------------------------------------------------------  00520003
C**** MAKE NULL TAPE FOR SEARCH                                         00530003
      SUBROUTINE ERROR                                                  00540001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             00550001
      I = 0                                                             00560001
      NDIFF = -1                                                        00570001
      WRITE (LMAP) (I,J=1,20),NDIFF,(I,J=1,9)                           00580001
      WRITE(6,4001)                                                     00590001
 4001 FORMAT(//,' ',11('****'),'**     E N D    O F    P R O G R A M    00600018
     * **',11('****'))                                                  00610018
      STOP                                                              00620002
      END                                                               00630001
C**** ------------------------------------------------------------------00640003
C**** GENERATE COMPLETE HEMISPHERE OF REFLEXION DATA                    00650003
      SUBROUTINE EXPAND                                                 00660001
      DIMENSION CFOM(2250),EP(7000),I1(3),I2(3),KIND(24),TAB(15)        00670001
      DIMENSION LH(60),LK(60),LL(60),EW(60),ED(60)                      00680001
      DIMENSION N(80),ICH(7),KX(10)                                     00690001
      COMMON IHKL(7000),E(7000),IPHAZ(7000)                             00700001
      COMMON /REFL/ IH(100),G(2,100)                                    00710001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             00720001
      COMMON/CONST/NEX,KUSER1,DTOR,LC,LIN,NP(3)                         00730001
      COMMON /TRAN/ SCALE,ITLE(20),MH(3),LEVEL,IT4,XLIM(3)              00740000
      COMMON/TAPE/NOSET,PARA(6),NSYM,NCENT,LATT,NPIC,TS(3,24),IS(2,3,24)
     1 ,DDUM(173)
      EQUIVALENCE (IPHAZ(1),EP(1),CFOM(1))                              00760001
      EQUIVALENCE (IH(1),LH(1)),(IH(61),LK(1)),(G(1,11),LL(1)),         00770001
     1  (G(1,41),EW(1)),(G(1,71),ED(1))                                 00780001
      DATA ICH/1HS,1HL,1HG,1HX,1HY,1HZ,1HM/, KD/1H./, KSP/1H /          00790001
      DATA KX/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9/                  00800001
C**** READ IN PROGRAM PARAMETERS AND DATA                               00810003
      IDIV = 1                                                          00820000
      IND=0                                                             00830001
      IB=-1                                                             00840001
      IT4=0                                                             00850001
      NOSET=0                                                           00860001
      FACTOR=1.0/3.0                                                    00870001
      LEVEL=100                                                         00880001
      XLIM(1)=1.0                                                       00890001
      XLIM(2)=1.0                                                       00900001
      XLIM(3)=1.0                                                       00910001
      READ(LC,10) N                                                     00920000
   10 FORMAT(80A1)                                                      00930001
      DO 100 I=1,80                                                     00940001
      DO 15 K=1,7                                                       00950001
      IF(IND.EQ.0.AND.ICH(K).EQ.N(I)) GO TO 90                          00960001
   15 CONTINUE                                                          00970001
      IF(IND.EQ.0) GO TO 100                                            00980001
      DO 20 K=1,10                                                      00990001
      IF(KX(K).NE.N(I)) GO TO 20                                        01000001
      IB = MAX0(IB,0)                                                   01010001
      IB=10*IB+K-1                                                      01020000
      IF (IDIV.LE.0) IDIV = IDIV - 1                                    01030001
      GO TO 100                                                         01040001
   20 CONTINUE                                                          01050001
      IF (N(I).EQ.KD) IDIV = 0                                          01060001
      IF (N(I).NE.KSP.OR.IB.EQ.-1) GOTO 100                             01070001
      IDIV = MIN0(IDIV,0)                                               01080001
      GO TO (30,40,50,60,70,80),IND                                     01090001
C**** NOSET                                                             01100003
   30 NOSET=IB                                                          01110001
      GO TO 85                                                          01120000
C**** LEVEL                                                             01130003
   40 LEVEL=IB                                                          01140001
      GO TO 85                                                          01150001
C**** GRID                                                              01160003
   50 FACTOR=FLOAT(IB)*10.0**IDIV                                       01170001
      GO TO 85                                                          01180001
C**** XLIM                                                              01190003
   60 XLIM(1)=AMIN1(FLOAT(IB)*10.0**IDIV,1.0)                           01200001
      GO TO 85                                                          01210001
C**** YLIM                                                              01220003
   70 XLIM(2)=AMIN1(FLOAT(IB)*10.0**IDIV,1.0)                           01230001
      GO TO 85                                                          01240001
C**** ZLIM                                                              01250003
   80 XLIM(3)=AMIN1(FLOAT(IB)*10.0**IDIV,1.0)                           01260001
   85 IB=-1                                                             01270001
      IND=0                                                             01280001
      IDIV = 1                                                          01290001
      GO TO 100                                                         01300001
   90 IND=K                                                             01310001
C**** MAP                                                               01320003
      IF(K.EQ.7) IT4=LT                                                 01330001
      IF(K.EQ.7) GO TO 85                                               01340001
  100 CONTINUE                                                          01350001
      REWIND LIN                                                        01360001
      READ(LIN) NDIFF                                                   01370001
      IF(NDIFF.EQ.0) READ (LIN) ITLE, NCENT, LATT, NSYM,                01380001
     1  ((TS(I,J),(IS(K,I,J),K=1,2),I=1,3),J=1,NSYM),                   01390001
     2 MH, PARA, NPIC, NUMB                                             01400023
      IF(NDIFF.EQ.0)READ (LIN)(IHKL(I),I=1,NUMB)                        01401025
      IF(NDIFF.EQ.0)READ (LIN)(E(I),I=1,NUMB)                           01402025
      IF(NDIFF.EQ.1) READ(LIN) ITLE,NCENT,LATT,NSYM,((TS(I,J),(IS(K,I,J)01410001
     1  ,K=1,2),I=1,3),J=1,NSYM),MH,PARA,NPIC                           01420000
C**** CHECK FOR NULL TAPE                                               01430003
      IF (NDIFF.EQ.(-1)) CALL ERROR                                     01440001
      WRITE (LT,110) ITLE                                               01450001
  110 FORMAT(23H1FAST FOURIER TRANSFORM,74X,20HVERSION   JAN   1980     01460001
     1 ///20X,20A4//)                                                   01470001
      IF(NDIFF.EQ.0) GO TO 145                                          01480001
C**** READ FILE PREPARED BY NORMAL FOR WEIGHTED OR DIFFERENCE FOURIER   01490003
      NUMB=0                                                            01500001
  115 READ(LIN) LH,LK,LL,EW,ED                                          01510001
      DO 120 I=1,60                                                     01520000
      IF(LH(I).LT.(-999)) GO TO 200                                     01530001
      NUMB=NUMB+1                                                       01540001
      ISC=1                                                             01550001
      IF(LH(I).LT.0) ISC=-1                                             01560001
      IHKL(NUMB)=ISC*(LH(I)*262144+LK(I)*512+LL(I))+256*(512+1)         01570001
      MH(1)=MAX0(MH(1),IABS(LH(I)))                                     01580001
      MH(2)=MAX0(MH(2),IABS(LK(I)))                                     01590001
      MH(3)=MAX0(MH(3),IABS(LL(I)))                                     01600001
      E(NUMB)=EW(I)                                                     01610001
      EP(NUMB)=FLOAT(ISC)*ED(I)                                         01620000
      IF(NUMB.EQ.KUSER1) GO TO 130                                      01630001
  120 CONTINUE                                                          01640001
      GO TO 115                                                         01650001
  130 WRITE(LT,140) KUSER1                                              01660001
  140 FORMAT(1H0,44X,5HFIRST,I6,19HREFLEXIONS ACCEPTED)                 01670001
      GO TO 200                                                         01680001
C**** EXAMINE SETS OF PHASES IN ORDER OF COMBINED FIGURE OF MERIT UNLESS01690003
C**** SET IS SPECIFIED BY THE USER                                      01700003
  145 IF(NOSET.GT.0) GOTO 170                                           01710001
  150 READ (LIN) NIX                                                    01720001
      IF (NIX .GE. 0)THEN      
      READ(LIN)                                                         01730001
      READ(LIN)
      GOTO 150
      ELSE
      ENDIF
      READ(LIN)NSET,(CFOM(J),J=1,NSET)                                  01740013
      NPOS = 1                                                          01750001
      DO 160 J=1,NSET                                                   01760001
      IF(CFOM(J).GT.CFOM(NPOS))NPOS=J                                   01770013
  160 CONTINUE                                                          01780001
C**** MARK SELECTED SET                                                 01790003
      CFOM(NPOS)=CFOM(NPOS)-100.0                                       01800013
      BACKSPACE LIN                                                     01810001
      WRITE (LIN) NSET, (CFOM(J), J=1,NSET)                             01820001
C**** READ TO FIND SELECTED SET                                         01830003
  170 REWIND LIN                                                        01840001
      READ (LIN)                                                        01850001
      READ (LIN)                                                        01860001
      READ (LIN)                                                        01861022
      READ (LIN)                                                        01862022
      NCS = 0                                                           01870001
C**** EP WILL CONTAIN WEIGHTS                                           01880003
  180 READ (LIN) NO, ABSFOM, PSIZRO, RESID                              01890022
      READ (LIN)                                                        01891022
      READ (LIN)(EP(I),I=1,NUMB)                                        01892022
      NCS = NCS+1                                                       01900000
      IF(NOSET.EQ.0.AND.NCS.NE.NPOS) GOTO 180                           01910001
      IF(NOSET.NE.0.AND.NOSET.NE.NO) GOTO 180                           01920001
      NOSET = NO                                                        01930001
      NPOS=NOSET                                                        01931026
      DO 185 I=1,NUMB                                                   01940001
      E(I)=E(I)*EP(I)                                                   01950001
  185 CONTINUE                                                          01960001
      REWIND LIN                                                        01970005
      READ (LIN)                                                        01980004
      READ (LIN)                                                        01990004
      READ (LIN)                                                        01991022
      READ (LIN)                                                        01992022
      DO 186 II=1,NPOS                                                  02000011
      READ(LIN) NO,ABSFOM,PSIZRO,RESID                                  02010022
      READ(LIN)(IPHAZ(I),I=1,NUMB)                                      02011022
      READ(LIN)                                                         02012022
  186 CONTINUE                                                          02020010
      WRITE (LT,190) NO,ABSFOM,PSIZRO,RESID                             02030001
  190 FORMAT (32X,6HNUMSET,7X,7HABS FOM,11X,8HPSI ZERO,11X,5HRESID/     02040000
     1  28X,I8,F16.4,F18.2,F17.2)                                       02050001
      DO 192 I=1,NUMB                                                   02060001
      PHASE=DTOR*FLOAT(IPHAZ(I))                                        02070001
      EP(I)=E(I)*SIN(PHASE)                                             02080001
      E(I)=E(I)*COS(PHASE)                                              02090001
  192 CONTINUE                                                          02100001
C**** SET DEFAULT VALUES OF PROGRAM PARAMETERS UNLESS SPECIFIED BY USER 02110003
C**** CALCULATE NUMBER OF GRID POINTS FOR FOURIER MAP                   02120003
  200 DO 280 I=1,3                                                      02130001
      NP(I)=PARA(I)/FACTOR+0.5                                          02140001
      IF(I.EQ.3) NP(I)=NP(I)+MOD(NP(I),2)                               02150001
  250 NTEST=NP(I)                                                       02160001
      DO 270 J=2,5                                                      02170001
  260 IF(NTEST.NE.(NTEST/J)*J) GO TO 270                                02180001
      NTEST=NTEST/J                                                     02190001
      IF(NTEST.EQ.1) GO TO 280                                          02200000
      GO TO 260                                                         02210001
  270 CONTINUE                                                          02220001
      NP(I)=NP(I)+1                                                     02230001
      IF(I.EQ.3) NP(I)=NP(I)+1                                          02240001
      GO TO 250                                                         02250001
  280 CONTINUE                                                          02260001
      WRITE(LT,290) FACTOR                                              02270001
  290 FORMAT(1H0,38X,30HGRID SPACING IS APPROXIMATELY ,F6.3,2X,         02280001
     1 9HANGSTROMS)                                                     02290001
      WRITE (LT,300) PARA,MH,NP                                         02300000
  300 FORMAT (///49X,1HA,9X,1HB,9X,1HC,7X,5HALPHA,5X,4HBETA,4X,5HGAMMA/ 02310001
     1  22X,20HUNIT CELL PARAMETERS,3F10.3,1X,3F9.1//49X,1HH,9X,1HK,9X, 02320001
     2  1HL/24X,16HMAXIMUM INDICES ,3I10//21X,21HNUMBER OF GRID POINTS, 02330001
     3  6X,2HNX,8X,2HNY,8X,2HNZ/25X,15HIN FOURIER MAP ,3I10)            02340001
      IF (NP(1) .LE. 350) GO TO 400                                     02350001
      WRITE (LT,320)                                                    02360001
  320 FORMAT (1H0,22X,76HNX GREATER THAN 350. INCREASE ARRAY INUT IN SUB02370001
     1ROUTINE OUTPUT OF FFT PROGRAM)                                    02380001
      CALL ERROR                                                        02390001
  400 IF (IT4 .LE. 0) WRITE (LT,405)                                    02400000
  405 FORMAT (///45X,29HFOURIER MAP NOT TO BE PRINTED)                  02410001
      IF (IT4 .GT. 0) WRITE (LT,410) XLIM,LEVEL                         02420001
  410 FORMAT (///13X,43HFOURIER MAP TO BE PRINTED FROM X =  0.0  TO,    02430001
     1  F7.3, 15H,  Y =  0.0  TO, F7.3, 15H,  Z =  0.0  TO, F7.3/       02440001
     1 1H0,40X,33HPOINTS UNDERLINED IF GREATER THAN,I5)                 02450001
      REWIND LO                                                         02460001
      WRITE (LT,460) NUMB                                               02470001
  460 FORMAT (///36X,41HNUMBER OF INDEPENDENT REFLECTIONS INPUT =, I7)  02480001
C**** GENERATE ONE COMPLETE HEMISPHERE OF REFLEXIONS                    02490003
      DO 470 I=1,15                                                     02500001
      TAB(I)=SIN(FLOAT(30*I)*DTOR)                                      02510001
  470 CONTINUE                                                          02520001
      NEX = 0                                                           02530001
      FSUM=0.0                                                          02540001
      IP5=256*(262144+512+1)                                            02550001
      NBATCH=0                                                          02560001
      DO 800 JN=1,NUMB                                                  02570001
      I1(1)=IHKL(JN)/262144                                             02580000
      J=IHKL(JN)-262144*I1(1)                                           02590001
      I1(2)=J/512-256                                                   02600001
      I1(3)=J-512*(I1(2)+256)-256                                       02610001
      DO 700 J=1,NSYM                                                   02620001
      DO 540 I=1,3                                                      02630001
  540 I2(I)=0                                                           02640001
      DO 560 I=1,3                                                      02650001
      DO 550 K=1,2                                                      02660001
      M=IABS(IS(K,I,J))                                                 02670001
      IF(M.NE.0) I2(M)=I2(M)+I1(I)*ISIGN(1,IS(K,I,J))                   02680000
  550 CONTINUE                                                          02690001
  560 CONTINUE                                                          02700001
      B1=1.0                                                            02710001
      JS=1                                                              02720001
      IF(I2(3)) 590,570,600                                             02730001
  570 IF(I2(1)) 590,580,600                                             02740001
  580 IF(I2(2)) 590,600,600                                             02750001
  590 B1=-1.0                                                           02760001
      JS=-1                                                             02770001
  600 KIND(J)=IP5+JS*(262144*I2(1)+512*I2(2)+I2(3))                     02780000
      DO 610 I=1,3                                                      02790001
      IF(IABS(I2(I)).GE.NP(I)/2) GO TO 700                              02800001
      IF(I2(I).GT.MH(I)) MH(I)=I2(I)                                    02810001
  610 CONTINUE                                                          02820001
      IF(J.EQ.1) GO TO 630                                              02830001
      ND=J-1                                                            02840001
      DO 620 I=1,ND                                                     02850001
      IF(KIND(J).EQ.KIND(I)) GO TO 700                                  02860001
  620 CONTINUE                                                          02870001
  630 NBATCH=NBATCH+1                                                   02880000
      NEX=NEX+1                                                         02890001
      NU=0                                                              02900001
      DO 640 I=1,3                                                      02910001
  640 NU=NU-I1(I)*INT(TS(I,J)*12.0+0.1)                                 02920001
      NU=MOD(NU,12)                                                     02930001
      IF(NU.LE.0) NU=NU+12                                              02940001
      XC=TAB(NU+3)                                                      02950001
      XS=TAB(NU)                                                        02960001
      GR=XC*E(JN)-XS*EP(JN)                                             02970001
      GI=(XS*E(JN)+XC*EP(JN))*B1                                        02980000
      FSUM=FSUM+SQRT(GR*GR+GI*GI)                                       02990001
      G(1,NBATCH)=GR                                                    03000001
      G(2,NBATCH)=GI                                                    03010001
      IH(NBATCH)=KIND(J)                                                03020001
      IF(NBATCH.LT.100) GO TO 700                                       03030001
      WRITE(LO) IH,G                                                    03040001
      NBATCH=0                                                          03050001
  700 CONTINUE                                                          03060001
  800 CONTINUE                                                          03070001
      IF(NBATCH.NE.0) WRITE(LO) IH,G                                    03080000
      SCALE=3000.0/FSUM                                                 03090001
      WRITE(LT,990) NEX,SCALE                                           03100001
  990 FORMAT(/36X,41HNUMBER OF REFLECTIONS IN ONE HEMISPHERE =,I7/      03110001
     1  /1H ,49X,9HSCALE   =,F10.3)                                     03120001
      RETURN                                                            03130001
      END                                                               03140001
C**** ------------------------------------------------------------------03150003
      SUBROUTINE CMPLFT (X, Y, NSIZE, N, D)                             03160001
      REAL X(NSIZE), Y(NSIZE)                                           03170001
      INTEGER D(5),PMAX,PSYM,TWOGRP,FACTOR(15),SYM(15),UNSYM(15)        03180000
C**** COMPLEX FINITE DISCRETE FOURIER TRANSFORM                         03190003
C**** TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA                03200003
C**** MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN 03210003
C**** BY G. T. SANDE, 1969.                                             03220003
C**** THIS PROGRAM CALCULATES THE TRANSFORM                             03230003
C**** (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))                 03240012
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             03250000
      P MAX = 5                                                         03260001
      TWO GRP = 4                                                       03270001
      CALL S R FP (N, P MAX, TWO GRP, FACTOR, SYM, P SYM, UN SYM)       03280001
      CALL MDFTKD (N, FACTOR, D, X, Y, NSIZE)                           03290001
      CALL DIPRP (N, SYM, P SYM, UN SYM, D, X, Y, NSIZE)                03300001
      RETURN                                                            03310001
      END                                                               03320001
C**** ------------------------------------------------------------------03330003
      SUBROUTINE S R FP (PTS,PMAX,TWO GRP,FACTOR,SYM,P SYM,UN SYM)      03340000
C**** SYMMETRIZED REORDERING FACTORING PROGRAM                          03350003
      INTEGER PTS,PMAX,TWO GRP,P SYM, FACTOR (10), SYM (10), UN SYM (10)03360001
      INTEGER PP(14), QQ (7), F,P,P TWO,Q,R                             03370001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             03380001
      NEST=14                                                           03390001
      N=PTS                                                             03400001
      P SYM=1                                                           03410000
      F=2                                                               03420001
      P=0                                                               03430001
      Q=0                                                               03440001
  100 IF (N.LE.1) GO TO 500                                             03450001
      DO 200 J=F,PMAX                                                   03460001
      IF (N.EQ.(N/J)*J) GO TO 300                                       03470001
  200 CONTINUE                                                          03480001
      CALL ERROR                                                        03490001
  300 F=J                                                               03500001
      N=N/F                                                             03510000
      IF (N.EQ.(N/F)*F) GO TO 400                                       03520001
      Q=Q+1                                                             03530001
      QQ(Q)=F                                                           03540001
      GO TO 100                                                         03550001
  400 N=N/F                                                             03560001
      P=P+1                                                             03570001
      PP(P)=F                                                           03580001
      P SYM=P SYM*F                                                     03590001
      GO TO 100                                                         03600001
  500 R=1                                                               03610001
      IF (Q.EQ.0) R=0                                                   03620001
      IF (P.LT.1) GO TO 700                                             03630001
      DO 600 J=1,P                                                      03640001
      JJ=P+1-J                                                          03650001
      SYM(J)=PP(JJ)                                                     03660001
      FACTOR(J)=PP(JJ)                                                  03670001
      JJ=P+Q+J                                                          03680001
      FACTOR(JJ)=PP(J)                                                  03690001
      JJ=P+R+J                                                          03700000
      SYM(JJ)=PP(J)                                                     03710001
  600 CONTINUE                                                          03720001
  700 IF (Q.LT.1) GO TO 900                                             03730001
      DO 800 J=1,Q                                                      03740001
      JJ=P+J                                                            03750001
      UN SYM(J)=QQ(J)                                                   03760001
      FACTOR(JJ)=QQ(J)                                                  03770001
  800 CONTINUE                                                          03780001
      SYM(P+1)=PTS/P SYM**2                                             03790001
  900 JJ=2*P+Q                                                          03800000
      FACTOR(JJ+1)=0                                                    03810001
      P TWO=1                                                           03820001
      J=0                                                               03830001
 1000 J=J+1                                                             03840001
      IF (FACTOR(J).EQ.0) GO TO 1200                                    03850001
      IF (FACTOR(J).NE.2) GO TO 1000                                    03860001
      P TWO=P TWO*2                                                     03870001
      FACTOR(J)=1                                                       03880001
      IF (P TWO.GE.TWO GRP) GO TO 1100                                  03890001
      IF (FACTOR(J+1).EQ.2) GO TO 1000                                  03900000
 1100 FACTOR(J)=P TWO                                                   03910001
      P TWO=1                                                           03920001
      GO TO 1000                                                        03930001
 1200 IF (P.EQ.0) R=0                                                   03940001
      JJ=2*P+R                                                          03950001
      SYM(JJ+1)=0                                                       03960001
      IF (Q.LE.1) Q=0                                                   03970001
      UN SYM(Q+1)=0                                                     03980001
      RETURN                                                            03990001
      END                                                               04000000
C**** ------------------------------------------------------------------04010003
      SUBROUTINE DIPRP (PTS, SYM, P SYM, UN SYM, DIM, X, Y, NSIZE)      04020001
C**** DOUBLE IN PLACE REORDERING PROGRAM                                04030003
      REAL X(NSIZE), Y(NSIZE)                                           04040001
      INTEGER SYM(10), UN SYM(10), DIM(5), PTS, PSYM, DK, P UN SYM, TEST04050001
      LOGICAL ONE MOD                                                   04060001
      INTEGER SEP, DELTA, P, P0, P1, P2, P3, P4, P5, SIZE               04070001
      INTEGER V(14), MODULO(14), S(14), U(14)                           04080001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             04090000
      NEST=14                                                           04100001
      NT = DIM(1)                                                       04110001
      SEP = DIM(2)                                                      04120001
      P2 = DIM(3)                                                       04130001
      SIZE = DIM(4) - 1                                                 04140001
      P4 = DIM(5)                                                       04150001
      IF (SYM(1).EQ.0) GO TO 500                                        04160001
      DO 100 J=1,NEST                                                   04170000
      U(J)=1                                                            04180001
      S(J)=1                                                            04190001
  100 CONTINUE                                                          04200001
      N=PTS                                                             04210001
      DO 200 J=1,NEST                                                   04220001
      IF (SYM(J).EQ.0) GO TO 300                                        04230001
      JJ=NEST+1-J                                                       04240001
      U(JJ)=N                                                           04250001
      N=N/SYM(J)                                                        04260001
      S(JJ)=N                                                           04270000
  200 CONTINUE                                                          04280001
  300 JJ=0                                                              04290001
      L=1                                                               04300001
      V(1)=1                                                            04310001
  310 L=L+1                                                             04320001
      V(L)=V(L-1)                                                       04330001
  320 IF(L.LT.NEST) GO TO 310                                           04340001
      N=V(NEST)                                                         04350001
      JJ=JJ+1                                                           04360001
      IF (JJ.GE.N) GO TO 400                                            04370000
      DELTA = (N-JJ)*SEP                                                04380001
      P1 = (JJ-1)*SEP + 1                                               04390001
      DO 350 P0 = P1, NT, P2                                            04400001
      P3 = P0 + SIZE                                                    04410001
      DO 350 P = P0, P3, P4                                             04420001
      P5 = P + DELTA                                                    04430001
      T = X(P)                                                          04440001
      X(P) = X(P5)                                                      04450001
      X(P5) = T                                                         04460001
      T = Y(P)                                                          04470000
      Y(P) = Y(P5)                                                      04480001
      Y(P5) = T                                                         04490001
  350 CONTINUE                                                          04500001
  400 V(L)=V(L)+S(L)                                                    04510001
      IF(V(L).LE.U(L)) GO TO 320                                        04520001
      L=L-1                                                             04530001
      IF(L.NE.0) GO TO 400                                              04540001
  500 IF (UN SYM(1).EQ.0) GO TO 1900                                    04550001
      P UN SYM=PTS/P SYM**2                                             04560000
      MULT=P UN SYM/UN SYM(1)                                           04570001
      TEST=(UN SYM(1)*UN SYM(2)-1)*MULT*P SYM                           04580001
      LK=MULT                                                           04590001
      DK=MULT                                                           04600001
      DO 600 K=2,NEST                                                   04610001
      IF (UN SYM(K).EQ.0) GO TO 700                                     04620001
      LK=LK*UN SYM(K-1)                                                 04630001
      DK=DK/UN SYM(K)                                                   04640001
      U(K)=(LK-DK)*P SYM                                                04650001
      MODS=K                                                            04660000
  600 CONTINUE                                                          04670001
  700 ONE MOD=MODS.LT.3                                                 04680001
      IF (ONE MOD) GO TO 900                                            04690001
      DO 800 J=3,MODS                                                   04700001
      JJ=MODS+3-J                                                       04710001
      MODULO(JJ)=U(J)                                                   04720001
  800 CONTINUE                                                          04730001
  900 MODULO(2)=U(2)                                                    04740001
      JL=(P UN SYM-3)*P SYM                                             04750001
      MS=P UN SYM*P SYM                                                 04760000
      DO 1800 J=P SYM,JL,P SYM                                          04770001
      K=J                                                               04780001
 1000 K=K*MULT                                                          04790001
      IF (ONE MOD) GO TO 1200                                           04800001
      DO 1100 I=3,MODS                                                  04810001
      K=K-(K/MODULO(I))*MODULO(I)                                       04820001
 1100 CONTINUE                                                          04830001
 1200 IF (K.GE.TEST) GO TO 1300                                         04840000
      K=K-(K/MODULO(2))*MODULO(2)                                       04850001
      GO TO 1400                                                        04860001
 1300 K=K-(K/MODULO(2))*MODULO(2)+MODULO(2)                             04870001
 1400 IF (K.LT.J) GO TO 1000                                            04880001
      IF (K.EQ.J) GO TO 1800                                            04890001
      DELTA = (K-J)*SEP                                                 04900001
      DO 1600 L=1,P SYM                                                 04910001
      DO 1500 M=L,PTS,MS                                                04920001
      P1 = (M+J-1)*SEP + 1                                              04930000
      DO 1500 P0 = P1, NT, P2                                           04940001
      P3 = P0 + SIZE                                                    04950001
      DO 1500 JJ = P0, P3, P4                                           04960001
      KK = JJ + DELTA                                                   04970001
      T=X(JJ)                                                           04980001
      X(JJ)=X(KK)                                                       04990001
      X(KK)=T                                                           05000001
      T=Y(JJ)                                                           05010001
      Y(JJ)=Y(KK)                                                       05020001
      Y(KK)=T                                                           05030000
 1500 CONTINUE                                                          05040001
 1600 CONTINUE                                                          05050001
 1800 CONTINUE                                                          05060001
 1900 RETURN                                                            05070001
      END                                                               05080001
C**** ------------------------------------------------------------------05090003
      SUBROUTINE MDFTKD (N, FACTOR, DIM, X, Y, NSIZE)                   05100001
C**** MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER         05110003
      INTEGER FACTOR(10), DIM(5), F, P, R, S                            05120000
      REAL X(NSIZE), Y(NSIZE)                                           05130001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             05140001
      S = DIM(2)                                                        05150001
      F = 0                                                             05160001
      M = N                                                             05170001
  100 F = F + 1                                                         05180001
      P = FACTOR(F)                                                     05190001
      IF (P.EQ.0) RETURN                                                05200001
      M = M/P                                                           05210000
      R = M*S                                                           05220001
      GO TO (100, 200, 300, 400, 500), P                                05230001
  200 CALL R2 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), DIM)              05240001
      GO TO 100                                                         05250001
  300 CONTINUE                                                          05260001
      CALL R3 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)05270001
     ., DIM)                                                            05280001
      GO TO 100                                                         05290000
  400 CALL R4 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)05300001
     ., X(3*R+1), Y(3*R+1), DIM)                                        05310001
      GO TO 100                                                         05320001
  500 CALL R5 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)05330001
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), DIM)                    05340001
      GO TO 100                                                         05350001
      END                                                               05360000
C**** ------------------------------------------------------------------05370003
      SUBROUTINE R2 CFTK (N, M, X0, Y0, X1, Y1, DIM)                    05380001
C**** RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL        05390003
      INTEGER DIM(5), SIZE, SEP                                         05400001
      REAL X0(10), Y0(10), X1(10), Y1(10), IS, IU                       05410001
      LOGICAL FOLD,ZERO                                                 05420001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             05430001
      NT = DIM(1)                                                       05440000
      SEP = DIM(2)                                                      05450001
      L1 = DIM(3)                                                       05460001
      SIZE = DIM(4) - 1                                                 05470001
      K2 = DIM(5)                                                       05480001
      NS = N*SEP                                                        05490001
      M2=M*2                                                            05500001
      FM2 = FLOAT(M2)                                                   05510001
      M OVER 2=M/2+1                                                    05520001
      MM2 = SEP*M2                                                      05530001
      FJM1 = -1.0                                                       05540001
      DO 600 J=1,M OVER 2                                               05550001
      FOLD=J.GT.1 .AND. 2*J.LT.M+2                                      05560001
      K0 = (J-1)*SEP + 1                                                05570001
      FJM1 = FJM1 + 1.0                                                 05580001
      ANGLE = TWO PI*FJM1/FM2                                           05590001
      ZERO=ANGLE.EQ.0.0                                                 05600001
      IF (ZERO) GO TO 200                                               05610001
      C=COS(ANGLE)                                                      05620001
      S=SIN(ANGLE)                                                      05630000
      GO TO 200                                                         05640001
  100 FOLD=.FALSE.                                                      05650001
      K0 = (M+1-J)*SEP + 1                                              05660001
      C=-C                                                              05670001
  200 DO 500 KK = K0, NS, MM2                                           05680001
      DO 440 L = KK, NT, L1                                             05690001
      K1 = L + SIZE                                                     05700001
      DO 420 K = L, K1, K2                                              05710001
      RS=X0(K)+X1(K)                                                    05720001
      IS=Y0(K)+Y1(K)                                                    05730000
      RU=X0(K)-X1(K)                                                    05740001
      IU=Y0(K)-Y1(K)                                                    05750001
      X0(K)=RS                                                          05760001
      Y0(K)=IS                                                          05770001
      IF (ZERO) GO TO 300                                               05780001
      X1(K)=RU*C+IU*S                                                   05790001
      Y1(K)=IU*C-RU*S                                                   05800001
      GO TO 420                                                         05810001
  300 X1(K)=RU                                                          05820001
      Y1(K)=IU                                                          05830000
  420 CONTINUE                                                          05840001
  440 CONTINUE                                                          05850001
  500 CONTINUE                                                          05860001
      IF (FOLD) GO TO 100                                               05870001
  600 CONTINUE                                                          05880001
      RETURN                                                            05890001
      END                                                               05900001
C**** ------------------------------------------------------------------05910003
      SUBROUTINE R3 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, DIM)            05920001
C**** RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL        05930003
      INTEGER DIM(5), SIZE, SEP                                         05940001
      REAL X0(10),Y0(10),X1(10),Y1(10),X2(10),Y2(10), I0,I1,I2,IA,IB,IS 05950001
      LOGICAL FOLD,ZERO                                                 05960001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             05970001
      DATA A/-0.5/, B/0.86602540/                                       05980001
      NT = DIM(1)                                                       05990001
      SEP = DIM(2)                                                      06000001
      L1 = DIM(3)                                                       06010000
      SIZE = DIM(4) - 1                                                 06020001
      K2 = DIM(5)                                                       06030001
      NS = N*SEP                                                        06040001
      M3=M*3                                                            06050001
      FM3 = FLOAT(M3)                                                   06060001
      MM3 = SEP*M3                                                      06070001
      M OVER 2=M/2+1                                                    06080001
      FJM1 = -1.0                                                       06090001
      DO 600 J=1,M OVER 2                                               06100000
      FOLD=J.GT.1 .AND. 2*J.LT.M+2                                      06110001
      K0 = (J-1)*SEP + 1                                                06120001
      FJM1 = FJM1 + 1.0                                                 06130001
      ANGLE = TWO PI*FJM1/FM3                                           06140001
      ZERO=ANGLE.EQ.0.0                                                 06150001
      IF (ZERO) GO TO 200                                               06160001
      C1=COS(ANGLE)                                                     06170001
      S1=SIN(ANGLE)                                                     06180001
      C2=C1*C1-S1*S1                                                    06190001
      S2=S1*C1+C1*S1                                                    06200000
      GO TO 200                                                         06210001
  100 FOLD=.FALSE.                                                      06220001
      K0 = (M+1-J)*SEP + 1                                              06230001
      T=C1*A+S1*B                                                       06240001
      S1=C1*B-S1*A                                                      06250001
      C1=T                                                              06260001
      T=C2*A-S2*B                                                       06270001
      S2=-C2*B-S2*A                                                     06280001
      C2=T                                                              06290001
  200 DO 500 KK = K0, NS, MM3                                           06300000
      DO 440 L = KK, NT, L1                                             06310001
      K1 = L + SIZE                                                     06320001
      DO 420 K = L, K1, K2                                              06330001
      R0=X0(K)                                                          06340001
      I0=Y0(K)                                                          06350001
      RS=X1(K)+X2(K)                                                    06360001
      IS=Y1(K)+Y2(K)                                                    06370001
      X0(K)=R0+RS                                                       06380001
      Y0(K)=I0+IS                                                       06390001
      RA=R0+RS*A                                                        06400000
      IA=I0+IS*A                                                        06410001
      RB=(X1(K)-X2(K))*B                                                06420001
      IB=(Y1(K)-Y2(K))*B                                                06430001
      IF (ZERO) GO TO 300                                               06440001
      R1=RA+IB                                                          06450001
      I1=IA-RB                                                          06460001
      R2=RA-IB                                                          06470001
      I2=IA+RB                                                          06480001
      X1(K)=R1*C1+I1*S1                                                 06490001
      Y1(K)=I1*C1-R1*S1                                                 06500000
      X2(K)=R2*C2+I2*S2                                                 06510001
      Y2(K)=I2*C2-R2*S2                                                 06520001
      GO TO 420                                                         06530001
  300 X1(K)=RA+IB                                                       06540001
      Y1(K)=IA-RB                                                       06550001
      X2(K)=RA-IB                                                       06560001
      Y2(K)=IA+RB                                                       06570001
  420 CONTINUE                                                          06580001
  440 CONTINUE                                                          06590001
  500 CONTINUE                                                          06600000
      IF (FOLD) GO TO 100                                               06610001
  600 CONTINUE                                                          06620001
      RETURN                                                            06630001
      END                                                               06640001
C**** ------------------------------------------------------------------06650003
      SUBROUTINE R4 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, DIM)    06660001
C**** RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL        06670003
      INTEGER DIM(5), SIZE, SEP                                         06680001
      REAL X0(10),Y0(10),X1(10),Y1(10),X2(10),Y2(10),X3(10),Y3(10)      06690000
      LOGICAL FOLD,ZERO                                                 06700001
      REAL I1,I2,I3,IS0,IS1,IU0,IU1                                     06710001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             06720001
      NT = DIM(1)                                                       06730001
      SEP = DIM(2)                                                      06740001
      L1 = DIM(3)                                                       06750001
      SIZE = DIM(4) - 1                                                 06760001
      K2 = DIM(5)                                                       06770001
      NS = N*SEP                                                        06780000
      M4=M*4                                                            06790001
      FM4 = FLOAT(M4)                                                   06800001
      MM4 = SEP*M4                                                      06810001
      M OVER 2=M/2+1                                                    06820001
      FJM1 = -1.0                                                       06830001
      DO 600 J=1,M OVER 2                                               06840001
      FOLD=J.GT.1 .AND. 2*J.LT.M+2                                      06850001
      K0 = (J-1)*SEP + 1                                                06860001
      FJM1 = FJM1 + 1.0                                                 06870000
      ANGLE = TWO PI*FJM1/FM4                                           06880001
      ZERO=ANGLE.EQ.0.0                                                 06890001
      IF (ZERO) GO TO 200                                               06900001
      C1=COS(ANGLE)                                                     06910001
      S1=SIN(ANGLE)                                                     06920001
      C2=C1*C1-S1*S1                                                    06930001
      S2=S1*C1+C1*S1                                                    06940001
      C3=C2*C1-S2*S1                                                    06950001
      S3=S2*C1+C2*S1                                                    06960001
      GO TO 200                                                         06970000
  100 FOLD=.FALSE.                                                      06980001
      K0 = (M+1-J)*SEP + 1                                              06990001
      T=C1                                                              07000001
      C1=S1                                                             07010001
      S1=T                                                              07020001
      C2=-C2                                                            07030001
      T=C3                                                              07040001
      C3=-S3                                                            07050001
      S3=-T                                                             07060001
  200 DO 500 KK = K0, NS, MM4                                           07070000
      DO 440 L = KK, NT, L1                                             07080001
      K1 = L + SIZE                                                     07090001
      DO 420 K = L, K1, K2                                              07100001
      RS0=X0(K)+X2(K)                                                   07110001
      IS0=Y0(K)+Y2(K)                                                   07120001
      RU0=X0(K)-X2(K)                                                   07130001
      IU0=Y0(K)-Y2(K)                                                   07140001
      RS1=X1(K)+X3(K)                                                   07150001
      IS1=Y1(K)+Y3(K)                                                   07160001
      RU1=X1(K)-X3(K)                                                   07170000
      IU1=Y1(K)-Y3(K)                                                   07180001
      X0(K)=RS0+RS1                                                     07190001
      Y0(K)=IS0+IS1                                                     07200001
      IF (ZERO) GO TO 300                                               07210001
      R1=RU0+IU1                                                        07220001
      I1=IU0-RU1                                                        07230001
      R2=RS0-RS1                                                        07240001
      I2=IS0-IS1                                                        07250001
      R3=RU0-IU1                                                        07260001
      I3=IU0+RU1                                                        07270000
      X2(K)=R1*C1+I1*S1                                                 07280001
      Y2(K)=I1*C1-R1*S1                                                 07290001
      X1(K)=R2*C2+I2*S2                                                 07300001
      Y1(K)=I2*C2-R2*S2                                                 07310001
      X3(K)=R3*C3+I3*S3                                                 07320001
      Y3(K)=I3*C3-R3*S3                                                 07330001
      GO TO 420                                                         07340001
  300 X2(K)=RU0+IU1                                                     07350001
      Y2(K)=IU0-RU1                                                     07360001
      X1(K)=RS0-RS1                                                     07370000
      Y1(K)=IS0-IS1                                                     07380001
      X3(K)=RU0-IU1                                                     07390001
      Y3(K)=IU0+RU1                                                     07400001
  420 CONTINUE                                                          07410001
  440 CONTINUE                                                          07420001
  500 CONTINUE                                                          07430001
      IF (FOLD) GO TO 100                                               07440001
  600 CONTINUE                                                          07450001
      RETURN                                                            07460001
      END                                                               07470000
C**** ------------------------------------------------------------------07480003
      SUBROUTINE R5 CFTK(N,M,X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4,DIM)07490001
C**** RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL        07500003
      INTEGER DIM(5), SIZE, SEP                                         07510001
      REAL X0(10),Y0(10),X1(10),Y1(10),X2(10),Y2(10),X3(10),Y3(10),     07520001
     1 X4(10),Y4(10),I0,I1,I2,I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2     07530001
      LOGICAL FOLD,ZERO                                                 07540001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             07550001
      DATA A1/0.30901699/,B1/0.95105652/,A2/-0.80901699/,B2/0.58778525/ 07560000
      NT = DIM(1)                                                       07570001
      SEP = DIM(2)                                                      07580001
      L1 = DIM(3)                                                       07590001
      SIZE = DIM(4) - 1                                                 07600001
      K2 = DIM(5)                                                       07610001
      NS = N*SEP                                                        07620001
      M5=M*5                                                            07630001
      FM5 = FLOAT(M5)                                                   07640001
      MM5 = SEP*M5                                                      07650000
      M OVER 2=M/2+1                                                    07660001
      FJM1 = -1.0                                                       07670001
      DO 600 J=1,M OVER 2                                               07680001
      FOLD=J.GT.1 .AND. 2*J.LT.M+2                                      07690001
      K0 = (J-1)*SEP + 1                                                07700001
      FJM1 = FJM1 + 1.0                                                 07710001
      ANGLE = TWO PI*FJM1/FM5                                           07720001
      ZERO=ANGLE.EQ.0.0                                                 07730001
      IF (ZERO) GO TO 200                                               07740000
      C1=COS(ANGLE)                                                     07750001
      S1=SIN(ANGLE)                                                     07760001
      C2=C1*C1-S1*S1                                                    07770001
      S2=S1*C1+C1*S1                                                    07780001
      C3=C2*C1-S2*S1                                                    07790001
      S3=S2*C1+C2*S1                                                    07800001
      C4=C2*C2-S2*S2                                                    07810001
      S4=S2*C2+C2*S2                                                    07820001
      GO TO 200                                                         07830001
  100 FOLD=.FALSE.                                                      07840000
      K0 = (M+1-J)*SEP + 1                                              07850001
      T=C1*A1+S1*B1                                                     07860001
      S1=C1*B1-S1*A1                                                    07870001
      C1=T                                                              07880001
      T=C2*A2+S2*B2                                                     07890001
      S2=C2*B2-S2*A2                                                    07900001
      C2=T                                                              07910001
      T=C3*A2-S3*B2                                                     07920001
      S3=-C3*B2-S3*A2                                                   07930001
      C3=T                                                              07940000
      T=C4*A1-S4*B1                                                     07950001
      S4=-C4*B1-S4*A1                                                   07960001
      C4=T                                                              07970001
  200 DO 500 KK = K0, NS, MM5                                           07980001
      DO 440 L = KK, NT, L1                                             07990001
      K1 = L + SIZE                                                     08000001
      DO 420 K = L, K1, K2                                              08010001
      R0=X0(K)                                                          08020001
      I0=Y0(K)                                                          08030001
      RS1=X1(K)+X4(K)                                                   08040000
      IS1=Y1(K)+Y4(K)                                                   08050001
      RU1=X1(K)-X4(K)                                                   08060001
      IU1=Y1(K)-Y4(K)                                                   08070001
      RS2=X2(K)+X3(K)                                                   08080001
      IS2=Y2(K)+Y3(K)                                                   08090001
      RU2=X2(K)-X3(K)                                                   08100001
      IU2=Y2(K)-Y3(K)                                                   08110001
      X0(K)=R0+RS1+RS2                                                  08120001
      Y0(K)=I0+IS1+IS2                                                  08130001
      RA1=R0+RS1*A1+RS2*A2                                              08140000
      IA1=I0+IS1*A1+IS2*A2                                              08150001
      RA2=R0+RS1*A2+RS2*A1                                              08160001
      IA2=I0+IS1*A2+IS2*A1                                              08170001
      RB1=RU1*B1+RU2*B2                                                 08180001
      IB1=IU1*B1+IU2*B2                                                 08190001
      RB2=RU1*B2-RU2*B1                                                 08200001
      IB2=IU1*B2-IU2*B1                                                 08210001
      IF (ZERO) GO TO 300                                               08220001
      R1=RA1+IB1                                                        08230001
      I1=IA1-RB1                                                        08240000
      R2=RA2+IB2                                                        08250001
      I2=IA2-RB2                                                        08260001
      R3=RA2-IB2                                                        08270001
      I3=IA2+RB2                                                        08280001
      R4=RA1-IB1                                                        08290001
      I4=IA1+RB1                                                        08300001
      X1(K)=R1*C1+I1*S1                                                 08310001
      Y1(K)=I1*C1-R1*S1                                                 08320001
      X2(K)=R2*C2+I2*S2                                                 08330001
      Y2(K)=I2*C2-R2*S2                                                 08340000
      X3(K)=R3*C3+I3*S3                                                 08350001
      Y3(K)=I3*C3-R3*S3                                                 08360001
      X4(K)=R4*C4+I4*S4                                                 08370001
      Y4(K)=I4*C4-R4*S4                                                 08380001
      GO TO 420                                                         08390001
  300 X1(K)=RA1+IB1                                                     08400001
      Y1(K)=IA1-RB1                                                     08410001
      X2(K)=RA2+IB2                                                     08420001
      Y2(K)=IA2-RB2                                                     08430001
      X3(K)=RA2-IB2                                                     08440000
      Y3(K)=IA2+RB2                                                     08450001
      X4(K)=RA1-IB1                                                     08460001
      Y4(K)=IA1+RB1                                                     08470001
  420 CONTINUE                                                          08480001
  440 CONTINUE                                                          08490001
  500 CONTINUE                                                          08500001
      IF (FOLD) GO TO 100                                               08510001
  600 CONTINUE                                                          08520001
      RETURN                                                            08530001
      END                                                               08540000
C**** ------------------------------------------------------------------08550003
      SUBROUTINE HERMFT (X, Y, NSIZE, N, DIM)                           08560001
      REAL X(NSIZE), Y(NSIZE)                                           08570001
      INTEGER DIM(5), D2, D3, D4, D5                                    08580001
C**** HERMITIAN SYMMETRIC FOURIER TRANSFORM                             08590003
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             08600001
      TWO N = FLOAT(2*N)                                                08610000
      NT = DIM(1)                                                       08620001
      D2 = DIM(2)                                                       08630001
      D3 = DIM(3)                                                       08640001
      D4 = DIM(4) - 1                                                   08650001
      D5 = DIM(5)                                                       08660001
      DO 100 I0 = 1, NT, D3                                             08670001
      I1 = I0 + D4                                                      08680001
      DO 100 I = I0, I1, D5                                             08690001
      A = X(I)                                                          08700000
      B = Y(I)                                                          08710001
      X(I) = A + B                                                      08720001
      Y(I) = A - B                                                      08730001
  100 CONTINUE                                                          08740001
      N OVER 2 = N/2 + 1                                                08750001
      IF (N OVER 2 .LT. 2) GO TO 500                                    08760001
      DO 400 I0 = 2, N OVER 2                                           08770001
      ANGLE = TWO PI*FLOAT(I0-1)/TWO N                                  08780001
      CO = COS(ANGLE)                                                   08790000
      SI = SIN(ANGLE)                                                   08800001
      K = (N + 2 - 2*I0)*D2                                             08810001
      K1 = (I0 - 1)*D2 + 1                                              08820001
      DO 300 I1 = K1, NT, D3                                            08830001
      I2 = I1 + D4                                                      08840001
      DO 200 I = I1, I2, D5                                             08850001
      J = I + K                                                         08860001
      A = X(I) + X(J)                                                   08870001
      B = X(I) - X(J)                                                   08880001
      C = Y(I) + Y(J)                                                   08890000
      D = Y(I) - Y(J)                                                   08900001
      E = B*CO + C*SI                                                   08910001
      F = B*SI - C*CO                                                   08920001
      X(I) = A + F                                                      08930001
      X(J) = A - F                                                      08940001
      Y(I) = E + D                                                      08950001
      Y(J) = E - D                                                      08960001
  200 CONTINUE                                                          08970001
  300 CONTINUE                                                          08980001
  400 CONTINUE                                                          08990000
      CALL CMPLFT (X, Y, NSIZE, N, DIM)                                 09000001
  500 RETURN                                                            09010001
      END                                                               09020001
C**** ------------------------------------------------------------------09030003
      SUBROUTINE PP1 (X, NSIZE, NX, NY, NZ)                             09040001
      REAL X(NSIZE)                                                     09050001
      INTEGER  P1, P2, R, SKIP, RECS,  D(5)                             09060001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             09070000
      COMMON /TRAN/ SCALE,ITLE(20),MH(3),LEVEL,IT4,XLIM(3)              09080001
      COMMON/TAPE/NOSET,PARA(6),NSYM,NCENT,LATT,NPIC,TS(3,24),IS(2,3,24)
     1 ,DDUM(173)
      P1 = NSIZE/(2*NY*(MH(3) + 1))                                     09100001
      P2 = NSIZE/(NX*NZ)                                                09110001
      IF (P1 .LE. 0 .OR. P2 .LE. 0) GO TO 300                           09120001
C**** PASS ONE. TRANSFORM ON K AND WRITE INTERMEDIATE RESULTS ON LSCRA  09130003
      REWIND LSCRA                                                      09140000
      R = -MH(1)                                                        09150001
  100 IF (R + P1 .GT. MH(1)) P1 = MH(1) + 1 - R                         09160001
      CALL READ KL(X, NY, MH(3)+1, P1, R)                               09170001
      D(1) = 2*(NY*P1*(MH(3)+1))                                        09180001
      D(2) = 2                                                          09190001
      D(3) = D(1)                                                       09200001
      D(4) = D(1)                                                       09210001
      D(5) = 2*NY                                                       09220001
      CALL CMPLFT (X(1), X(2), NSIZE, NY, D)                            09230001
      CALL WRITE Y (X, NY, MH(3)+1, P1, P2)                             09240000
      R = R + P1                                                        09250001
      IF (R .LE. MH(1)) GO TO 100                                       09260001
C**** END OF PASS 1.  PASS 2 READS BACK THE INTERMEDIATE RESULTS,       09270003
C**** CALCULATES THE TRANSFORMS ON H AND L, AND WRITES OUT THE FINAL    09280003
C**** Y SECTIONS.                                                       09290003
      REWIND LMAP                                                       09300001
      WRITE(LMAP) ITLE,NOSET,PARA,NSYM,NCENT,LATT,NPIC,TS,IS            09310001
      WRITE(LMAP) NX,NZ,NY                                              09320000
      REWIND LSCRA                                                      09330001
      SKIP = 0                                                          09340001
      R = 0                                                             09350001
      P1 = NSIZE/(2*NY*(MH(3) + 1))                                     09360001
      RECS = (NY - 1)/P2                                                09370001
  200 IF (R + P2 .GT. NY) P2 = NY - R                                   09380001
      CALL READ HL (X, NX, NZ/2, P2, MH(1), MH(3), P1, SKIP, RECS)      09390001
      IF (R + P2 .LT. NY) REWIND LSCRA                                  09400001
      SKIP = SKIP + 1                                                   09410000
C**** X NOW CONTAINS INTERMEDIATE RESULTS STORED WITH L DOWN THE        09420003
C**** COLUMNS AND H ACROSS THE ROWS.                                    09430003
      D(1) = NX*NZ*P2                                                   09440001
      D(2) = NZ                                                         09450001
      D(3) = NZ*NX                                                      09460001
      D(4) = 2*(MH(3) + 1)                                              09470001
      D(5) = 2                                                          09480001
      CALL CMPLFT (X(1), X(2), NSIZE, NX, D)                            09490000
      D(2) = 2                                                          09500001
      D(3) = D(1)                                                       09510001
      D(4) = D(1)                                                       09520001
      D(5) = NZ                                                         09530001
      CALL HERMFT (X(1), X(2), NSIZE, NZ/2, D)                          09540001
      CALL OUTPUT (X, NZ, NX, P2, R, NY)                                09550001
      R = R + P2                                                        09560001
      IF (R .LT. NY) GO TO 200                                          09570001
C**** END OF JOB                                                        09580003
      RETURN                                                            09590001
  300 P1 = 2*NY*(MH(3)+1)                                               09600001
      P2 = NX * NZ                                                      09610001
      WRITE (LT,350) NSIZE, P1, P2                                      09620001
  350 FORMAT(1H0,8X,37HREQUEST TOO LARGE. SPACE AVAILABLE IS,I10,       09630001
     1 33H AND SPACE REQUESTED IS LARGER OF,I10,4H AND,I10)             09640001
      CALL ERROR                                                        09650001
C**** THIS STATEMENT IS INACCESSIBLE AND IS FOR COMPILATION ONLY        09660003
      RETURN                                                            09670001
      END                                                               09680001
C**** ------------------------------------------------------------------09690003
      SUBROUTINE READ KL(X, NY, NZ, NX, HS)                             09700001
      INTEGER HS, H, HM, HL                                             09710001
      COMPLEX X(NY,NZ,NX)                                               09720001
      COMMON /REFL/ IH(100), G(2,100)                                   09730001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             09740001
      COMMON /CONST/ NEX,KUSER1,DTOR,LC,LIN,NP(3)
      REWIND LO                                                         09760001
      NBLOCK = NEX/100+1                                                09770001
      HM=262144*(HS+NX-1+256)+(512+1)*(2*256-1)                         09780001
      HL=262144*(HS+256)                                                09790001
      DO 100 H = 1, NX                                                  09800001
      DO 100 L = 1, NZ                                                  09810001
      DO 100 K = 1, NY                                                  09820001
      X(K,L,H) = CMPLX(0.0,0.0)                                         09830001
  100 CONTINUE                                                          09840001
      M=100                                                             09850001
      DO 500 IB=1,NBLOCK                                                09860001
      IF(IB.EQ.NBLOCK) M=MOD(NEX,100)                                   09870001
      IF(M.EQ.0) GO TO 500                                              09880001
      READ(LO) IH,G                                                     09890001
      DO 300 J = 1, M                                                   09900001
      IHJ=IH(J)                                                         09910001
      IF(IHJ.GT.HM.OR.IHJ.LT.HL) GO TO 300                              09920001
      H=IHJ/262144-256                                                  09930001
      L=IHJ-262144*(H+256)                                              09940000
      K=L/512-256                                                       09950001
      L=L-512*(K+256)-256                                               09960001
      NOKO = 0                                                          09970001
      IF (H.EQ.0.AND.L.EQ.0.AND.K.NE.0) NOKO = NY-K+1                   09980001
      H = H - HS + 1                                                    09990001
      IF(K.LT.0)K=NY+K                                                  10000001
      K = K + 1                                                         10010001
      L = L + 1                                                         10020001
      X(K,L,H) = CMPLX(G(1,J),G(2,J))                                   10030001
      IF (NOKO.NE.0) X(NOKO,L,H) = CONJG(X(K,L,H))                      10040000
  300 CONTINUE                                                          10050001
  500 CONTINUE                                                          10060001
      RETURN                                                            10070001
      END                                                               10080001
C**** ------------------------------------------------------------------10090003
      SUBROUTINE WRITE Y (X, NY, NZ, NX, SIZE)                          10100001
      INTEGER SIZE, H, P, Q, R                                          10110001
      COMPLEX X(NY,NZ,NX)                                               10120001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             10130001
      P = SIZE                                                          10140017
      Q = 0                                                             10150017
  100 R = Q + 1                                                         10160017
      IF (Q + P .GT. NY) P = NY - Q                                     10170017
      Q = Q + P                                                         10180017
      DO 10 L=1,NZ                                                      10190017
   10 WRITE (LSCRA)((X(K,L,H), H = 1, NX), K = R, Q)                    10200017
      IF (Q .LT. NY) GO TO 100                                          10210017
      RETURN                                                            10220001
      END                                                               10230001
C**** ------------------------------------------------------------------10240003
      SUBROUTINE READ HL (X, NX, NZ, NY, HMAX, LMAX, SIZE, SKIP, RECS)  10250001
      INTEGER HMAX, SIZE, SKIP ,RECS, H, HL, HU, P, Q                   10260001
      COMPLEX X(NZ,NX,NY)                                               10270001
C**** READS IN INTERMEDIATE RESULTS FOR ALL H AND L FOR A BLOCK OF K.   10280003
C**** THE INPUT IS STORED WITH L DOWN THE COLUMNS AND H ON THE ROWS.    10290003
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             10300001
      LM = LMAX + 1                                                     10310001
      P = SIZE                                                          10320000
      HU = NX - HMAX                                                    10330001
      IF (SKIP .LE. 0) GO TO 200                                        10340001
      DO 100 Q = 1, SKIP                                                10350001
      DO 100 L=1,LM                                                     10360020
      READ (LSCRA)                                                      10370001
  100 CONTINUE                                                          10380001
C**** READ DATA FOR NEGATIVE H                                          10390003
  200 IF (HU + P .GT. NX) GO TO 400                                     10400001
      HL = HU + 1                                                       10410000
      HU = HU + P                                                       10420001
      DO 10 L=1,LM                                                      10430017
   10 READ (LSCRA)((X(L,H,K), H = HL, HU), K = 1, NY)                   10440017
      IF (RECS .LE. 0) GO TO 200                                        10450001
      DO 300 Q = 1, RECS                                                10460001
      DO 300 L=1,LM                                                     10461021
      READ (LSCRA)                                                      10470001
  300 CONTINUE                                                          10480001
      GO TO 200                                                         10490001
C**** GO PICK UP RECORD WHICH SPANS H = 0 IF NECESSARY                  10500003
  400 IF (HU .NE. NX) GO TO 700                                         10510001
      HU = 0                                                            10520001
C**** READ RECORDS FOR POSITIVE H                                       10530003
  500 IF (HU + P .GT. HMAX + 1) P = HMAX + 1 - HU                       10540001
      HL = HU + 1                                                       10550001
      HU = HU + P                                                       10560001
      DO 20 L=1,LM                                                      10570017
   20 READ (LSCRA)((X(L,H,K), H = HL, HU), K = 1, NY)                   10580017
  550 IF (HU .EQ. HMAX + 1) GO TO 800                                   10590000
      IF (RECS .LE. 0) GO TO 500                                        10600001
      DO 600 Q = 1, RECS                                                10610001
      DO 600 L=1,LM                                                     10611021
      READ (LSCRA)                                                      10620001
  600 CONTINUE                                                          10630001
      GO TO 500                                                         10640001
C**** SECTION TO READ A RECORD SPANNING H = 0                           10650003
  700 HL = HU + 1                                                       10660001
      HU = HU + P - NX                                                  10670000
      IF (HU .GT. HMAX + 1) HU = HMAX + 1                               10680001
      DO 30 L=1,LM                                                      10690017
   30 READ (LSCRA)((X(L,H,K),H=HL,NX),(X(L,H,K),H=1,HU),K=1,NY)         10700017
      GO TO 550                                                         10710001
C**** PAD THE ARRAY WITH ZERO WHERE THERE ARE NO DATA, AND FILL IN THE  10720003
C**** -H K 0 RESULTS BY SYMMETRY.                                       10730003
  800 DO 900 H = 2, HU                                                  10740001
      HL = NX + 2 - H                                                   10750000
      DO 900 K = 1, NY                                                  10760001
      X(1,HL,K) = CONJG(X(1,H,K))                                       10770001
  900 CONTINUE                                                          10780001
      HL = HMAX + 2                                                     10790001
      HU = NX - HMAX                                                    10800001
      IF (HU .LT. HL) GO TO 920                                         10810001
      DO 910 L = 1, LM                                                  10820001
      DO 910 K = 1, NY                                                  10830001
      DO 910 H = HL, HU                                                 10840001
      X(L,H,K) = CMPLX(0.0,0.0)                                         10850000
  910 CONTINUE                                                          10860001
  920 IF (LM .GE. NZ) GO TO 940                                         10870001
      P = LM + 1                                                        10880001
      DO 930 K = 1, NY                                                  10890001
      DO 930 L = P, NZ                                                  10900001
      DO 930 H = 1, NX                                                  10910001
      X(L,H,K) = CMPLX(0.0,0.0)                                         10920001
  930 CONTINUE                                                          10930001
C**** END OF INPUT                                                      10940003
  940 RETURN                                                            10950001
      END                                                               10960001
C**** ------------------------------------------------------------------10970003
      SUBROUTINE OUTPUT (X, NZ, NX, NY, Y, NYT)                         10980001
      REAL X(NZ,NX,NY)                                                  10990001
      INTEGER STAR,BLANK,Y,SEC,XL,XU                                    11000001
      COMMON /PERIF/ LMAP,LT,LO,LSCRA,TWOPI                             11010001
      COMMON /TRAN/ SCALE,ITLE(20),MH(3),LEVEL,IT4,XLIM(3)              11020000
      COMMON /TAPE/ INUT(350),LINE(50)                                  11030001
      DATA STAR/2H**/,BLANK/4H    /,NCOL/36/                            11040001
C**** PUT OUT SCALED Y-SECTIONS                                         11050003
      IF(IT4.EQ.0) GO TO 250                                            11060001
      NXM=MIN0(NX,INT(XLIM(1)*FLOAT(NX))+1)                             11070001
      NYM=MIN0(NYT,INT(XLIM(2)*FLOAT(NYT))+1)                           11080001
      NZM=MIN0(NZ,INT(XLIM(3)*FLOAT(NZ))+1)                             11090001
      ASC=1000.0/FLOAT(NX)                                              11100000
  250 DO 900 K = 1, NY                                                  11110001
      SEC = Y + K - 1                                                   11120001
      DO 350 J=1,NZ                                                     11130001
      DO 330 I=1,NX                                                     11140001
      XX=X(J,I,K)*SCALE                                                 11150001
      X(J,I,K)=XX                                                       11160001
      INUT(I)=0                                                         11170001
      IF(XX.NE.0.0) INUT(I)=XX+SIGN(0.5,XX)                             11180001
  330 CONTINUE                                                          11190000
      WRITE(LMAP)(INUT(I),I=1,NX)                                       11200001
  350 CONTINUE                                                          11210001
      IF (IT4 .EQ. 0) GO TO 900                                         11220001
      XU = 0                                                            11230001
  450 XL = XU + 1                                                       11240001
      XU = XU + NCOL                                                    11250001
      IF(XU.GT.NXM)XU=NXM                                               11260001
      DO 460 L=XL,XU                                                    11270001
      INUT(L)=FLOAT((L-1))*ASC+0.5                                      11280001
  460 CONTINUE                                                          11290000
      NEC=1000.*(FLOAT(SEC))/(FLOAT(NYT))+0.5                           11300001
      WRITE (IT4,480) ITLE,NEC                                          11310001
  480 FORMAT(1H1,7X,20A4,8X,12HSECTION  Y =,I4/)                        11320001
      WRITE (IT4,500) (INUT(NN),NN=XL,XU,2)                             11330001
  500 FORMAT(8X,3HX =,I4,17I6)                                          11340001
      ILIM = XL + 1                                                     11350001
      WRITE (IT4,520) (INUT(NN),NN=ILIM,XU,2)                           11360001
  520 FORMAT(12X,18I6)                                                  11370001
      WRITE(IT4,530)                                                    11380001
  530 FORMAT(1H0)                                                       11390000
      DO 700 I = 1,NZM                                                  11400001
      LINE(1)=FLOAT((I-1))*1000./FLOAT(NZ)+0.5                          11410001
      L = 1                                                             11420001
      DO 600 J = XL, XU                                                 11430001
      L = L + 1                                                         11440001
      INUT(L)=BLANK                                                     11450001
      XX=X(I,J,K)                                                       11460001
      LINE(L)=0                                                         11470001
      IF(XX.NE.0.0) LINE(L)=INT(0.1*XX+SIGN(0.5,XX))                    11480001
      IF (IABS(LINE(L)) .GT. 99) LINE(L) = ISIGN(99,LINE(L))            11490000
      IF (10 * LINE(L) .GT. LEVEL) INUT(L) = STAR                       11500001
  600 CONTINUE                                                          11510001
      WRITE (IT4,630) (LINE(J), J = 1, L)                               11520001
  630 FORMAT(4H Z =,I4,4H *  ,36I3)                                     11530001
      WRITE(IT4,660) (INUT(J),J=2,L)                                    11540001
  660 FORMAT(12X,36(1X,A2))                                             11550001
  700 CONTINUE                                                          11560001
      IF(XU.LT.NXM)GO TO 450                                            11570001
      IF(SEC.GE.NYM) IT4=0                                              11580001
  900 CONTINUE                                                          11590000
      RETURN                                                            11600001
      END                                                               11610001

