CRdG 02-05-95 MCENTR goed wegschrijven naar de REDDIF-file
CRdG 01-03-94 Default waarden voor parameters in de Autofour-kaarten
C             op de waarden gezet die Crunch94 moet gebruiken.
CRdG 23-02-94 COSD vervangen door nette COS gebruik makend van PIR!
CRdG 23-02-94 open statement eruit!
c sept'90: added code to write datafiles for AUTOFOUR:
c for037: REDDIF-file (including symmetry-operations)
c for038: AUTOFOUR (rudimentary) input-file (first part only,
c         known atomic positions after SEARCH should be added to this file)
C     * * * * * * * * * * * * * * * * NORMAL * * * * * * * * * * * * * *
C        PROGRAM FOR THE CALCULATION OF NORMALISED STRUCTURE FACTORS
C     VERSION    JAN    1980                          UNIVERSITY OF YORK
C     ------------------------------------------------------------------
C     INPUT/OUTPUT UNITS, TITLE, FLAGS
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
C     SYMMETRY
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT
C     SCRATCH TAPE REFLEXION ARRAYS
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
C     ATOMIC SCATTERING FACTORS
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
C     KNOWN MOLECULAR (GROUP) INFORMATION
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)
C     SPHERICAL SCATTERING FACTORS
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF
C     MISCELLANEOUS
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
C     WILSON PLOT PARAMETERS
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
C     STATISTICAL CHARTS
      COMMON/ST/VST(10,5),NST(5),ZT(25,5),EE(10),MULT,IND,NZR,TMUL
C     REFLEXION DATA FOR MULTAN
      COMMON/XXX/IX(1000),EX(1000),FX(1000)
C     SIN/COS TABLE
      COMMON/TRIG/SINT(450)
	character *7 autofourlatt
	real fat(32),s(12)
C     DEFINE INPUT AND OUTPUT CHANNELS
C     CARD READER
      LN=5
C     LINE PRINTER
      LO=6
C     INPUT AND OUTPUT OF BINARY REFLEXION DATA
      ISTAN=15
C     SCRATCH TAPE
      ISCRA=8
C     OUTPUT FOR MULTAN (FORMATTED)
      LNTA=9
C     MULTAN RECYCLE INSTRUCTIONS
      LREC=12
C     FOURIER OUTPUT FILE FOR INPUT TO EXFFT (MAY EQUAL ISCRA)
      LFOUR=10
C     SET UP INITIAL VALUES, READ PROGRAM PARAMETERS
      PI=4.0*ATAN(1.0)
      NREF=0
      RHOMAX=0.0
      DTOR=PI/180.0
C     SET UP SIN/COS TABLE
      DO 50 I=1,450
      SINT(I)=SIN(DTOR*FLOAT(I-1))
   50 CONTINUE
      READ(LN,100)ITLE
  100 FORMAT(20A4)
      WRITE(LO,120) ITLE
  120 FORMAT(39H0PROGRAM TO NORMALISE STRUCTURE FACTORS,60X,
     1 21HVERSION    JAN   1980/1H0,20X,20A4)
      CALL TRANSL(JUMP,BT,ISC)
      ANAT=FLOAT(NAT)/(PTS*FLOAT((ICENT+1)*NSYM))
      WRITE(LO,370) ANAT
  370 FORMAT(1H0,39X,36HNUMBER OF ATOMS IN ASYMMETRIC UNIT =,F6.2)
      NASU=INT(ANAT+0.5)
c AUTOFOUR-patch (begin)
CRdG 23-02-94 open statement eruit!
c	open(unit=38,carriagecontrol='list',status='new')
	write(38,'(''AUTOFOUR FOR '',16A4)') (ITLE(i37),i37=1,16)
	autofourlatt='PABCIFR'
c 0(.0) for defaults
c anat = #atoms in asym.unit
	write(38,'(4x,a1,5i5,5f10.1)') autofourlatt(latt:latt),3,0,0,
     .	  nint(anat),1,0.0,-1.0,0.0,0.0,0.3
c num(1..9) = #atoms of each atomtype
	write(38,'(16i5)') (NW(i37),i37=1,nk)
c AUTOFOUR-patch (end)
C     CALCULATE NUMBER OF REFLEXIONS TO PASS TO MULTAN
      IF (MM.GT.0) GOTO 400
      MN = INT(4.0*ANAT+100.5)
      IF (ICENT.EQ.1) MN = MN + 50
      IF (NSYM.EQ.1) MN = MN + 50
      MN = MIN0(MN,500)
      MM=MN+MIN0(500-MN,100)/2
C     CHECK IF WEIGHTED OR DIFFERENCE FOURIER IS REQUIRED
  400 NDIFF=0
      DO 410 I=1,NGP
      IF(NINF(I).GT.5) GO TO 420
  410 CONTINUE
      IF(MM.GT.0) WRITE(LO,380) MM,MZ
  380 FORMAT(1H0,27X,22HOUTPUT FOR MULTAN  -  ,I5,13H  LARGEST E'S,3X,
     1 3HAND,I5,14H  SMALLEST E'S)
      GO TO 430
  420 NDIFF=1
      ISCRA=LFOUR
      WRITE(ISCRA) NDIFF
      WRITE(ISCRA) ITLE,ICENT,LATT,NSYM,((TS(I,J),(IS(K,I,J),K=1,2),
     1 I=1,3),J=1,NSYM),(NDIFF,I=1,3),(CX(I),I=1,6),NASU
      EN=0.0
      ER=0.0
      SC=SQRT(SCAL(1))
      IF(SC.LT.0.01) SC=1.0
C     READ REFLEXION DATA FROM CARDS
  430 IF(IABS(NPC).LE.12) CALL CARDIN
C     READ REFLEXION DATA FROM BINARY FILE
      IF(IABS(NPC).GT.12) CALL TAPEIN
      IF(NDIFF.EQ.1) CALL RFAC
      IF(NDIFF.EQ.1) STOP
      NB=8.0*ALOG10(0.05*FLOAT(MAX0(NREF,100))+0.5)
C     MAXIMUM OF 30 POINTS ON WILSON PLOT
      IF(NB.GT.30) NB=30
      WRITE(LO,440) NREF,RHOMAX,NB
  440 FORMAT(//23H0NUMBER OF REFLEXIONS =,I6,8X,
     1 32HMAXIMUM (SIN(THETA)/LAMBDA)**2 =,F7.4,8X,
     2 33HNUMBER OF POINTS ON WILSON PLOT =,I3)
      IF(JUMP.GE.0) GO TO 450
C     OBTAIN SUMS FOR WILSON PLOT AND FIT LEAST SQUARES STRAIGHT LINE
      CALL SUM(PTS)
C     PLOT WILSON AND DEBYE CURVES AND LEAST SQUARES STRAIGHT LINE
      CALL GRAPH(NGP)
  450 BT=2.0*BT
      IF(JUMP.GE.0) SC=1.0
C     CALCULATE SCALE FACTORS FOR APPROPRIATE REFLEXION GROUPS
      CALL RESCA(KSYS,ISC,JUMP)
C     OUTPUT FOR MULTAN
c AUTOFOUR-patch (begin)
c unformatted reddif-file
	write(37) 990,ITLE
c normal-latt   = P A B C I F R
c autofour-latt = P I A B C F R
	latta=latt
	if (latta.eq.5) then
	  latta=2
	else if (latta.ge.2.and.latta.le.4) then
	  latta=latta+1
	end if
c acent(0)/centro(1); #symmops; #atomtypes; cell(1..6) , remaining 20 items
c (volume,reciprocal cell) not defined
CRdG 23-02-94 COSD vervangen door nette COS gebruik makend van PIR!
        PIR=ATAN(1.0)*4./180.
C Schrijf MCENTR goed weg naar de reddif-file!
C NONCENTRO: icent=0; mcentr=1    CENTRO: icent=1; mcentr=2
        if(icent.eq.0) mcentr=1
        if(icent.eq.1) mcentr=2
	write(37) 991,nref,latta,mcentr,nsym,nk,cx(1),cx(2),cx(3),
C    .	  cosd(cx(4)),cosd(cx(5)),cosd(cx(6)),(0.0,i37=1,20)
     .	  cos(pir*cx(4)),cos(pir*cx(5)),cos(pir*cx(6)),(0.0,i37=1,20)
c unique symmop's in AUTOFOUR-format on REDDIF-file
	do i37=1,nsym
c init. S() = r11,r12,r13,t1 r21,r22,r23,t2 r31,r32,r33,t3
c define translation part
	  s( 1)=0.0
	  s( 2)=0.0
	  s( 3)=0.0
	  s( 4)=ts(1,i37)
	  s( 5)=0.0
	  s( 6)=0.0
	  s( 7)=0.0
	  s( 8)=ts(2,i37)
	  s( 9)=0.0
	  s(10)=0.0
	  s(11)=0.0
	  s(12)=ts(3,i37)
c define rotational part
	  do i371=1,2
	    do i372=1,3
	      if (is(i371,i372,i37).ne.0)
     .		s(iabs(is(i371,i372,i37))+(i372-1)*4)=
     .		float(isign(1,is(i371,i372,i37)))
	    end do
	  end do
	  write(37) 992,S
	end do
c max |h|,|k|,|l|,lambda not defined
	write(37) 994,0,0,0,0.0
c scattering factor tables (from 0.00 to 1.50 step 0.05)
	do i37=1,nk
	  do j37=1,32
	    rho37=(float(j37-1)*0.05)**2.0
	    fat(j37)=al(i37)*exp(-as(i37)*rho37)+
     .	      bl(i37)*exp(-bs(i37)*rho37)+cl(i37)*exp(-cs(i37)*rho37)+
     .        dl(i37)*exp(-ds(i37)*rho37)+el(i37)
	  end do
	  write(37) 995,fat
	end do
	write(37) 996,1
c F000 not defined; only 8 atomtypes in normal -=> #9,10 not defined
	write(37)997,0.0,(NO(i37),i37=1,8),0,0
c start reflections
c AUTOFOUR-patch (end)
      IF(MM.LT.0) GO TO 500
      WRITE(LNTA,460) ITLE,(CX(I),I=1,6),NW,NO,ICENT,LATT,NSYM,NGP,NASU
  460 FORMAT(20A4/6F10.5/16I5/5I5)
      WRITE(LNTA,470) ((TS(I,J),(IS(K,I,J),K=1,2),I=1,3),J=1,NSYM)
  470 FORMAT(3(F11.8,2I2))
      IF(NGP.EQ.0) GO TO 500
      NF=0
      DO 490 I=1,NGP
      NS=NF+1
      NF=NF+NAG(I)
      WRITE(LNTA,480) NINF(I),NAG(I),(NZ(J),X(J),Y(J),Z(J),J=NS,NF)
  480 FORMAT(2I5/(I5,3F10.6))
  490 CONTINUE
C     CALCULATE FINAL E'S AND OUTPUT REFLEXION STATISTICS
  500 CALL ECAL(KSYS)
      IF(NGP.LE.0) GO TO 700
      NF=0
      DO 600 IGP=1,NGP
      NS=NF+1
      NF=NF+NAG(IGP)
      IF(NINF(IGP).LT.5) GO TO 600
      CALL RECYC(NS,NF,BT)
      GO TO 700
  600 CONTINUE
  700 STOP
      END
C     ------------------------------------------------------------------
C     FREE FORMAT INPUT ROUTINE
      SUBROUTINE TRANSL(JUMP,BT,ISC)
      COMMON/FFREAD/IDIV(8),IB(8)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      DIMENSION LETT(26),N(80),KX(10),POP(10),NA(8),CR(9,10)
      DATA LETT/1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL,1HM,
     1 1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ/
      DATA KX/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9/
      DATA KSP/1H /,KM/1H-/,KD/1H./
C     SET INITIAL AND DEFAULT VALUES
      TH=1.0
      EN=1.2
      ER=0.3
      MZ=100
      MM=0
      NSYM=1
      NTOT=0
      NGP=0
      IK=1
      NB=0
      ISC=0
      LST=0
      BT=0.0
      DO 10 I=1,8
      NW(I)=0
      NO(I)=0
      SCAL(I)=0.0
   10 CONTINUE
      DO 20 I=1,100
      X(I)=0.0
      Y(I)=0.0
      Z(I)=0.0
   20 CONTINUE
      DO 40 J=1,10
      DO 30 I=1,9
      CR(I,J)=0.0
   30 CONTINUE
   40 CONTINUE
      NPC=15
      LATT=LETT(16)
      JUMP=-1
      ICENT=0
      IND=1
      KS=1
      READ(LN,90) N
   90 FORMAT(80A1)
  100 KEY=0
      IKW=0
      IC=0
      IMK=0
      IM=1
  110 DO 200 I=KS,80
      DO 120 K=1,26
      IF(LETT(K).EQ.N(I)) GO TO 190
  120 CONTINUE
      IF(IKW.EQ.0) GO TO 200
      IF(IKW.LT.3.AND.N(I).EQ.KSP) GO TO 185
      IF(IKW.LT.3) GO TO 3000
      IF(IC.GT.8) GO TO 200
      DO 130 K=1,10
      IF(KX(K).EQ.N(I)) GO TO 180
  130 CONTINUE
      IF(N(I).EQ.KD) GO TO 170
      IF(N(I).EQ.KM) GO TO 150
      IM=1
      IF(N(I).EQ.KSP) GO TO 160
      GO TO 3000
  150 IM=-1
  160 IF(IMK.LE.0) IC=IC+1
C     TEST FOR CARD
      IF(KEY.EQ.30118.AND.IC.GE.2) GO TO 1950
      IF(IC.GT.8) GO TO 200
      IB(IC)=0
      IDIV(IC)=0
      IMK=1
      GO TO 200
  170 IMK=-1
      GO TO 200
  180 IB(IC)=IM*(10*IABS(IB(IC))+K-1)
      IF(IMK.EQ.1) IMK=0
      IF(IMK.LT.0) IDIV(IC)=IDIV(IC)-1
      GO TO 200
  185 GO TO (3000,2000,2100,2200,2300),IND
  190 IF(IC.GT.0) GO TO 210
      IF(IKW.GE.3) GO TO 200
      IKW=IKW+1
      KEY=100*KEY+K
C     TEST FOR SYMMETRY INPUT
      IF(KEY.EQ.192513) GO TO 1200
C     TEST FOR TAPE
      IF(KEY.EQ.200116) GO TO 2800
  200 CONTINUE
      KS=1
      READ(LN,90) N
      GO TO 110
  210 KS=I
      IF(KEY.EQ.1000) GO TO 2150
      IF(KEY.EQ.2000) GO TO 2250
      IF(KEY.EQ.3000) GO TO 2350
C     LATTICE
      IF(KEY.EQ.120120) GO TO 1000
C     NONCENTROSYMMETRIC
      IF(KEY.EQ.141514) GO TO 100
C     CENTROSYMMETRIC
      IF(KEY.EQ.30514) GO TO 1110
C     LINEAR
      IF(KEY.EQ.120914) GO TO 1120
C     NOSCALE
      IF(KEY.EQ.141519) GO TO 1130
C     LIST
      IF(KEY.EQ.120919) GO TO 1140
C     RANDOM
      IF(KEY.EQ.180114) GO TO 1147
C     ORIENTED
      IF(KEY.EQ.151809) GO TO 1149
C     POSITIONED
      IF(KEY.EQ.161519) GO TO 1151
C     KARLE
      IF(KEY.EQ.110118) GO TO 1153
C     WEIGHTED FOURIER
      IF(KEY.EQ.230615) GO TO 1155
C     DIFFERENCE FOURIER
      IF (KEY.EQ.40615) GOTO 1156
C     CREATE
      IF(KEY.EQ.31805) GO TO 1160
C     NREF
      IF(KEY.EQ.141805) GO TO 1350
C     EMIN
      IF(KEY.EQ.51309) GO TO 1400
C     NZRO
      IF(KEY.EQ.142618) GO TO 1450
C     EINPUT
      IF(KEY.EQ.50914) GO TO 1500
C     RHOMAX
      IF(KEY.EQ.180815) GO TO 1550
C     BFAC
      IF(KEY.EQ.20601) GO TO 1600
C     SCALE
      IF(KEY.EQ.190301) GO TO 1650
C     CELL
      IF(KEY.EQ.30512) GO TO 1700
C     CONTENTS
      IF(KEY.EQ.31514) GO TO 1750
C     FACTORS
      IF(KEY.EQ.60103) GO TO 1800
C     MULTIPLICITY
      IF(KEY.EQ.132112) GO TO 1900
      GO TO 3000
 1000 IND=2
      GO TO 100
 1110 ICENT=1
      GO TO 100
 1120 IK=0
      WRITE(LO,1125)
 1125 FORMAT(1H0,28X,64HNORMALISATION BY LEAST SQUARES STRAIGHT LINE THR
     1OUGH DEBYE CURVE)
      GO TO 100
 1130 ISC=1
      WRITE(LO,1135)
 1135 FORMAT(1H0,48X,24HNO INDEX GROUP RESCALING)
      GO TO 100
 1140 LST=1
      WRITE(LO,1145)
 1145 FORMAT(1H0,45X,29HLIST COMPLETE SET OF E-VALUES)
      GO TO 100
 1147 IND=2
      GO TO 1157
 1149 IND=3
      GO TO 1157
 1151 IND=4
      GO TO 1157
 1153 IND=5
      GO TO 1157
 1155 IND=6
      GOTO 1157
 1156 IND=7
 1157 NGP=NGP+1
      NINF(NGP)=IND
      IND=4
      NAG(NGP)=0
      POP(NGP)=0.0
      GO TO 100
 1160 NPC=-IABS(NPC)
      GO TO 100
C     SET UP LINE FOR ISYM; READ TO SPACE, THEN TO NON-SPACE
 1200 KS=MAX0(1,MOD(KS+1,81))
      IF (KS.EQ.1) READ (LN,90) N
      IF (N(KS).NE.KSP) GOTO 1200
 1300 KS=MAX0(1,MOD(KS+1,81))
      IF (KS.EQ.1) READ (LN,90) N
      IF (N(KS).EQ.KSP) GOTO 1300
      KS=KS-1
      CALL INSYM(N,KS)
      GO TO 100
 1350 MM=IB(1)
      GO TO 100
 1400 EN=FLOAT(IB(1))*10.0**IDIV(1)
      GO TO 100
 1450 MZ=IB(1)
      GO TO 100
 1500 BT=0.0
      SCAL(1)=1.0
      IK=-1
      GO TO 100
 1550 TH=FLOAT(IB(1))*10.0**IDIV(1)
      GO TO 100
 1600 BT=FLOAT(IB(1))*10.0**IDIV(1)
      WRITE(LO,1610) BT
 1610 FORMAT(1H0,40X,33HSUPPLIED TEMPERATURE FACTOR (B) =,F6.2)
      JUMP=JUMP+1
      GO TO 100
 1650 DO 1660 J=1,8
      IF(J.LT.IC) SCAL(J)=FLOAT(IB(J))*10.0**IDIV(J)
 1660 CONTINUE
      WRITE(LO,1670) SCAL
 1670 FORMAT(1H0,23X,26HSUPPLIED SCALE FACTORS ARE,8F6.2/1H ,32X,
     1 56HFOR APPROPRIATE INDEX GROUPS SEE RESCALING SECTION BELOW)
      JUMP=JUMP+1
      GO TO 100
 1700 IF(IC.NE.7) GO TO 3000
      DO 1710 J=1,6
      IF(NGP.EQ.0) CX(J)=FLOAT(IB(J))*10.0**IDIV(J)
      IF(NGP.GT.0) CR(J,NGP)=FLOAT(IB(J))*10.0**IDIV(J)
 1710 CONTINUE
      IF(NGP.EQ.0) CALL INCELL
      GO TO 100
 1750 NK=0
      IND=3
      GO TO 100
 1800 IND=5
      GO TO 100
 1900 POP(NGP)=FLOAT(IB(1))*10.0**IDIV(1)
      GO TO 100
 1950 NPC=ISIGN(IB(1),NPC)
      GO TO 2800
 2000 LATT=LETT(KEY)
      KS=KS+1
      GO TO 100
 2100 NK=NK+1
      NW(NK)=KEY
      KEY=1000
      IKW=3
      GO TO 110
 2150 NA(NK)=IB(1)
      GO TO 100
 2200 NAG(NGP)=NAG(NGP)+1
      NTOT=NTOT+1
      DO 2210 I=1,NK
      IF(KEY.EQ.NW(I)) GO TO 2230
 2210 CONTINUE
      GO TO 3000
 2230 NZ(NTOT)=I
      KEY=2000
      IKW=3
      GO TO 110
 2250 IF(IC.GT.1) X(NTOT)=FLOAT(IB(1))*10.0**IDIV(1)
      IF(IC.GT.2) Y(NTOT)=FLOAT(IB(2))*10.0**IDIV(2)
      IF(IC.GT.3) Z(NTOT)=FLOAT(IB(3))*10.0**IDIV(3)
      GO TO 100
 2300 DO 2310 JF=1,NK
      IF(KEY.EQ.NW(JF)) GO TO 2320
 2310 CONTINUE
      GO TO 3000
 2320 KEY=3000
      IKW=3
      GO TO 110
C
C  NOT!!! CHANGED TO INT. TABLES FORMAT
C  THEREFORE DO NOT USE THIS SOURCE AS A REPLACEMENT NORMAL!!
C  GET THE ORIGINAL
C
 2350 AL(JF)=FLOAT(IB(1))*10.0**IDIV(1)
      AS(JF)=FLOAT(IB(2))*10.0**IDIV(2)
      BL(JF)=FLOAT(IB(3))*10.0**IDIV(3)
      BS(JF)=FLOAT(IB(4))*10.0**IDIV(4)
      CL(JF)=FLOAT(IB(5))*10.0**IDIV(5)
      IF(IC.NE.6) GO TO 3000
      GO TO 100
 2800 CALL ATREC
      NAT=0
      DO 2805 I=1,80
      N(I)=KSP
 2805 CONTINUE
      DO 2810 I=1,NK
      K=NW(I)/100
      J=NW(I)-100*K
      IF (K.GT.0) N(I)=LETT(K)
      IF (J.GT.0) N(I+40)=LETT(J)
      NW(I)=NA(I)
      NO(I)=INT(AL(I)+BL(I)+CL(I)+DL(I)+EL(I)+0.5)
      IF(NO(I).NE.1) NAT=NAT+NA(I)
 2810 CONTINUE
      WRITE(LO,2820) (N(I),N(I+40),NA(I),NO(I),AL(I),AS(I),BL(I),BS(I),
     1 CL(I),CS(I),DL(I),DS(I),EL(I),I=1,NK)
 2820 FORMAT(//1H0,51X,18HUNIT CELL CONTENTS//
     1 1H ,4HATOM,4X,14HNUMBER IN CELL,4X,13HATOMIC NUMBER,4X,
     2 'SCATTERING FACTOR CONSTANTS',/,
     3' (F=AA*EXP(-A*RHO)+BB*EXP(-B*RHO)+CC*EXP(-C*RHO)+DD*EXP(-D*RHO)',
     4 '+EE)',/,
     5 (1H ,1X,2A1,I14,I17,9F8.3))
      DO 2830 I=1,142
      GIS(I)=0.0
 2830 CONTINUE
      IF(NGP.EQ.0) GO TO 2880
      NF=0
      DO 2870 I=1,NGP
      NS=NF+1
      NF=NF+NAG(I)
      WRITE(LO,2840) I,NAG(I),POP(I)
 2840 FORMAT(/1H0,11X,14HGROUP NUMBER =,I5,27X,
     1 26HNUMBER OF ATOMS IN GROUP =,I3,4X,14HMULTIPLICITY =,F5.1)
      IF(NINF(I).EQ.2) WRITE(LO,2842)
 2842 FORMAT(1H+,35X,17HRANDOMLY ORIENTED)
      IF(NINF(I).EQ.3) WRITE(LO,2843)
 2843 FORMAT(1H+,35X,18HCORRECTLY ORIENTED)
      IF(NINF(I).EQ.4) WRITE(LO,2844)
 2844 FORMAT(1H+,34X,20HCORRECTLY POSITIONED)
      IF(NINF(I).EQ.5) WRITE(LO,2845)
 2845 FORMAT(1H+,34X,19HFOR KARLE RECYCLING)
      IF(NINF(I).EQ.6) WRITE(LO,2846)
 2846 FORMAT(1H+,34X,20HFOR WEIGHTED FOURIER)
      IF(NINF(I).EQ.7) WRITE (LO,2847)
 2847 FORMAT(1H+,33X,22HFOR DIFFERENCE FOURIER)
      DO 2860 J=NS,NF
      K=NZ(J)
      IF(NINF(I).LE.2.OR.NINF(I).EQ.6) NA(K)=NA(K)-INT(POP(I)+0.5)
      WRITE(LO,2850) N(K),N(K+40),X(J),Y(J),Z(J)
 2850 FORMAT(1H ,36X,2A1,3F15.4)
 2860 CONTINUE
C     CALCULATE SPHERICALLY AVERAGED MOLECULAR SCATTERING FACTORS
      DO 2865 J=1,6
      F(J)=CR(J,I)
 2865 CONTINUE
      IF(NINF(I).EQ.2) CALL DEBYE(NS,NF,F,POP(I))
 2870 CONTINUE
C     CALCULATE WILSON (GIW) AND DEBYE (GIS) SCATTERING FACTORS
 2880 DO 2900 I=1,142
      T=0.01*FLOAT(I-1)
      TT=T*T
      GIW(I)=0.0
      DO 2890 J=1,NK
      FZ=AL(J)*EXP(-AS(J)*TT)+BL(J)*EXP(-BS(J)*TT)+CL(J)*EXP(-CS(J)*TT)
     1 + DL(J)*EXP(-DS(J)*TT)+EL(J)
      GIS(I)=GIS(I)+FZ*FZ*FLOAT(NA(J))
      GIW(I)=GIW(I)+FZ*FZ*FLOAT(NW(J))
 2890 CONTINUE
 2900 CONTINUE
      IF(JUMP.GE.0) IK=0
      RETURN
 3000 WRITE(LO,3010) N
 3010 FORMAT(14H ERROR IN LINE,5X,80A1)
      STOP
      END
C     ------------------------------------------------------------------
C     INPUT UNIT CELL PARAMETERS AND CALCULATE RECIPROCAL PARAMETERS
      SUBROUTINE INCELL
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      WRITE(LO,20) (CX(I),I=1,6)
   20 FORMAT(1H0,11HDIRECT CELL,9X,3HA =,F8.3,4X,3HB =,F8.3,4X,
     1 3HC =,F8.3,4X,7HALPHA =,F7.2,4X,6HBETA =,F7.2,4X,7HGAMMA =,F7.2)
      CALL VOL(CX,V)
C     VOLUME AND RECIPROCAL CELL FUNCTIONS
      V=1.0/(V*CX(1)*CX(2)*CX(3))
      P(1)=CX(2)*CX(3)*CX(7)*V
      P(2)=CX(1)*CX(3)*CX(8)*V
      P(3)=CX(1)*CX(2)*CX(9)*V
      P(4)=0.5*P(1)*P(2)*(CX(4)*CX(5)-CX(6))/(CX(7)*CX(8))
      P(5)=0.5*P(1)*P(3)*(CX(4)*CX(6)-CX(5))/(CX(7)*CX(9))
      P(6)=0.5*P(2)*P(3)*(CX(5)*CX(6)-CX(4))/(CX(8)*CX(9))
      DO 40 I=1,3
      P(I)=0.25*P(I)*P(I)
      CX(I+3)=180.0*ATAN2(CX(I+6),CX(I+3))/PI
   40 CONTINUE
      WRITE(LO,50) P
   50 FORMAT(6H0RHO =,F9.6,9H * H**2 +,F9.6,9H * K**2 +,F9.6,9H * L**2 +
     1 ,F9.6,10H * H * K +,F9.6,10H * H * L +,F9.6,8H * K * L)
      RETURN
      END
C     ------------------------------------------------------------------
C     SINE AND COSINE OF CELL ANGLES PLUS TRIGONOMETRIC PART OF VOLUME
      SUBROUTINE VOL(CX,V)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      DIMENSION CX(9)
      DTOR=PI/180.0
      ARG=1.0
      DO 10 I=4,6
      CX(I+3)=SIN(DTOR*CX(I))
      CX(I)=COS(DTOR*CX(I))
      ARG=ARG-CX(I)*CX(I)
   10 CONTINUE
      V=SQRT(ARG+2.0*CX(4)*CX(5)*CX(6))
      RETURN
      END
C     ------------------------------------------------------------------
C     READ GENERAL EQUIVALENT POSITIONS AS IN INTERNATIONAL TABLES AND
C     DETERMINE LATTICE MULTIPLICITY (PTS) AND CRYSTAL SYSTEM (KSYS)
      SUBROUTINE INSYM(N,KS)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT
      DIMENSION N(80),KX(15),LTC(7),ICAP(2),LINE(21)
      DATA KX/1H1,1H2,1H3,1H4,1H5,1H6,1HX,1HY,1HZ,1H ,1H,,1H+,1H-,1H/,
     1 1H*/
      DATA LTC/1HP,1HA,1HB,1HC,1HI,1HF,1HR/,ICAP/3HNON,3H   /
      IC=1
      ISN=1
      TRV=-1.0
      IN=1
   10 KS=MOD(KS+1,80)
      DO 100 I=KS,81
      IF(I.EQ.81) GO TO 40
      DO 20 J=1,15
      IF(N(I).EQ.KX(J)) GO TO 30
   20 CONTINUE
      ISN=100
      IF(IN.GE.2) GO TO 40
      NSYM=NSYM-1
      GO TO 105
   30 GO TO (90,90,90,90,90,90,80,80,80,100,40,100,60,100,40),J
C     END OF LINE, CHARACTER '*' OR NEW KEYWORD
   40 IF(IN.EQ.2) IS(2,IC,NSYM)=0
      IF(TRV.LT.0.0) TS(IC,NSYM)=0.0
      IN=1
      TRV=-1.0
      IC=IC+1
      IF(J.EQ.11) GO TO 100
      IF(ISN.GT.10) GO TO 105
      IC=1
      NSYM=NSYM+1
      GO TO 100
C     CHARACTER = '-'
   60 ISN=-1
      GO TO 100
C     CHARACTER = 'X', 'Y' OR 'Z'
   80 IS(IN,IC,NSYM)=ISN*(J-6)
      ISN=1
      IN=IN+1
      GO TO 100
C     CHARACTER = '1' TO '6'
   90 IF(TRV.LT.0.0) TRV=FLOAT(J)
      IF(TRV.GT.0.0) TS(IC,NSYM)=TRV/FLOAT(J)
  100 CONTINUE
      READ(LN,102) N
  102 FORMAT(80A1)
      KS=80
      GO TO 10
C     PREPARE 'FORMATTED' OUTPUT
  105 KS=I
      WRITE(LO,104) ICAP(ICENT+1),NSYM,LATT
  104 FORMAT(/1H0,17HTHE STRUCTURE IS ,A3,15HCENTROSYMMETRIC,8X,I3,3X,
     1 28HGENERAL EQUIVALENT POSITIONS,10X,18HLATTICE IS OF TYPE,3X,A1/)
      DO 200 ISYM=1,NSYM
      DO 110 I=1,21
      LINE(I)=KX(10)
  110 CONTINUE
      DO 170 IC=1,3
C     TRANSLATIONAL PART
      INC=7*IC-5
      IF(TS(IC,ISYM).LT.0.1) GO TO 120
      NUM=1
      IF(TS(IC,ISYM).GT.0.6) NUM=TS(IC,ISYM)/(1.0-TS(IC,ISYM))+0.1
      NOM=FLOAT(NUM)/TS(IC,ISYM)+0.1
      LINE(INC-1)=KX(NUM)
      LINE(INC)=KX(14)
      LINE(INC+1)=KX(NOM)
C     SYMBOLIC PART
  120 DO 160 IN=1,2
      INC=INC+2
      IF(IS(IN,IC,ISYM)) 130,160,140
C     NEGATIVE SYMBOL
  130 LINE(INC)=KX(13)
      GO TO 150
C     POSITIVE SYMBOL
  140 IF(IN.EQ.2.OR.TS(IC,ISYM).GT.0.1) LINE(INC)=KX(12)
C     'X', 'Y' OR 'Z'
  150 IARG=IABS(IS(IN,IC,ISYM))+6
      LINE(INC+1)=KX(IARG)
  160 CONTINUE
  170 CONTINUE
      WRITE(LO,180) (LINE(I),I=1,21)
  180 FORMAT(1H ,32X,3(7X,3A1,1X,A1,1X,A1,1X,A1,1X,A1))
  200 CONTINUE
C     DETERMINE LATTICE MULTIPLICITY
C     PRIMITIVE
      PTS=1.0
      DO 250 I=1,7
      IF(LATT.EQ.LTC(I)) GO TO 260
  250 CONTINUE
      STOP
  260 LATT=I
      IF(LATT.EQ.7) GO TO 300
C     A, B, C OR I CENTRED
      IF(LATT.NE.1) PTS=2.0
C     F CENTRED
      IF(LATT.EQ.6) PTS=4.0
      GO TO 400
  300 DO 310 I=1,NSYM
C     PRIMITIVE RHOMBOHEDRAL  (PTS=1.0)
      IF(IABS(IS(1,1,I)).EQ.3) GO TO 400
  310 CONTINUE
C     CENTRED HEXAGONAL
      PTS=3.0
C     DETERMINE CRYSTAL SYSTEM
  400 DO 450 I=1,2
      DO 440 J=1,NSYM
      DO 430 IN=1,2
      IF(IABS(IS(IN,1,J)).EQ.4-I) GO TO 460
  430 CONTINUE
  440 CONTINUE
  450 CONTINUE
C     1 - TRICLINIC, 2 - MONOCLINIC, 3 - ORTHORHOMBIC
      KSYS=MIN0(NSYM,3)
      GO TO 500
  460 IF(I.EQ.1) GO TO 480
C     TETRAGONAL
      KSYS=4
      IF(NSYM.EQ.4.OR.NSYM.EQ.8) GO TO 500
C     TRIGONAL OR RHOMBOHEDRAL INDEXED ON HEXAGONAL AXES
      KSYS=5
C     TEST FOR 6-FOLD AXIS - GENERAL FORM -X, -Y, Z + T
      DO 470 J=2,NSYM
      IF(IABS(IS(1,1,J)).GT.1.OR.IABS(IS(2,1,J)).GT.1) GO TO 470
      IF(IABS(IS(1,2,J)).EQ.1.OR.IABS(IS(2,2,J)).EQ.1) GO TO 470
C     HEXAGONAL
      KSYS=6
  470 CONTINUE
      GO TO 500
C     CUBIC
  480 KSYS=8
C     PRIMITIVE RHOMBOHEDRAL
      IF(LATT.EQ.7) KSYS=7
      IF(KSYS.EQ.7) LATT=1
  500 RETURN
      END
C     ------------------------------------------------------------------
C     INPUT INFORMATION ABOUT CELL CONTENTS AND MOLECULAR FRAGMENTS
C     CALCULATE SPHERICAL SCATTERING FACTORS
      SUBROUTINE ATREC
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      DIMENSION ALT(100),AST(100),BLT(100),BST(100),CLT(100),N1(100)
      DIMENSION CST(100),DLT(100),DST(100),ELT(100)
      DATA ALT /
     *   0.388   ,   0.873400,   1.56    ,   1.261   ,   1.207   ,
     *   2.112   ,   3.188   ,   4.197   ,   5.155   ,   3.95530 ,
     *   7.448   ,   7.426   ,   7.276   ,   6.988   ,   6.509   ,
     *   5.967   ,   5.557   ,   7.48450 ,   8.21860 ,   8.62660 ,
     *   9.18900 ,   9.75950 ,  10.2971  ,   10.6406 ,  11.2819  ,
     *  11.7695  ,  12.2841  ,  12.8376  ,  13.3380  ,  14.0743  ,
     *  15.2354  ,  16.0816  ,  16.6723  ,  17.0006  ,  17.1789  ,
     *  17.3555  ,  17.1784  ,  17.5663  ,  17.7760  ,  17.8765  ,
     *  17.6142  ,   3.70250 ,  19.1301  ,  19.2674  ,  19.2957  ,
     *  19.3319  ,  19.2808  ,  19.2214  ,  19.1624  ,  19.1889  ,
     *  19.6418  ,  19.9644  ,  20.1472  ,  20.2933  ,  20.3892  ,
     *  20.3361  ,  20.5780  ,  21.1671  ,  22.0440  ,  22.6845  ,
     *  23.3405  ,  24.0042  ,  24.6274  ,  25.0709  ,  25.8976  ,
     *  26.5070  ,  26.9049  ,  27.6563  ,  28.1819  ,  28.6641  ,
     *  28.9476  ,  29.1440  ,  29.2024  ,  29.0818  ,  28.7621  ,
     *  28.1894  ,  27.3049  ,  27.0059  ,  16.8819  ,  20.6809  ,
     *  27.5446  ,  31.0617  ,  33.3689  ,  34.6726  ,  35.3163  ,
     *  35.5631  ,  35.9299  ,  35.7630  ,  35.6597  ,  35.5645  ,
     *  35.8847  ,  36.0228  ,  36.1874  ,  36.5254  ,  36.6706  ,
     *  36.6488  ,  36.7881  ,  36.9185  ,   0.0     ,   0.0     /
      DATA AST /
     *   7.151   ,   9.10370 ,   3.264   ,   2.620   ,   5.745   ,
     *   7.827   ,   7.341   ,   6.327   ,   5.392   ,   8.40420 ,
     *   4.821   ,   3.770   ,   3.143   ,   2.739   ,   2.602   ,
     *   2.753   ,   3.176   ,   0.907200,  12.7949  ,  10.4421  ,
     *   9.02130 ,   7.85080 ,   6.86570 ,   6.10380 ,   5.34090 ,
     *   4.76110 ,   4.27910 ,   3.87850 ,   3.58280 ,   3.26550 ,
     *   3.06690 ,   2.85090 ,   2.63450 ,   2.40980 ,   2.17230 ,
     *   1.93840 ,   1.78880 ,   1.55640 ,   1.40290 ,   1.27618 ,
     *   1.18865 ,   0.277200,   0.864132,   0.808520,   0.751536,
     *   0.698655,   0.644600,   0.594600,   0.547600,   5.83030 ,
     *   5.30340 ,   4.81742 ,   4.34700 ,   3.92820 ,   3.56900 ,
     *   3.21600 ,   2.94817 ,   2.81219 ,   2.77393 ,   2.66248 ,
     *   2.56270 ,   2.47274 ,   2.38790 ,   2.25341 ,   2.24256 ,
     *   2.18020 ,   2.07051 ,   2.07356 ,   2.02859 ,   1.98890 ,
     *   1.90182 ,   1.83262 ,   1.77333 ,   1.72029 ,   1.67191 ,
     *   1.62903 ,   1.59279 ,   1.51293 ,   0.461100,   0.545000,
     *   0.655150,   0.690200,   0.704000,   0.700999,   0.685870,
     *   0.663100,   0.646453,   0.616341,   0.589092,   0.563359,
     *   0.547751,   0.529300,   0.511929,   0.499384,   0.483629,
     *   0.465154,   0.451018,   0.437533,   0.0     ,   0.0     /
      DATA BLT/
     *   0.601   ,   0.630900,   1.059   ,   2.008   ,   2.530   ,
     *   2.462   ,   2.305   ,   2.218   ,   2.172   ,   3.11250 ,
     *   1.280   ,   2.267   ,   3.192   ,   4.169   ,   5.107   ,
     *   5.925   ,   6.573   ,   6.77230 ,   7.43980 ,   7.38730 ,
     *   7.36790 ,   7.35580 ,   7.35110 ,   7.35370 ,   7.35730 ,
     *   7.35730 ,   7.34090 ,   7.29200 ,   7.16760 ,   7.03180 ,
     *   6.70060 ,   6.37470 ,   6.07010 ,   5.81960 ,   5.23580 ,
     *   6.72860 ,   9.64350 ,   9.81840 ,  10.2946  ,  10.9480  ,
     *  12.0144  ,  17.2356  ,  11.0948  ,  12.9182  ,  14.3501  ,
     *  15.5017  ,  16.6885  ,  17.6444  ,  18.5596  ,  19.1005  ,
     *  19.0455  ,  19.0138  ,  18.9949  ,  19.0298  ,  19.1062  ,
     *  19.2970  ,  19.5990  ,  19.7695  ,  19.6697  ,  19.6847  ,
     *  19.6095  ,  19.4258  ,  19.0886  ,  19.0798  ,  18.2185  ,
     *  17.6383  ,  17.2940  ,  16.4285  ,  15.8851  ,  15.4345  ,
     *  15.2208  ,  15.1726  ,  15.2293  ,  15.4300  ,  15.7189  ,
     *  16.1550  ,  16.7296  ,  17.7639  ,  18.5913  ,  19.0417  ,
     *  19.1584  ,  13.0637  ,  12.9510  ,  15.4733  ,  19.0211  ,
     *  21.2816  ,  23.0547  ,  22.9064  ,  23.1032  ,  23.4219  ,
     *  23.2948  ,  23.4128  ,  23.5964  ,  23.8083  ,  24.0992  ,
     *  24.4096  ,  24.7736  ,  25.1995  ,   0.0     ,   0.0     /
      DATA BST /
     *  30.18    ,   3.35680 ,  108.3    ,   54.77   ,  38.23    ,
     *  31.65    ,  26.84    ,  22.83    ,   19.61   ,   3.42620 ,
     *  96.71    ,  69.72    ,  55.67    ,  43.28    ,  34.46    ,
     *  28.44    ,  24.26    ,  14.8407  ,   0.774800,   0.659900,
     *   0.572900,   0.500000,   0.438500,   0.392000,   0.343200,
     *   0.307200,   0.278400,   0.256500,   0.247000,   0.233300,
     *   0.241200,   0.251600,   0.264700,   0.272600,  16.5796  ,
     *  16.5623  ,  17.3151  ,  14.0988  ,  12.8006  ,  11.9160  ,
     *  11.7660  ,   1.09580 ,   8.14487 ,   8.43467 ,   8.21758 ,
     *   7.98929 ,   7.47260 ,   6.90890 ,   6.37760 ,   0.503100,
     *   0.460700,   0.420885,   0.381400,   0.344000,   0.310700,
     *   0.275600,   0.244475,   0.226836,   0.222087,   0.210628,
     *   0.202088,   0.196451,   0.194200,   0.181951,   0.196143,
     *   0.202172,   0.197940,   0.223545,   0.238849,   0.257119,
     *   9.98519 ,   9.59990 ,   9.37046 ,   9.22590 ,   9.09227 ,
     *   8.97948 ,   8.86553 ,   8.81174 ,   8.62160 ,   8.44840 ,
     *   8.70751 ,   2.35760 ,   2.92380 ,   3.55078 ,   3.97458 ,
     *   4.06910 ,   4.17619 ,   3.87135 ,   3.65155 ,   3.46204 ,
     *   3.41519 ,   3.32530 ,   3.25396 ,   3.26371 ,   3.20647 ,
     *   3.08997 ,   3.04619 ,   3.00775 ,   0.0     ,   0.0     /
      DATA CLT /
     *   0.0     ,   0.311200,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   1.45460 ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   0.653900,   1.05190 ,   1.58990 ,
     *   1.64090 ,   1.69910 ,   2.07030 ,   3.32400 ,   3.01930 ,
     *   3.52220 ,   4.00340 ,   4.44380 ,   5.61580 ,   5.16520 ,
     *   4.35910 ,   3.70680 ,   3.43130 ,   3.97310 ,   5.63770 ,
     *   5.54930 ,   5.13990 ,   5.42200 ,   5.72629 ,   5.41732 ,
     *   4.04183 ,  12.8876  ,   4.64901 ,   4.86337 ,   4.73425 ,
     *   5.29537 ,   4.80450 ,   4.46100 ,   4.29480 ,   4.45850 ,
     *   5.03710 ,   6.14487 ,   7.51380 ,   8.97670 ,  10.6620  ,
     *  10.8880  ,  11.3727  ,  11.8513  ,  12.3856  ,  12.7740  ,
     *  13.1235  ,  13.4396  ,  13.7603  ,  13.8518  ,  14.3167  ,
     *  14.5596  ,  14.5583  ,  14.9779  ,  15.1542  ,  15.3087  ,
     *  15.1000  ,  14.7586  ,  14.5135  ,  14.4327  ,  14.5564  ,
     *  14.9305  ,  15.6115  ,  15.7131  ,  25.5582  ,  21.6575  ,
     *  15.5380  ,  18.4420  ,  16.5877  ,  13.1138  ,   9.49887 ,
     *   8.00370 ,  12.1439  ,  12.4739  ,  12.5977  ,  12.7473  ,
     *  14.1891  ,  14.9491  ,  15.6402  ,  16.7707  ,  17.3415  ,
     *  17.3990  ,  17.8919  ,  18.3317  ,   0.0     ,   0.0     /
      DATA CST /
     *   0.0     ,  22.9276  ,  0.0      , 0.0       ,  0.0      ,
     *   0.0     ,  0.0      ,   0.0     ,   0.0     ,   0.230600,
     *   0.0     ,   0.0     ,  0.0      ,   0.0     ,   0.0     ,
     *   0.0     ,  0.0      ,  43.8983  , 213.187   ,  85.7484  ,
     * 136.108   ,  35.6338  ,  26.8938  ,  20.2626  ,  17.8674  ,
     *  15.3535  ,  13.5359  ,  12.1763  ,  11.3966  ,  10.3163  ,
     *  10.7805  ,  11.4468  ,  12.9479  ,  15.2372  ,   0.260900,
     *   0.226100,   0.274800,   0.166400,   0.125599,   0.117622,
     *   0.204785,  11.0040  ,  21.5707  ,  24.7997  ,  25.8749  ,
     *  25.2052  ,  24.6605  ,  24.7008  ,  25.8499  ,  26.8909  ,
     *  27.9074  ,  28.5284  ,  27.7660  ,  26.4659  ,  24.3879  ,
     *  20.2073  ,  18.7726  ,  17.6083  ,  16.7669  ,  15.8850  ,
     *  15.1009  ,  14.3996  ,  13.7546  ,  12.9331  ,  12.6648  ,
     *  12.1899  ,  11.4407  ,  11.3604  ,  10.9975  ,  10.6647  ,
     *   0.261033,   0.275116,   0.295977,   0.321703,   0.350500,
     *   0.382661,   0.417916,   0.424593,   1.48260 ,   1.57290 ,
     *   1.96347 ,   8.61800 ,   8.79370 ,   9.55642 ,  11.3824  ,
     *  14.0422  ,  23.1052  ,  19.9887  ,  18.5990  ,  17.8309  ,
     *  16.9235  ,  16.0927  ,  15.3622  ,  14.9455  ,  14.3136  ,
     *  13.4346  ,  12.8946  ,  12.4044  ,   0.0     ,   0.0     /
      DATA DLT /
     *   0.0     ,   0.178000,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   1.12510 ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   1.64420 ,   0.865900,   1.02110 ,
     *   1.46800 ,   1.90210 ,   2.05710 ,   1.49220 ,   2.24410 ,
     *   2.30450 ,   2.34880 ,   2.38000 ,   1.67350 ,   2.41000 ,
     *   2.96230 ,   3.68300 ,   4.27790 ,   4.35430 ,   3.98510 ,
     *   3.53750 ,   1.52920 ,   2.66940 ,   3.26588 ,   3.65721 ,
     *   3.53346 ,   3.74290 ,   2.71263 ,   1.56756 ,   1.28918 ,
     *   0.605844,   1.04630 ,   1.60290 ,   2.03960 ,   2.46630 ,
     *   2.68270 ,   2.52390 ,   2.27350 ,   1.99000 ,   1.49530 ,
     *   2.69590 ,   3.28719 ,   3.33049 ,   2.82428 ,   2.85137 ,
     *   2.87516 ,   2.89604 ,   2.92270 ,   3.54545 ,   2.95354 ,
     *   2.96577 ,   3.63837 ,   2.98233 ,   2.98706 ,   2.98963 ,
     *   3.71601 ,   4.30013 ,   4.76492 ,   5.11982 ,   5.44174 ,
     *   5.67589 ,   5.83377 ,   5.78370 ,   5.86000 ,   5.96760 ,
     *   5.52593 ,   5.96960 ,   6.46920 ,   7.02588 ,   7.42518 ,
     *   7.44330 ,   2.11253 ,   3.21097 ,   4.08655 ,   4.80703 ,
     *   4.17287 ,   4.18800 ,   4.18550 ,   3.47947 ,   3.49331 ,
     *   4.21665 ,   4.23284 ,   4.24391 ,   0.0     ,   0.0     /
      DATA DST /
     *  0.0      ,   0.982100, 0.0       ,   0.0     ,   0.0     ,
     *  0.0      ,   0.0     ,  0.0      ,  0.0      ,  21.7184  ,
     * 0.0       ,   0.0     ,  0.0      ,  0.0      ,  0.0      ,
     *  0.0      ,  0.0      ,  33.3929  ,  41.6841  , 178.437   ,
     *  51.3531  , 116.105   , 102.478   ,  98.7399  ,  83.7543  ,
     *  76.8805  ,  71.1692  ,  66.3421  ,  64.8126  ,  58.7097  ,
     *  61.4135  ,  54.7625  ,  47.7972  ,  43.8163  ,  41.4328  ,
     *  39.3972  , 164.934   , 132.376   , 104.354   ,  87.6627  ,
     *  69.7957  ,  61.6584  ,  86.8472  ,  94.2928  ,  98.6062  ,
     *  76.8986  ,  99.8156  ,  87.4825  ,  92.8029  ,  83.9571  ,
     *  75.2825  ,  70.8403  ,  66.8776  ,  64.2658  , 213.904   ,
     * 167.202   , 133.124   , 127.113   , 143.644   , 137.903   ,
     * 132.721   , 128.007   , 123.174   , 101.398   , 115.362   ,
     * 111.874   ,  92.6566  , 105.703   , 102.961   , 100.417   ,
     *  84.3298  ,  72.0290  ,  63.3644  ,  57.0560  ,  52.0861  ,
     *  48.1647  ,  45.0011  ,  38.6103  ,  36.3956  ,  38.3246  ,
     *  45.8149  ,  47.2579  ,  48.0093  ,  47.0045  ,  45.4715  ,
     *  44.2473  , 150.645   , 142.325   , 117.020   ,  99.1722  ,
     * 105.251   , 100.613   ,  97.4908  , 105.980   , 102.273   ,
     *  88.4834  ,  86.0030  ,  83.7881  ,   0.0     ,   0.0     /
      DATA ELT /
     *   0.008   ,   0.006400,   0.3747  ,   0.7163  ,   1.243   ,
     *   1.412   ,  1.498    ,   1.578   ,   1.668   ,   0.351500,
     *   2.216   ,   2.291   ,   2.491   ,   2.801   ,   3.343   ,
     *   4.073   ,   4.839   ,   1.44450 ,   1.42280 ,   1.37510 ,
     *   1.33290 ,   1.28070 ,   1.21990 ,   1.18320 ,   1.08960 ,
     *   1.03690 ,   1.01180 ,   1.03410 ,   1.19100 ,   1.30410 ,
     *   1.71890 ,   2.13130 ,   2.53100 ,   2.84090 ,   2.95570 ,
     *   2.82500 ,   3.48730 ,   2.50640 ,   1.91213 ,   2.06929 ,
     *   3.75591 ,   4.38750 ,   5.40428 ,   5.37874 ,   5.32800 ,
     *   5.26593 ,   5.17900 ,   5.06940 ,   4.93910 ,   4.78210 ,
     *   4.59090 ,   4.35200 ,   4.07120 ,   3.71180 ,   3.33520 ,
     *   2.77310 ,   2.14678 ,   1.86264 ,   2.05830 ,   1.98486 ,
     *   2.02876 ,   2.20963 ,   2.57450 ,   2.41960 ,   3.58324 ,
     *   4.29728 ,   4.56796 ,   5.92046 ,   6.75621 ,   7.56672 ,
     *   7.97628 ,   8.58154 ,   9.24354 ,   9.88750 ,  10.4720  ,
     *  11.0005  ,  11.4722  ,  11.6883  ,  12.0658  ,  12.6089  ,
     *  13.1746  ,  13.4118  ,  13.5782  ,  13.6770  ,  13.7108  ,
     *  13.6905  ,  13.7247  ,  13.6211  ,  13.5266  ,  13.4314  ,
     *  13.4287  ,  13.3966  ,  13.3573  ,  13.3812  ,  13.3592  ,
     *  13.2887  ,  13.2754  ,  13.2674  ,   0.0     ,   0.0     /
      DATA N1/8,805,1209,205,2,3,14,15,6,1405,1401,1307,112,1909, 
     1 16,19,312,107,11,301,1903,2009,22,318,1314,605,315,1409,321,
     2 2614,701,705,119,1905,218,1118,1802,1918,25,2618,1402,1317,
     3 2003,1821,1808,1604,107,304,914,1914,1902,2005,9,2405,319,
     4 201,1201,305,1618,1404,1613,1913,521,704,2002,425,815,518,
     5 2013,2502,1921,806,2001,23,1805,1519,918,1620,121,807,2012,
     6 1602,209,1615,120,1814,618,1801,103,2008,1601,21,1416,1621,
     7 113,313,211,306,519,613/
C
C**** ATOMIC SCATTERING FACTORS FOR ABOVE ATOM TYPES 
C****     F=AL*EXP(-AS*RHO)+BL*EXP(-BS*RHO)+CL*EXP(-CS*RHO)+
C    + DL*EXP(-DS*RHO)+EL
      DO 150 I=1,NK
C
C**** CHECK ATOM TYPE
C CHANGED TO INT. TABLES EXPRESIONS
C
      DO 120 J=1,100
      IF(NW(I).NE.N1(J)) GO TO 120 
      AS(I)=AST(J) 
      AL(I)=ALT(J)
      BS(I)=BST(J)
      BL(I)=BLT(J)
      CL(I)=CLT(J)
      CS(I)=CST(J)
      DL(I)=DLT(J)
      DS(I)=DST(J)
      EL(I)=ELT(J)
      GO TO 150
  120 CONTINUE   
  150 CONTINUE
      RETURN
      END
C     ------------------------------------------------------------------
C     CALCULATE SCATTERING FACTORS FOR RANDOM GROUPS  (NINF = 2)
      SUBROUTINE DEBYE(NMEM,NTOT,CR,POP)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF
      DIMENSION G(142),CR(9)
      FP=4.0*PI
      IF(CR(1).LT.0.01) GO TO 15
      WRITE(LO,5) (CR(I),I=1,6)
    5 FORMAT(36H GIVEN COORDINATES REFER TO THE CELL,2X,4H A =,F6.2,
     1 2X,3HB =,F6.2,2X,3HC =,F6.2,2X,7HALPHA =,F6.1,2X,6HBETA =,
     2 F6.1,2X,7HGAMMA =,F6.1)
C     CONVERT TO ORTHOGONAL COORDINATES
      CALL VOL(CR,V)
      R1=CR(3)*(CR(4)-CR(5)*CR(6))/CR(9)
      R2=CR(3)*V/CR(9)
      DO 10 I=NMEM,NTOT
      X(I)=CR(1)*X(I)+CR(2)*CR(6)*Y(I)+CR(3)*CR(5)*Z(I)
      Y(I)=CR(2)*CR(9)*Y(I)+R1*Z(I)
      Z(I)=R2*Z(I)
   10 CONTINUE
   15 D=1.0
      DO 100 I=1,142
      G(I)=0.0
      T=0.01*FLOAT(I-1)
      TT=T*T
      DO 20 J=1,NK
      F(J)=AL(J)*EXP(-AS(J)*TT)+BL(J)*EXP(-BS(J)*TT)+CL(J)*EXP(-CS(J)
     1 *TT)+DL(J)*EXP(-DS(J)*TT)+EL(J)
   20 CONTINUE
C     SUM OVER INTERATOMIC VECTORS
      DO 50 K=NMEM,NTOT
      KT=NZ(K)
      NT=K+1
      G(I)=G(I)+F(KT)*F(KT)
      IF(K.EQ.NTOT) GO TO 50
      DO 40 L=NT,NTOT
      LT=NZ(L)
      IF(I.EQ.1) GO TO 30
      D=FP*T*SQRT((X(K)-X(L))**2+(Y(K)-Y(L))**2+(Z(K)-Z(L))**2)
      D=SIN(D)/D
   30 G(I)=G(I)+2.0*F(KT)*F(LT)*D
   40 CONTINUE
   50 CONTINUE
      G(I)=SQRT(G(I))
  100 CONTINUE
      WRITE(LO,120) (G(I),I=1,101,2)
  120 FORMAT(1H0,26X,66HGROUP SCATTERING FACTORS AT INTERVALS OF 0.02 IN
     1 SIN(THETA)/LAMBDA/(1H ,17F7.2))
      DO 140 I=1,142
      GIS(I)=GIS(I)+G(I)*G(I)*POP
  140 CONTINUE
      RETURN
      END
C     ------------------------------------------------------------------
C     USER SUPPLIED SUBROUTINE TO READ IN LOCAL STANDARD TAPE
C     THE SUPPLIED SUBROUTINE READS THE YORK DATA TAPE
      SUBROUTINE TAPEIN
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      DIMENSION IKL(60),F(60),SIGMA(60)
      REWIND ISTAN
      K=0
C     READ YORK DATA TAPE
   10 READ(ISTAN) IKL,F,SIGMA,SIGMA
C     FILL ARRAYS LH, LK, LL, FO AND SIG WITH 60 REFLEXIONS
      DO 20 I=1,60
      K=K+1
      FO(K)=-1.0
C     TAPE ENDS WITH REFLEXION 000 (IKL = 32896)
      IF(IKL(I).EQ.32896) GO TO 30
C     UNPACK IKL
      IND=IKL(I)
      LH(K)=IND/65536
      IF(IND.LT.0) LH(K)=LH(K)-1
      IND=IND-65536*LH(K)
      LK(K)=IND/256
      LL(K)=IND-256*LK(K)-128
      LK(K)=LK(K)-128
      FO(K)=F(I)
C     SIG .LT. 0.0 FOR UNOBSERVED REFLEXIONS
      SIG(K)=SIGMA(I)
      IF(K.NE.60) GO TO 20
C     CALCULATE RHO, EPSILON, MULTIPLICITY, SCATTERING FACTOR AND
C     CREATE SCRATCH FILE
      CALL FCAL
      K=0
   20 CONTINUE
      GO TO 10
   30 CALL FCAL
      RETURN
      END
C     ------------------------------------------------------------------
C     READ REFLEXIONS FROM CARD INPUT
      SUBROUTINE CARDIN
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      DIMENSION IFORM(20),KH(12),KK(12),KL(12),F(12),KD(12)
      READ(LN,5) IFORM
    5 FORMAT(20A4)
      K=0
      NN=IABS(NPC)
   10 READ(LN,IFORM,END=30) (KH(I),KK(I),KL(I),F(I),KD(I),I=1,NN)
      DO 20 I=1,NN
      K=K+1
      LH(K)=KH(I)
      LK(K)=KK(I)
      LL(K)=KL(I)
      FO(K)=F(I)
      SIG(K)=FLOAT(1-2*KD(I))
      IF(F(I).LT.0.0) GO TO 30
      IF(K.NE.60) GO TO 20
C     CALCULATE RHO, EPSILON, MULTIPLICITY, SCATTERING FACTOR AND
C     CREATE SCRATCH FILE
      CALL FCAL
      K=0
   20 CONTINUE
      GO TO 10
   30 CALL FCAL
      RETURN
      END
C     ------------------------------------------------------------------
C     CALCULATE RHO, EPSILON, MULTIPLICITY AND SCATTERING FACTOR
C     FOR EACH REFLEXION AND CREATE THE SCRATCH TAPE (ISCRA)
C     PREPARE FILE FOR WEIGHTED FOURIER
      SUBROUTINE FCAL
      DIMENSION I1(3),I2(3)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
C     BESSEL FUNCTION I1/I0
      VEC(U)=U*(U+0.4807)/((U+0.8636)*U+1.3943)
      DO 300 I=1,60
      IF(FO(I).LT.0.0) GO TO 310
      NREF=NREF+1
      RHO(I)=P(1)*FLOAT(LH(I)*LH(I))+P(2)*FLOAT(LK(I)*LK(I))
     1 +P(3)*FLOAT(LL(I)*LL(I))+P(4)*FLOAT(LH(I)*LK(I))
     2 +P(5)*FLOAT(LH(I)*LL(I))+P(6)*FLOAT(LK(I)*LL(I))
      RHOMAX=AMAX1(RHOMAX,RHO(I))
C     COMPUTE EPSILON AND MULTIPLICITY BY GENERATING EQUIVALENT
C     REFLEXIONS
C     EPSILON = NUMBER OF TIMES SAME REFLEXION APPEARS IN LIST
C     MULTIPLICITY = NUMBER DIFFERENT REFLEXIONS IN LIST
      EPS=1.0
      MULT=1
      I1(1)=LH(I)
      I1(2)=LK(I)
      I1(3)=LL(I)
C     IN TRICLINIC SPACE GROUPS EPS = 1.0 AND MULT = 1
      IF(NSYM.EQ.1) GO TO 60
      K1=65536*I1(1)+256*(I1(2)+128)+I1(3)+128
      IK1=65792-K1
      DO 50 J=2,NSYM
      DO 10 L=1,3
   10 I2(L)=0
      DO 40 L=1,3
      DO 30 K=1,2
      M=IABS(IS(K,L,J))
      IF(M.GT.0) I2(M)=I2(M)+I1(L)*ISIGN(1,IS(K,L,J))
   30 CONTINUE
   40 CONTINUE
      K2=65536*I2(1)+256*(I2(2)+128)+I2(3)+128
      IF(K2.EQ.K1) EPS=EPS+1.0
      IF(ICENT.NE.0.AND.K2.EQ.IK1) EPS=EPS+1.0
      IF(K2.EQ.K1.OR.K2.EQ.IK1) MULT=MULT+1
   50 CONTINUE
   60 FF=FO(I)*FO(I)/PTS
      ID(I)=NSYM/MULT
C     DETERMINE INDEX GROUP (FOR RESCALING)
      IF(KSYS.GE.7) GO TO 90
      LG=MOD(IABS(LL(I)),2)
      IF(KSYS.GE.5) GO TO 80
      KG=MOD(IABS(LK(I)),2)
      JG=MOD(IABS(LH(I)),2)
C     TRICLINIC, MONCLINIC AND ORTHORHOMBIC
      IF(KSYS.LE.3) IG=JG+2*KG+4*LG
C     TETRAGONAL
      IF(KSYS.EQ.4) IG=JG+KG+3*LG
      GO TO 100
C     TRIGONAL, HEXAGONAL AND RHOMBOHEDRAL INDEXED ON HEXAGONAL AXES
   80 IG=3*LG
      IF(MOD(LH(I),3).EQ.0) IG=IG+1
      IF(MOD(LK(I),3).EQ.0.OR.MOD(LH(I)+LK(I),3).EQ.0) IG=IG+1
      GO TO 100
C     CUBIC AND PRIMITIVE RHOMBOHEDRAL
   90 IG=3*MOD(IABS(LH(I)+LK(I)+LL(I)),2)
      IF(MOD(LH(I)-LL(I),3).EQ.0) IG=IG+1
      IF(MOD(LK(I)-LL(I),3).EQ.0.OR.MOD(LH(I)-LK(I),3).EQ.0) IG=IG+1
C     PACK SYMMETRY FUNCTIONS FOR LATER USE
  100 ID(I)=10000*ID(I)+100*INT(EPS+0.5)+IG+1
C     LOOK UP SCATTERING FACTOR TABLES GENERATED BY ATREC
      SINTH=100.0*SQRT(RHO(I))
      IND=MAX0(2,INT(SINTH+1.5))
      FRAC=SINTH-FLOAT(IND-1)
      BF=0.5*(GIW(IND+1)-GIW(IND-1))
      AF=BF+GIW(IND-1)-GIW(IND)
      FORM=AF*FRAC*FRAC+BF*FRAC+GIW(IND)
C     'WILSON' STRUCTURE FACTOR
      EW(I)=FF/(FORM*EPS)
      BF=0.5*(GIS(IND+1)-GIS(IND-1))
      AF=BF+GIS(IND-1)-GIS(IND)
      FORM=AF*FRAC*FRAC+BF*FRAC+GIS(IND)
C     'DEBYE' STRUCTURE FACTOR
      ED(I)=FF/(FORM*EPS)
      IF(IK.EQ.-1) ED(I)=FF
      IF(NDIFF.NE.1) GO TO 300
      NS=1
C     PHASES FOR WEIGHTED E-MAP
      DO 110 IGP=1,NGP
      NF=NS+NAG(IGP)-1
      IF(NINF(IGP).GT.5) GO TO 120
      NS=NF+1
  110 CONTINUE
  120 REL=0.0
      RIM=0.0
      IENT=0
      DO 160 J=1,NSYM
      T=1000.0
      DO 130 L=1,3
      T=T+FLOAT(I1(L))*TS(L,J)
      I2(L)=0
  130 CONTINUE
      DO 150 L=1,3
      DO 140 K=1,2
      M=IABS(IS(K,L,J))
      IF(M.GT.0) I2(M)=I2(M)+I1(L)*ISIGN(1,IS(K,L,J))
  140 CONTINUE
  150 CONTINUE
      CALL SFAC(NS,NF,I2,T,RHO(I),A,B,IENT)
      IENT=1
      REL=REL+A
      IF(ICENT.EQ.0) RIM=RIM+B
      IF(ICENT.EQ.1) REL=REL+A
  160 CONTINUE
C     SIM WEIGHTING SCHEME
      FCL=PTS*SQRT(REL*REL+RIM*RIM)
      SIG(I)=FCL*EXP(-BT*RHO(I))
      XKAP=2.0*SC*FO(I)*SIG(I)/FORM
      IF (ICENT.EQ.0) WATE = VEC(XKAP)
      IF (ICENT.EQ.1) WATE = TANH(XKAP/2.0)
      FOBS = SC * EXP(BT * RHO(I)) * FO(I)
      COEFF = 0.0
      IF (FCL.LT.0.00001) GOTO 200
      IF (NINF(IGP).EQ.6) COEFF = FOBS * WATE / FCL
      IF (NINF(IGP).EQ.7) COEFF = (FOBS * WATE - FCL) / FCL
  200 EW(I)=REL*COEFF
      ED(I)=RIM*COEFF
      EN=EN+SIG(I)
      ER=ER+FO(I)
  300 CONTINUE
      I=60
C     CREATE SCRATCH TAPE
  310 IF(NDIFF.EQ.0) WRITE(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG
C     CREATE FILE FOR WEIGHTED FOURIER
      IF(FO(I).LT.0.0) LH(I)=-1000
      IF(NDIFF.EQ.1) WRITE(ISCRA) LH,LK,LL,EW,ED,FO,SIG
      RETURN
      END
C     ------------------------------------------------------------------
C     STRUCTURE FACTOR CALCULATION
      SUBROUTINE SFAC(NS,NF,L,T,RHO,A,B,IENT)
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)
      COMMON/TRIG/SINT(450)
      DIMENSION L(3),COST(360)
      EQUIVALENCE (SINT(91),COST(1))
      A=0.0
      B=0.0
      IF(IENT.EQ.1) GO TO 30
      DO 10 I=1,NK
      F(I)=AL(I)*EXP(-AS(I)*RHO)+BL(I)*EXP(-BS(I)*RHO)+CL(I)*EXP(-CS(I)*
     1RHO)+DL(I)*EXP(-DS(I)*RHO)+EL(I)
   10 CONTINUE
   30 HJ=FLOAT(L(1))
      HK=FLOAT(L(2))
      HL=FLOAT(L(3))
      DO 50 I=NS,NF
      N=NZ(I)
      ARG=AMOD(HJ*X(I)+HK*Y(I)+HL*Z(I)+T,1.0)
      IARG=INT(360.0*ARG+0.5)+1
      IF(IARG.EQ.361) IARG=1
      A=A+F(N)*COST(IARG)
      B=B+F(N)*SINT(IARG)
   50 CONTINUE
      RETURN
      END
C     ------------------------------------------------------------------
C     LEAST SQUARES PLOT, INCLUDING SUMMATION OVER NB RANGES OF RHO
      SUBROUTINE SUM(PTS)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
      DIMENSION SW(30),SD(30),SR(30),SI(30),NSUM(30)
      WRITE(LO,40)
   40 FORMAT(//1H0,20X,18HLEAST SQUARES PLOT//6H RANGE,6X,
     1 18HRHO=(SINTH/LAM)**2,6X,6HNUMBER,6X,8HMEAN RHO,7X,6HMEAN I,
     2 7X,23HMEAN EXP(-2*B*RHO)*E**2,3X,5HDEBYE,7X,6HWILSON)
C     SET INITIAL VALUES
      PP=0.0
      Q=0.0
      R=0.0
      S=0.0
      T=0.0
      NUMBER=0
      ADD=RHOMAX/FLOAT(NB)
      START=-ADD
      END=ADD
      RR=FLOAT(NB)/RHOMAX
      DO 50 I=1,30
      SW(I)=0.0
      SD(I)=0.0
      SR(I)=0.0
      SI(I)=0.0
      NSUM(I)=0
   50 CONTINUE
      REWIND ISCRA
C     READ SCRATCH TAPE
  100 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG
      DO 200 I=1,60
C     TAPE ENDS WITH FO .LT. 0.0
      IF(FO(I).LT.0.0) GO TO 250
C     N STORES RANGE OF RHO
      N=MIN0(INT(1.0+RR*RHO(I)),NB)
      MULT=ID(I)/10000
      IE=(ID(I)-10000*MULT)/100
      EPS=FLOAT(IE)
      TMUL=FLOAT(MULT)
C     WEIGHTED SUMS
C     NUMBER OF REFLEXIONS
      NSUM(N)=NSUM(N)+MULT
C     WILSON
      SW(N)=SW(N)+EW(I)*TMUL
C     DEBYE
      SD(N)=SD(N)+ED(I)*TMUL
C     RHO
      SR(N)=SR(N)+RHO(I)*TMUL
C     INTENSITY
      SI(N)=SI(N)+TMUL*FO(I)*FO(I)/(EPS*PTS)
  200 CONTINUE
      GO TO 100
  250 DO 300 I=1,NB
C     SMOOTH CURVE BY ADDING ADJACENT RANGES
      NUMBER=NUMBER+NSUM(I)
      NSUM(I)=NSUM(I)+NSUM(I+1)
      SW(I)=SW(I)+SW(I+1)
      SD(I)=SD(I)+SD(I+1)
      SR(I)=SR(I)+SR(I+1)
      SI(I)=SI(I)+SI(I+1)
C     CALCULATE WEIGHTED AVERAGES AND LOGS
      WT=FLOAT(NSUM(I))
      DIV=1.0/AMAX1(1.0,WT)
      ESQAV=SD(I)*DIV
      FLGD(I)=ALOG(ESQAV)
      AVI=SI(I)*DIV
      AVR(I)=SR(I)*DIV
      FLGW(I)=ALOG(SW(I)*DIV)
      START=START+ADD
      END=AMIN1(END+ADD,RHOMAX)
      WRITE(LO,280) I,START,END,NSUM(I),AVR(I),AVI,ESQAV,FLGD(I),FLGW(I)
  280 FORMAT(1H ,I3,F15.4,3H  -,F8.4,I11,F14.4,F14.1,F23.4,F15.4,F13.4)
C     COEFFICIENTS OF NORMAL EQUATIONS
      PP=PP+WT*AVR(I)*AVR(I)
      Q=Q+WT*AVR(I)
      R=R+WT*AVR(I)*FLGD(I)
      S=S+WT*FLGD(I)
      T=T+WT
  300 CONTINUE
      WRITE(LO,320) PP,Q,R,Q,T,S
  320 FORMAT(17H0NORMAL EQUATIONS/(1H ,E11.3,10H * SLOPE +,E11.3,
     1 14H * INTERCEPT =,E11.3))
C     LEAST SQUARES
      DIV=PP*T-Q*Q
      SLOPE=(R*T-Q*S)/DIV
      FLGK=(PP*S-Q*R)/DIV
      SC=EXP(-FLGK)
      BT=-0.5*SLOPE
      WRITE(LO,340) SLOPE,FLGK,BT,SC
  340 FORMAT(1H0,7HSLOPE =,F8.4,4X,11HINTERCEPT =,F8.4,4X,
     1 24HTEMPERATURE FACTOR (B) =,F8.4,4X,7HSCALE =,F8.4/
     2 51X,37HF(ABSOLUTE)**2 = SCALE*F(OBSERVED)**2)
c AUTOFOUR-patch (begin)
c B-ov ,scale (Fcalc=scale*Fobs) , kv
	write(38,'(2f10.5,2i5)') bt,sqrt(amax1(sc,0.0)),0,0
c AUTOFOUR-patch (end)
      RETURN
      END
C     ------------------------------------------------------------------
C     LINE PRINTER PLOT AT 50 VALUES OF RHO
      SUBROUTINE GRAPH(NGP)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
      DIMENSION FH(6),RH(6),M(117),R(4),AD(4),AW(4)
      DATA IST,ISP,ICW,ICD/1H*,1H ,1HW,1HD/
C     DETERMINE RANGES OF LOGS
      RX=AVR(NB)
      FX=FLGK
      FN=SLOPE*RX+FLGK
      DO 10 I=1,117
      M(I)=ISP
   10 CONTINUE
      DO 20 I=1,NB
      FX=AMAX1(FX,FLGW(I),FLGD(I))
      FN=AMIN1(FN,FLGW(I),FLGD(I))
   20 CONTINUE
      FD=FX-FN
      DO 30 I=1,6
      RH(I)=0.2*FLOAT(I-1)*RX
      FH(I)=FN+0.2*FLOAT(I-1)*FD
   30 CONTINUE
C     TOP FRAME
      WRITE(LO,40) ITLE,FH,RH(1)
   40 FORMAT(1H1,25X,63HPLOT OF WILSON AND DEBYE CURVES AND LEAST SQUARE
     1S STRAIGHT LINE/1H0,15X,20A4/1H0,40X,20HLN(F(OBS)**2/SIGFSQ)/1H ,
     2 F18.3,5F20.3/1H ,F12.3,2X,1H-,5(1HI,19(1H-)),2HI-)
      J=1
      IR=2
      DO 200 I=1,50
      DCV(I)=-1000000.0
C     SIDE FRAME
      IF(MOD(I,10).EQ.0) GO TO 60
      WRITE(LO,50)
   50 FORMAT(1H ,15X,1HI)
      GO TO 80
   60 WRITE(LO,70) RH(IR)
   70 FORMAT(1H ,F11.3,3X,3H-I-)
      IR=IR+1
C     INTERPOLATION
   80 Q=0.02*FLOAT(I)*RX
      IL=(SLOPE*Q+FLGK-FN)*100.0/FD+16.5
      IF(IL.GT.117) IL=117
      IF(IL.LT.1) IL=1
      M(IL)=IST
C     STRAIGHT LINE OUTPUT (*)
      WRITE(LO,170) (M(L),L=1,IL)
      M(IL)=ISP
      IF(Q.LT.AVR(1)) GO TO 180
      IF(J.EQ.1) GO TO 90
      IF(J.EQ.NB-2) GO TO 130
      IF(Q.LT.AVR(J+1)) GO TO 130
   90 J=J+1
      DO 100 K=1,4
      ITEMP = J-2+K
      R(K)=AVR(ITEMP)
  100 CONTINUE
      CALL SOLVE(R,FLGW(J-1),FLGW(J),FLGW(J+1),FLGW(J+2),AW)
      IF(NGP.EQ.0) GO TO 130
      CALL SOLVE(R,FLGD(J-1),FLGD(J),FLGD(J+1),FLGD(J+2),AD)
C     WILSON PLOT INTERPOLATION
  130 IL=100.0*(AW(4)+Q*(AW(3)+Q*(AW(2)+Q*AW(1)))-FN)/FD+16.5
      IF(IL.GT.117) IL=117
      IF(IL.LT.1) IL=1
      M(IL)=ICW
C     WILSON PLOT OUTPUT (W)
      WRITE(LO,170) (M(L),L=1,IL)
      M(IL)=ISP
      IF(NGP.NE.0) GO TO 160
C     STORE K-CURVE
      IF(IK.EQ.1) DCV(I)=EXP(AW(4)+Q*(AW(3)+Q*(AW(2)+Q*AW(1))))
      GO TO 180
C     DEBYE CURVE INTERPOLATION
  160 IL=100.0*(AD(4)+Q*(AD(3)+Q*(AD(2)+Q*AD(1)))-FN)/FD+16.5
      IF(IL.GT.117) IL=117
      IF(IL.LT.1) IL=1
      M(IL)=ICD
C     DEBYE CURVE OUTPUT (D)
      WRITE(LO,170) (M(L),L=1,IL)
  170 FORMAT(1H+,117A1)
      M(IL)=ISP
C     STORE K-CURVE
      IF(IK.EQ.1) DCV(I)=EXP(AD(4)+Q*(AD(3)+Q*(AD(2)+Q*AD(1))))
  180 IF(I.EQ.25) WRITE(LO,190)
  190 FORMAT(1H+,2X,3HRHO)
  200 CONTINUE
C     K-CURVE PARAMETERS
      DEL=50.0/AVR(NB)
C     K-CURVE FOLLOWS LEAST-SQUARES STRAIGHT LINE UNTIL THE DEBYE CURVE
C     CROSSES IT.
      J=0
      JP=0
      DO 250 I=1,50
      SK=EXP(SLOPE*FLOAT(I)/DEL+FLGK)
      IF(DCV(I).LT.(-999999.0)) GO TO 240
      JP=-1
      IF(DCV(I).GT.SK) JP=1
      IF(J.EQ.(-JP)) GO TO 270
      J=JP
  240 DCV(I)=SK
  250 CONTINUE
  270 RETURN
      END
C     ------------------------------------------------------------------
C     FIT CURVE TO Y = A(1) * RHO**3 + A(2) * RHO**2 + A(3) * RHO + A(4)
      SUBROUTINE SOLVE(R,Y1,Y2,Y3,Y4,A)
      DIMENSION R(4),A(4)
      B2=R(4)*(R(4)+R(1))
      B1=(Y4-Y1)/(R(4)-R(1))
      C31=(Y2-Y1)/(R(2)-R(1))-B1
      C32=(Y3-Y1)/(R(3)-R(1))-B1
      C11=R(2)*(R(2)+R(1))-B2
      C12=R(3)*(R(3)+R(1))-B2
      C21=R(2)-R(4)
      C22=R(3)-R(4)
      A(1)=(C31*C22-C32*C21)/(C22*C11-C12*C21)
      A(2)=(C31-C11*A(1))/C21
      A(3)=B1-(R(4)*R(4)+R(1)*R(1)+R(4)*R(1))*A(1)-(R(4)+R(1))*A(2)
      A(4)=Y1-R(1)*(A(3)+R(1)*(A(2)+R(1)*A(1)))
      RETURN
      END
C     ------------------------------------------------------------------
C     INDEX GROUP RESCALING
      SUBROUTINE RESCA(KSYS,ISC,JUMP)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
      DIMENSION NG(8),SCS(8)
      TOT=0.0
      NW=0
      DO 10 I=1,8
      SCS(I)=0.0
      NG(I)=0
   10 CONTINUE
      REWIND ISCRA
  100 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG
      DO 250 I=1,60
      IF(FO(I).LT.0.0) GO TO 300
      IF(IK.NE.1) ESQ=SC*ED(I)*EXP(BT*RHO(I))
      IF(IK.EQ.1) CALL CURVK(ESQ,RHO(I),ED(I))
C     UNPACK SYMMETRY FUNCTIONS
      MULT=ID(I)/10000
      TMUL=FLOAT(MULT)
      TOT=TOT+ESQ*TMUL
      NW=NW+MULT
      IG=MOD(ID(I),100)
      SCS(IG)=SCS(IG)+ESQ*TMUL
      NG(IG)=NG(IG)+MULT
  250 CONTINUE
      GO TO 100
  300 TOT=TOT/FLOAT(NW)
C     8 PARITY GROUPS FOR TRICLINIC, MONOCLINIC AND ORTHORHOMBIC
      NN=8
C     6 MODIFIED PARITY GROUPS FOR TETRAGONAL
C     6 INDEX GROUPS IN OTHER SYSTEMS
      IF(KSYS.GE.4) NN=6
      DO 320 I=1,NN
      IF(NG(I).GT.0) SCS(I)=SCS(I)/FLOAT(NG(I))
  320 CONTINUE
      WRITE(LO,330)
  330 FORMAT(1H1,27X,66HAVERAGE E**2 ACCORDING TO APPROPRIATE INDEX GROU
     1P BEFORE RESCALING)
      IF(KSYS.LE.3) WRITE(LO,335)
  335 FORMAT(1H0,53X,13HPARITY GROUPS/1H0,18X,3HALL,9X,3HEEE,9X,3HOEE,
     1 9X,3HEOE,9X,3HOOE,9X,3HEEO,9X,3HOEO,9X,3HEOO,9X,3HOOO)
      IF(KSYS.EQ.4) WRITE(LO,340)
  340 FORMAT(1H0,49X,22HMODIFIED PARITY GROUPS/1H0,18X,3HALL,9X,3HEEE,
     1 7X,7HEOE,OEE,7X,3HOOE,9X,3HEEO,7X,7HEOO,OEO,7X,3HOOO)
      IF(KSYS.LE.4) GO TO 365
      WRITE(LO,345)
  345 FORMAT(26H0INDEX GROUPS DIVIDED ON -)
      IF(KSYS.LE.6) WRITE(LO,350)
  350 FORMAT(1H+,30X,11H1) MOD(H,3),4X,11H2) MOD(K,3),4X,
     1 13H3) MOD(H+K,3),4X,11H4) MOD(L,2))
      IF(KSYS.GE.7) WRITE(LO,355)
  355 FORMAT(1H+,30X,13H1) MOD(H-L,3),4X,13H2) MOD(K-L,3),4X,
     1 13H3) MOD(H-K,3),4X,15H4) MOD(H+K+L,2))
      WRITE(LO,360)
  360 FORMAT(1H0,30X,18HE - ZERO REMAINDER,4X,22HO - NON-ZERO REMAINDER/
     1 1H0,18X,3HALL,9X,4HOOOE,5X,9HOOEE,OEOE,6X,4HEEEE,8X,4HOOOO,
     2 5X,9HOOEO,OEOO,6X,4HEEEO/1H ,42X,4HEOOE,32X,4HEOOO)
  365 WRITE(LO,370) TOT,(SCS(I),I=1,NN)
  370 FORMAT(1H ,3X,4HE**2,3X,9F12.3)
      WRITE(LO,380) NW,(NG(I),I=1,NN)
  380 FORMAT(1H ,2X,6HNUMBER,2X,9I12)
      TOT=1.0/TOT
      IF(JUMP.EQ.1) TOT=SCAL(1)
      DO 400 I=1,NN
      IF(NG(I).GT.0.AND.JUMP.NE.1) SCAL(I)=1.0/SCS(I)
      IF(ISC.EQ.1) SCAL(I)=TOT
  400 CONTINUE
      RETURN
      END
C     ------------------------------------------------------------------
C     K-CURVE INTERPOLATION
      SUBROUTINE CURVK(ESQ,RHO,ED)
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      EI=RHO*DEL
      I=EI
C     FOR SMALL RHO THE CURVE IS EXTRAPOLATED FROM THE FIRST POINT
C     USING THE LEAST SQUARES SLOPE
      IF(I.EQ.0) SK=EXP(SLOPE*RHO+FLGK)
C     INTERPOLATION
      IF(I.GT.0.AND.I.LT.50) SK=DCV(I)+(EI-FLOAT(I))*(DCV(I+1)-DCV(I))
C     FOR LARGE RHO THE CURVE IS EXTRAPOLATED FROM THE LAST POINT
      IF(I.GE.50) SK=DCV(50)*EXP(SLOPE*(AVR(NB)-RHO))
      ESQ=ED/SK
      RETURN
      END
C     ------------------------------------------------------------------
C     CALCULATE FINAL E-VALUES AND RESCALED F'S
C     CREATE NEW ISTAN IF REQUIRED
C     OUTPUT REFLEXIONS FOR MULTAN
C     PREPARE TABLES OF STATISTICS
      SUBROUTINE ECAL(KSYS)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS
      COMMON/ST/VST(10,5),NST(5),ZT(25,5),EE(10),MULT,IND,NZR,TMUL
      COMMON/XXX/ IX(1000),EX(1000),FX(1000)
      DIMENSION RHR(10),NHR(10),NU(25),STL(10),INP(60),NOB(60)
C     TABLES OF THEORETICAL DISTRIBUTIONS
      DIMENSION AVA(10),AVC(10),AVH(10),CPH(25)
	real w37(20)
C     ATOMIC SCATTERING FACTORS
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      DATA AVA/0.886,1.0,1.329,2.0,3.323,6.0,0.736,1.0,2.0,2.415/
      DATA AVC/0.798,1.0,1.596,3.0,6.383,15.0,0.968,2.0,8.0,8.691/
      DATA AVH/0.718,1.0,1.916,4.5,12.26,37.5,1.145,3.5,26.0,26.903/
      DATA CPH/0.368,0.463,0.526,0.574,0.612,0.643,0.670,0.694,0.715,
     1 0.733,0.765,0.791,0.813,0.832,0.848,0.863,0.875,0.886,0.896,
     2 0.905,0.913,0.920,0.926,0.932,0.938/
      DATA IOBS,IUNOBS/1H ,1HU/
C     SET INITIAL VALUES
      DO 20 I=1,10
      RHR(I)=0.0
      NHR(I)=0
      DO 10 J=1,5
      VST(I,J)=0.0
   10 CONTINUE
   20 CONTINUE
      DO 40 I=1,5
      NST(I)=0
      DO 30 J=1,25
      ZT(J,I)=0.0
   30 CONTINUE
   40 CONTINUE
      DO 50 I=1,25
      NU(I)=0
   50 CONTINUE
      NRW=0
      LIM=1000
      NC=0
      NS=0
      NL=0
      SCF=SQRT(SC)
      RR=10.0/SQRT(RHOMAX)
      IF(LST.EQ.1) WRITE(LO,55) NREF
   55 FORMAT(//8H0LIST OF,I6,2X,87HREFLEXIONS. F IS ON AN ABSOLUTE SCALE
     1 AND THE E-VALUES ARE SUITABLE FOR INPUT TO MULTAN/
     2 1H0,5(9H  H  K  L,5X,1HF,4X,1HE,4X))
      IF(NPC.LT.0) REWIND ISTAN
      REWIND ISCRA
   60 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG
c AUTOFOUR-patch (begin)
	do k37=1,60
c in packets of 60
	do i37=1,20
	  w37(i37)=0.0
	end do
	w37(1)=fo(k37)
	w37(10)=sqrt(rho(k37))
	do i37=1,nk
	  w37(10+i37)=al(i37)*exp(-as(i37)*rho(k37))+
     .	      bl(i37)*exp(-bs(i37)*rho(k37))+
     .        cl(i37)*exp(-cs(i37)*rho(k37))+
     .        dl(i37)*exp(-ds(i37)*rho(k37))+
     .        el(i37)
	end do
	if (sig(k37).lt.0.0) then
c less-than
	  n37=2
	else
c observed
	  n37=1
	end if
	if (fo(k37).lt.0.0) then
	  write(37)999,lh(k37),lk(k37),ll(k37),n37,w37
	  goto 3737
	else
c for reflections MARC should be set NOT to 990-998
c for the program REDNOR MARC should be set to 0 !
	  write(37)0,lh(k37),lk(k37),ll(k37),n37,w37
	end if
	end do
3737	continue
c AUTOFOUR-patch (end)
      DO 250 I=1,60
      INP(I)=32896
      MF=I
C     TEST FOR END OF DATA
      IF(FO(I).LT.0.0) GO TO 300
      D=SC*EXP(BT*RHO(I))
      MULT=ID(I)/10000
      IE=(ID(I)-10000*MULT)/100
      IG=ID(I)-10000*MULT-100*IE
C     CALCULATE E
      IF(IK.NE.1) ESQ=D*ED(I)
      IF(IK.EQ.1) CALL CURVK(ESQ,RHO(I),ED(I))
      ESQ=ESQ*SCAL(IG)
      E=SQRT(ESQ)
      ED(I)=E
C     CALCULATE RESCALED F
      FO(I)=FO(I)*SCF
C     PACK INDICES FOR TAPE ISTAN
      INP(I)=65536*LH(I)+256*(LK(I)+128)+LL(I)+128
C     SET OBS/UNOBS FLAG
      NOB(I)=IOBS
      IF(SIG(I).LT.0.0) NOB(I)=IUNOBS
      IF(RHO(I).GT.TH) GO TO 110
C     STORE REFLEXIONS FOR MULTAN
      IF(SIG(I).LT.0.0) GO TO 90
      NL=NL+1
      IF(E.GT.EN) GO TO 100
      NL=NL-1
   90 E=E+0.2*RHO(I)
      IF(E.GT.ER) GO TO 110
      NS=NS+1
  100 NC=NC+1
      IX(NC)=INP(I)
      EX(NC)=E
      FX(NC)=FO(I)
      IF(NC.NE.LIM) GO TO 110
      CALL SORT(EX,FX,IX,1000)
      IF(MZ.GT.0) ER=AMIN1(ER,EX(1001-MZ))
      EN=AMAX1(EN,EX(MM))
      NC=MIN0(MM,NL)
      LIM=1000-MZ
C     WORK OUT FINAL STATISTICS
  110 TMUL=FLOAT(MULT)
C     DISTRIBUTION OF E WITH SIN(THETA)/LAMBDA
      N=MIN0(10,INT(1.0+RR*SQRT(RHO(I))))
      NHR(N)=NHR(N)+MULT
      RHR(N)=RHR(N)+ESQ*TMUL
      NZR=INT(10.0*ESQ)+1
      IF(NZR.GT.10) NZR=10+(NZR-9)/2
      EE(1)=ED(I)
      DO 120 J=2,6
      EE(J)=EE(J-1)*ED(I)
  120 CONTINUE
      EE(7)=ESQ-1.0
      EE(8)=EE(7)*EE(7)
      EE(9)=EE(8)*EE(7)
      EE(10)=ABS(EE(9))
      EE(7)=ABS(EE(7))
      DO 130 J=1,10
      EE(J)=TMUL*EE(J)
  130 CONTINUE
C     ADD FUNCTIONS OF E TO APPROPRIATE ZONES
      IND=1
      J=LH(I)
      K=LK(I)
      L=LL(I)
      CALL ADD(1)
      GO TO (140,140,140,150,160,160,170,180),KSYS
C     TRICLINIC, MONOCLINIC AND ORTHORHOMBIC
  140 IF(J.EQ.0) CALL ADD(3)
      IF(K.EQ.0) CALL ADD(4)
      IF(L.EQ.0) CALL ADD(5)
      GO TO 200
C     TETRAGONAL
  150 IF(J.EQ.0.OR.K.EQ.0) CALL ADD(3)
      IF(IABS(J).EQ.IABS(K)) CALL ADD(4)
      IF(L.EQ.0) CALL ADD(5)
      GO TO 200
C     TRIGONAL, HEXAGONAL AND RHOMBOHEDRAL INDEXED ON HEXAGONAL AXES
  160 IF(J.EQ.0.OR.K.EQ.0.OR.J+K.EQ.0) CALL ADD(3)
      IF(J.EQ.K.OR.J+2*K.EQ.0.OR.2*J+K.EQ.0) CALL ADD(4)
      IF(L.EQ.0) CALL ADD(5)
      GO TO 200
C     PRIMITIVE RHOMBOHEDRAL
  170 IF(J.EQ.K.OR.J.EQ.L.OR.K.EQ.L) CALL ADD(3)
      IF(L.EQ.2*K-J.OR.K.EQ.2*J-L.OR.J.EQ.2*L-K) CALL ADD(4)
      IF(J+K+L.EQ.0) CALL ADD(5)
      GO TO 200
C     CUBIC
  180 IF(J.EQ.0.OR.K.EQ.0.OR.L.EQ.0) CALL ADD(3)
      IF(IABS(J).EQ.IABS(K).OR.IABS(J).EQ.IABS(L).OR.IABS(K).EQ.IABS(L))
     1  CALL ADD(4)
C     H,H,2H IS IN TWO PRINCIPAL ZONES BUT NOT ON A PRINCIPAL AXIS
      IF(IND.EQ.4) IND=0
      IF(IABS(L).EQ.IABS(J+K).OR.IABS(K).EQ.IABS(J+L).OR.IABS(J).
     1 EQ.IABS(K+L)) CALL ADD(5)
C     REFLEXIONS NOT BELONGING TO PRINCIPAL ZONES
  200 IF(IND.EQ.1) CALL ADD(2)
C     DISTRIBUTION OF E FOR COMPLETE DATA
      NET=MIN0(25,INT(10.0*ED(I)))
      IF(NET.EQ.0) GO TO 220
      NU(NET)=NU(NET)+1
  220 NRW=NRW+MULT
  250 CONTINUE
C     CREATE (OR REWRITE) ISTAN
  300 IF(NPC.LT.0) WRITE(ISTAN) INP,FO,ED,SIG
      IF(FO(MF).LT.0.0) MF=MF-1
C     LIST REFLEXIONS IF REQUIRED
      IF(LST.EQ.1.AND.MF.NE.0) WRITE(LO,305) (LH(K),LK(K),LL(K),FO(K),
     1 ED(K),NOB(K),K=1,MF)
C     FORMAT FOR REFLEXION LIST - A WIDER LINEPRINTER MAY ALLOW MORE
C     REFLEXIONS TO BE OUTPUT ON ONE LINE - THUS SAVING PAPER
  305 FORMAT(5(1H ,3I3,F7.1,F5.2,1X,A1))
C     TEST FOR END OF DATA
      IF(MF.EQ.60) GO TO 60
C     OUTPUT STATISTICS
      RR=1.0/RR
      DO 320 I=1,10
      STL(I)=RR*FLOAT(I)
      IF(NHR(I).GT.0) RHR(I)=RHR(I)/FLOAT(NHR(I))
      DO 310 J=1,5
      IF(NST(J).GT.0) VST(I,J)=VST(I,J)/FLOAT(NST(J))
  310 CONTINUE
  320 CONTINUE
      WRITE(LO,330) STL,RHR,NHR
  330 FORMAT(///1H0,52X,16HFINAL STATISTICS//1H ,38X,
     1 43HDISTRIBUTION OF E**2 WITH SIN(THETA)/LAMBDA/10H SINTH/LAM,
     2 10F10.4/1H ,3X,4HE**2,2X,10F10.4/1H ,2X,6HNUMBER,10I10)
      WRITE(LO,340)
  340 FORMAT(//1H0,53X,14HAVERAGE VALUES)
      WRITE(LO,350)
  350 FORMAT(1H0,45X,12HEXPERIMENTAL,39X,11HTHEORETICAL/1H ,23X,
     1 8HALL DATA,7X,3HHKL,44X,8HACENTRIC,5X,7HCENTRIC,
     2 2X,12HHYPERCENTRIC)
      WRITE(LO,360)
  360 FORMAT(1H+,4X,7HAVERAGE)
C     CAPTION ACCORDING TO CRYSTAL SYSTEM
      IF(KSYS.NE.7) WRITE(LO,370)
  370 FORMAT(1H+,50X,3H0KL)
      IF(KSYS.EQ.7) WRITE(LO,380)
  380 FORMAT(1H+,47X,8HH,K,2K-H)
      IF(KSYS.LE.3) WRITE(LO,390)
  390 FORMAT(1H+,62X,3HH0L)
      IF(KSYS.GE.4) WRITE(LO,400)
  400 FORMAT(1H+,62X,3HHHL)
      IF(KSYS.LE.6) WRITE(LO,410)
  410 FORMAT(1H+,74X,3HHK0)
      IF(KSYS.GE.7) WRITE(LO,420)
  420 FORMAT(1H+,71X,8HH,K,-H-K)
      WRITE(LO,430) ((VST(I,J),J=1,5),AVA(I),AVC(I),AVH(I),I=1,10)
  430 FORMAT(1H ,5X,6HMOD(E),7X,5F12.3,2X,3F12.3/
     1 1H ,6X,4HE**2,8X,5F12.3,2X,3F12.3/
     2 1H ,6X,4HE**3,8X,5F12.3,2X,3F12.3/
     3 1H ,6X,4HE**4,8X,5F12.3,2X,3F12.3/
     4 1H ,6X,4HE**5,8X,5F12.3,2X,3F12.3/
     5 1H ,6X,4HE**6,8X,5F12.3,2X,3F12.3/
     6 1H ,2X,11HMOD(E**2-1),5X,5F12.3,2X,3F12.3/
     7 1H ,2X,11H(E**2-1)**2,5X,5F12.3,2X,3F12.3/
     8 1H ,2X,11H(E**2-1)**3,5X,5F12.3,2X,3F12.3/
     9 1H ,16H(MOD(E**2-1))**3,2X,5F12.3,2X,3F12.3)
      WRITE(LO,440) NST
  440 FORMAT(21H0WEIGHTED SAMPLE SIZE,I10,4I12)
      WRITE(LO,450)
  450 FORMAT(//1H0,40X,40HN(Z) CUMULATIVE PROBABILITY DISTRIBUTION)
      WRITE(LO,350)
      WRITE(LO,460)
  460 FORMAT(1H+,5X,1HZ)
C     CAPTION ACCORDING TO CRYSTAL SYSTEM
      IF(KSYS.NE.7) WRITE(LO,370)
      IF(KSYS.EQ.7) WRITE(LO,380)
      IF(KSYS.LE.3) WRITE(LO,390)
      IF(KSYS.GE.4) WRITE(LO,400)
      IF(KSYS.LE.6) WRITE(LO,410)
      IF(KSYS.GE.7) WRITE(LO,420)
      DO 500 I=1,25
      DO 470 J=1,5
      IF(NST(J).GT.0) ZT(I,J)=ZT(I,J)/FLOAT(NST(J))
      IF(I.NE.1) ZT(I,J)=ZT(I,J)+ZT(I-1,J)
  470 CONTINUE
C     THEORETICAL DISTRIBUTIONS
      ZZ=0.1*FLOAT(I)
      IF(I.GT.10) ZZ=2.0*ZZ-1.0
C     ACENTRIC
      CPA=1.0-EXP(-ZZ)
C     CENTRIC
      XX=SQRT(0.5*ZZ)
      T=1.0/(1.0+0.47047*XX)
      CPC=1.0-((0.74786*T-0.09588)*T+0.34802)*T*EXP(-0.5*ZZ)
      WRITE(LO,480) ZZ,(ZT(I,J),J=1,5),CPA,CPC,CPH(I)
  480 FORMAT(1H ,F7.1,11X,5F12.3,2X,3F12.3)
  500 CONTINUE
      WRITE(LO,440) NST
      DO 510 I=1,24
      J=25-I
      NU(J)=NU(J)+NU(J+1)
  510 CONTINUE
      WRITE(LO,520)
  520 FORMAT(/1H0,38X,44HDISTRIBUTION OF E - NUMBER OF E'S .GT. LIMIT)
      DO 540 I=1,25
      AVR(I)=0.1*FLOAT(I)
  540 CONTINUE
      WRITE(LO,560) (AVR(I),I=7,25),(NU(I),I=7,25)
  560 FORMAT(1H0,2X,3HE  ,19F6.1/1H ,1X,4HNO. ,19I6)
C     OUTPUT REFLEXIONS FOR MULTAN
      MR=1000
      IF(LIM.EQ.1000) MR=NC
      CALL SORT(EX,FX,IX,MR)
      MM=MIN0(MM,NL)
      WRITE(LO,580) MM
  580 FORMAT(///1H ,I6,41H  LARGEST E-VALUES WRITTEN TO OUTPUT FILE)
      CALL OUTPUT(EX,FX,IX,0,MM)
      MZ=MIN0(MZ,NS)
      MS=MR-MZ
      WRITE(LO,600) MZ
  600 FORMAT(1H0,I6,42H  SMALLEST E-VALUES WRITTEN TO OUTPUT FILE)
      CALL OUTPUT(EX,FX,IX,MS,MR)
  630 RETURN
      END
C     ------------------------------------------------------------------
C     SUMS FOR REFLEXION IN ZONE N
      SUBROUTINE ADD(N)
      COMMON/ST/VST(10,5),NST(5),ZT(25,5),EE(10),MULT,IND,NZR,TMUL
      IS=1
      NT=N
      IF(N.LE.2.OR.IND.LE.1) GO TO 20
C     REFLEXION IS ON PRINCIPAL AXIS - THEREFORE IGNORE IT
      NT=IND
      IS=-1
   20 S=FLOAT(IS)
      DO 30 I=1,10
      VST(I,NT)=VST(I,NT)+S*EE(I)
   30 CONTINUE
      NST(NT)=NST(NT)+IS*MULT
      IF(NZR.LE.25) ZT(NZR,NT)=ZT(NZR,NT)+S*TMUL
      IND=N
      RETURN
      END
C     ------------------------------------------------------------------
C     SORT ON A
      SUBROUTINE SORT(A,B,IX,N)
      DIMENSION A(N),B(N),IX(N)
      INT=2
   10 INT=2*INT
      IF(INT.LT.N) GO TO 10
      INT=MIN0(N,(3*INT)/4-1)
   20 INT=INT/2
      IFIN=N-INT
      DO 70 II=1,IFIN
      I=II
      J=I+INT
      IF(A(I).GE.A(J)) GO TO 70
      T=A(J)
      X=B(J)
      L=IX(J)
   40 A(J)=A(I)
      B(J)=B(I)
      IX(J)=IX(I)
      J=I
      I=I-INT
      IF(I.LE.0) GO TO 60
      IF(A(I).LT.T) GO TO 40
   60 A(J)=T
      B(J)=X
      IX(J)=L
   70 CONTINUE
      IF(INT.GT.1) GO TO 20
      RETURN
      END
C     ------------------------------------------------------------------
C     PRINT AND OUTPUT TO FILE FOR REFLEXIONS TO BE USED IN MULTAN
      SUBROUTINE OUTPUT(EX,FX,IX,N,M)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      DIMENSION EX(1000),FX(1000),IX(1000)
      DIMENSION J(6),K(6),L(6),E(6),KODE(6)
      IF(N.EQ.M) GO TO 60
      WRITE(LO,10)
   10 FORMAT(6(1X,4HCODE,9H  H  K  L,3X,1HE,2X))
      NA=N+1
      KK=0
      DO 50 JJ=NA,M
      I=JJ
      IF(N.NE.0) I=M-JJ+NA
      KK=KK+1
      IND=IX(I)
      J(KK)=IND/65536
      IF(IND.LT.0) J(KK)=J(KK)-1
      IND=IND-65536*J(KK)
      K(KK)=IND/256
      L(KK)=IND-256*K(KK)-128
      K(KK)=K(KK)-128
      WRITE(LNTA,20) J(KK),K(KK),L(KK),EX(I)
   20 FORMAT(3I5,F10.3)
      E(KK)=EX(I)
      KODE(KK)=JJ-N
      IF(KK.NE.6) GO TO 50
      WRITE(LO,30) (KODE(II),J(II),K(II),L(II),E(II),II=1,6)
   30 FORMAT(6(I5,3I3,F6.3))
      KK=0
   50 CONTINUE
      IF(KK.EQ.0) GO TO 60
      WRITE(LO,30) (KODE(II),J(II),K(II),L(II),E(II),II=1,KK)
   60 KK=0
      D=-1.0
      WRITE(LNTA,20) KK,KK,KK,D
      RETURN
      END
C     ------------------------------------------------------------------
C     PHASE CALCULATION FOR WEIGHTED KARLE RECYCLING
      SUBROUTINE RECYC(NS,NF,BT)
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      COMMON/XXX/IX(1000),EX(1000),FX(1000)
      DIMENSION I1(3),I2(3),IFAZ(500)
C     I1/I0 (BESSEL FUNCTIONS)
      VEC(U)=U*(U+0.4807)/((U+0.8636)*U+1.3943)
C     CALCULATE PKARL (RATIO OF KNOWN TO COMPLETE STRUCTURE)
      KARL=0
      DO 150 I=NS,NF
      K=NZ(I)
      KARL=KARL+NO(K)
  150 CONTINUE
      KTOT=0
      DO 160 I=1,NK
      KTOT=KTOT+NW(I)*NO(I)
  160 CONTINUE
      PKARL=FLOAT(KARL*NSYM*(ICENT+1))*PTS/FLOAT(KTOT)
      IF(PKARL.LT.0.25) PKARL=0.25
      IF(PKARL.GT.0.60) PKARL=0.60
      WRITE(LO,180) ITLE,PKARL
  180 FORMAT (//1X,119(1H+)//1X,20A4,2X,37HPHASE CALCULATION FOR KARLE R
     1ECYCLING//38X,39HRATIO OF KNOWN TO COMPLETE STRUCTURE IS,F6.2)
C     CALCULATE PHASES AND SELECT REFLEXIONS FOR INPUT TO MULTAN
      REWIND ISCRA
      SUMF=0.0
      SUMC=0.0
  200 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG
      DO 300 I=1,60
      IF(FO(I).LT.0.0) GO TO 310
      IP=65536*LH(I)+256*(LK(I)+128)+LL(I)+128
      DO 210 IM=1,MM
      IF(IX(IM).EQ.IP) GO TO 220
  210 CONTINUE
      GO TO 300
  220 SUMF=SUMF+FX(IM)
      I1(1)=LH(I)
      I1(2)=LK(I)
      I1(3)=LL(I)
      REL=0.0
      RIM=0.0
      IENT=0
      DO 260 J=1,NSYM
      T=1000.0
      DO 230 L=1,3
      T=T+FLOAT(I1(L))*TS(L,J)
      I2(L)=0
  230 CONTINUE
      DO 250 L=1,3
      DO 240 K=1,2
      M=IABS(IS(K,L,J))
      IF(M.GT.0) I2(M)=I2(M)+I1(L)*ISIGN(1,IS(K,L,J))
  240 CONTINUE
  250 CONTINUE
      CALL SFAC(NS,NF,I2,T,RHO(I),A,B,IENT)
      IENT=1
      REL=REL+A
      IF(ICENT.EQ.0) RIM=RIM+B
      IF(ICENT.EQ.1) REL=REL+A
  260 CONTINUE
      E=EX(IM)
      EX(IM)=PTS*SQRT((REL*REL+RIM*RIM)*EXP(-BT*RHO(I)))
      SUMC=SUMC+EX(IM)
      IFAZ(IM)=0
C     CALCULATE SIM WEIGHT
      XKAP=2.0*E*E*EX(IM)/((1.0-PKARL)*FX(IM))
      IF(XKAP.GT.4.0) GO TO 280
      IF(XKAP.LT.2.4.OR.E.LT.1.5.OR.EX(IM).LT.PKARL*FX(IM)) GO TO 300
  280 IF (ICENT.EQ.0) EX(IM+500) = VEC(XKAP)
      IF (ICENT.EQ.1) EX(IM+500) = TANH(XKAP/2.0)
      FAZE=(180.0/PI)*ATAN2(RIM,REL)+360.0
      IFAZ(IM)=MOD(INT(FAZE+0.5),360)
      IF(IFAZ(IM).EQ.0) IFAZ(IM)=360
  300 CONTINUE
      GO TO 200
  310 MARK=-1
      SCALE=SUMC/SUMF
      RS=0.0
      NREC=0
      DO 350 I=1,MM
      RS=RS+ABS(SCALE*FX(I)-EX(I))
      IF(IFAZ(I).LE.0) GO TO 350
      NREC=NREC+1
      IX(NREC)=I
      IX(NREC+500)=IFAZ(I)
      FX(NREC+500)=EX(I+500)
  350 CONTINUE
      RS=100.0*RS/SUMC
      IF(NREC.GT.250) NREC=250
      WRITE(LO,360) SCALE,RS,NREC
  360 FORMAT (/35X,7HSCALE =,F7.3,19X,10HR-FACTOR =,F7.2//38X,
     1 39HNUMBER OF REFLEXIONS PASSED TO MULTAN =,I5//1X,119(1H+))
      WRITE(LREC,370) ITLE,NREC
  370 FORMAT(20A4/7HPHASES ,I4)
      WRITE(LREC,380) (IX(I),I=1,NREC)
  380 FORMAT(20I4)
      WRITE(LREC,380) (MARK,I=1,NREC)
      WRITE(LREC,390) (FX(I+500),I=1,NREC)
  390 FORMAT(20F4.2)
      WRITE(LREC,380) (IX(I+500),I=1,NREC),MARK
      RETURN
      END
C     ------------------------------------------------------------------
C     R-FACTOR FOR COMPLETE DATA
      SUBROUTINE RFAC
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),
     1 RHO(60),SIG(60)
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH
      SCALE=EN/ER
      R=0.0
      REWIND ISCRA
      READ(ISCRA)
      READ(ISCRA)
  100 READ(ISCRA) LH,LK,LL,EW,ED,FO,SIG
      DO 200 I=1,60
      IF(FO(I).LT.0.0) GO TO 250
      R=R+ABS(SIG(I)-SCALE*FO(I))
  200 CONTINUE
      GO TO 100
  250 R=100.0*R/EN
      WRITE(LO,280) R,NREF
  280 FORMAT(1H0,39X,10HR-FACTOR =,F7.2,3X,3HFOR,I6,2X,10HREFLEXIONS)
      RETURN
      END
