      SUBROUTINE ATOMIN(ATPR,ITPR,NAT,NLEES,NPRS,PRES,FAT,NFAT,JFAT,P1,
     1 NEWFLAG)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/PNTR/IPNT(10),JPNT(10),S(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),ATOM(10),EXCL(10)
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11),
     1 ISER(10),SF,SQ,DN,XN,DX,DY,DZ,ITLE(20),DM,XM
      DIMENSION ATPR(6,NAT),PAR(6),ITPR(2,NAT),X(3),FAT(32,NFAT)
      CHARACTER*4 ATOM,NAAM,LABEL
      LOGICAL NEWFLAG
      CHARACTER*80 REGEL
      EQUIVALENCE (X(1),PAR(1))
      DATA NAAM/4HEIND/
C
C  READ ATOMIC PARAMETERS FROM CARD
C  CALCULATE PERCENTAGE OF THE STRUCTURE WHICH IS PUT IN
C  SINCE THE CONCEPT BEHIND AUTOFOUR IS INCOMPATIBLE WITH DISORDER
C  THERE ARE NO OPTIONS TO HANDLE DISORDER
C  IF NEWFLAG IS TRUE THE PROGRAM DETERMINES THE SCATTERING FACTOR
C  TABLE FROM THE NAME OF THE ATOM ON THE INPUTFILE
C  THIS NUMBER NEED NOT BE GIVEN BY THE USER IN THIS CASE
C
      NPRS=0
      IFAIL=0
      PAR(5)=0
      PAR(6)=1
C     WRITE(LO,2)
C2    FORMAT(/,' ATOMIN: List of input parameters:'//' ',15X,'NR',8X,
C    1 'X',11X,'Y',11X,'Z',12X,'Table'/)
  100 CONTINUE
101   READ(LC,9,END=200)REGEL
9     FORMAT(A80)
      IF(REGEL(1:3).EQ.'REM'.OR.REGEL(1:3).EQ.'rem'.OR.
     1REGEL(1:1).EQ.' ')GO TO 101
C
C  BGR OF THE GENERAL POSITION ALWAYS EQUALS 1
C
      IF(NEWFLAG)THEN
      CALL GETATOM(REGEL,LABEL,NFAT,FI,X,IFAIL)
      ELSE
      BACKSPACE LC
      READ(LC,10)LABEL,FI,X
10    FORMAT(A4,6X,5F10.0)
      ENDIF
      IF(NAAM.EQ.LABEL.OR.NAAM.EQ.REGEL(1:4))GOTO 200
      IF(IFAIL.EQ.0)THEN
      I=FI+.5
      I=LPNT(I)
      IF(I.EQ.0)THEN
      WRITE(LO,40)REGEL(1:79)
40    FORMAT(/,' ATOMIN: Error in structurefactor table designation',/
     1' ',A79)
      STOP
      ENDIF
      CALL SMLT(X,BGR)
      NPRS=NPRS+1
C
C  Input parameters are now put out in mainprogram
C     WRITE(LO,3)NPRS,X,I
C3    FORMAT(11X,I7,3(5X,F7.4),7X,I5)
      PAR(4)=1./BGR
      ITPR(1,NPRS)=I
      DO 20 II=1,6
   20 ATPR(II,NPRS)=PAR(II)
C
C  ALWAYS READ NAT ATOMS OF THE STRUCTURE (MAXIMUM)
C  NLEES=0.1*NAT DEFAULT
C  EXCEPT WHEN LESS THAN 0.1*NAT PEAKS ARE PUT IN
C
      ENDIF
      IF(NPRS.LT.NAT)GOTO 100
  200 CONTINUE
      NLEES=MIN(NLEES,NPRS)
C     NLEES=NPRS
C     CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRES,FAT,NFAT,JFAT,P1,0)
      IF(NPRS.GT.0)RETURN
      WRITE(LO,30)
   30 FORMAT(/,50H ATOMIN: AUTOFOUR fails because no peaks are given)
      STOP
      END
