      SUBROUTINE MAINS(C,A,B,NC,NNNN,NI,NAME,NM)
C
C  MAIN DRIVER ROUTINE
C
C
	REAL*8  C(NC)
      DIMENSION A(NNNN),NAME(NM)
      CHARACTER*8 NAME
      INTEGER EVEN,B(NI)
      LOGICAL READY,GO_ON,NEWFLAG,OK,CLEAN,FLAG,TOBAD,HFLAG,FLAGO
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11),
     1 ISER(10),SF,SQ,DN,XN,MH(3),ITLE(20),DM,XM
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      COMMON/TEMP/R2OLD,DLR
      COMMON/PNTR/IPNT(10),JPNT(10),S(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),ATOM(10),EXCL(10)
      EXTERNAL COUNT
C
C  INITIALIZE VARIABLES
C
      READY=.FALSE.
C
C  The value of flag is supplied by Spesin
C
C     FLAG=.TRUE.
      TOBAD=.FALSE.
	AAA=RANDOM(1)
      NSTOP=3
      ICOUNT=0
      IBEST=1
      IBAD=0
      NX=0
      NY=0
      NZ=0
      N=NNNN
      NCYCL=0
      NCTOT=0
      NREF=0
      R2ANC=1.
      R2OLD=1.
      LOCSPS=1
      LOCFT=7
C
C  LRED: REDDIFFILE INPUT REFLECTION
C
      LRED=9
C
C  LO:   LINE PRINTER
C
      LO=6
C
C  LN:   OUTPUT ATOM-FILE
C
      LN=11
C
C  LPDB: OUTPUT PDB-FILE
C
      LPDB=12
C
C  LM:   OUTPUTFILE FOR SEARCH80
C
      LM=13
C
C  LC:   CARD READER
C
      LC=1
C
C  LSCRA: SCRATCHFILE
C
      LSCRA=8
C
C  LSQ: OUTPUT FOR LEAST SQUARES PROGRAM
C
      LSQ=15
C
C  LCENT: FILE CONTAINS SWITCH INDICATING A CENTROSYMMETRIC STRUCTURE
C         BEING SOLVED BY DETER
C
      LCENT=21
C
C  LTYPE: FILE CONTAINS FLAG SIGNALING AN EQUAL_ATOM STRUCTURE
C         OR NOT
C
      LTYPE=22
C
C  LFILE: CELL AND COORDINATES OUTPUT FOR INTERMEDIATE ANALYSIS
C
      LFILE=31
      STOPR=0.
	CALL STAB
      CALL HEADER(LO)
      REWIND LRED
    1 READ(LRED)K
      IF(K.EQ.999)GOTO 2
      NREF=NREF+1
C
C   NREF IS THE DIMENSION FOR ALL VARIABLES INVOLVING STRUCTUREFACTORS
C
      GOTO 1
    2 CONTINUE
      NREF=EVEN(NREF)+1
      IFIRST=EVEN(LOCFT+17*NREF)
	LOCHKL=1
	JFIRST=1+4*NREF
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,0,LO)
      REWIND LRED
      CALL SPESIN(A(LOCSPS),N,NFAT,NAT,NLEES,PRW,BOV,SCALE,NWEG,
     1 ECHK,STLMAX,NEWFLAG,FLAG,HFLAG,LCENT,LTYPE,DREMPL,NDIF)
	CLEAN=STOPR.GT.0.3
	FLAGO=FLAG
	NATO=NAT
      MAXCY=MAX(10,INT(LOG(FLOAT(NAT))/LOG(1.2)))
      IF(STLMAX.EQ.0)STLMAX=10.0
      DLR=DELR
      NSPES=32*NFAT+38
      IFIRST=EVEN(LOCSPS+NSPES+1)
      LOCFAT=IFIRST
      CALL POINTR(A(LOCFT),NFAT,A(LOCFAT),JFAT)
c      IF(JFAT.NE.0)STOP
      IFIRST=EVEN(LOCFAT+NFAT)
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,0,LO)
      LOCREF=IFIRST
      IFIRST=LOCREF+19*NREF
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,1,LO)
      CALL RFLIN(A(LOCREF),B(LOCHKL),NREF,IREF,NFAT,A(LOCFT)
     1 ,STLMAX,A(LOCREF+7*NREF))
      WRITE(LO,4001)(IPNT(J),J=1,NFAT)
4001  FORMAT(' IPNT: ',9I5)
      WRITE(LO,4002)(JPNT(J),J=1,NFAT)
4002  FORMAT(' JPNT: ',9I5)
      WRITE(LO,4003)(KPNT(J),J=1,NFAT)
4003  FORMAT(' KPNT: ',9I5)
      WRITE(LO,4004)(LPNT(J),J=1,NFAT)
4004  FORMAT(' LPNT: ',9I5)
      MH(1)=max(mh(1),mh(2))
	mh(2)=max(mh(1),mh(2))
C
C    IREF IS THE ACTUAL NUMBER OF REFLECTIONS
C
      LOCFO=LOCREF
      LOCAC=LOCREF+NREF
      LOCBC=LOCAC+NREF
      LOCST=LOCBC+NREF
      LOCE=LOCST+NREF
      LOCSN=LOCE+NREF
      LOCH=LOCHKL
      LOCK=LOCH+NREF
      LOCL=LOCK+NREF
      LOCMRC=LOCL+NREF
	LOCFOB=LOCSN+NREF
	LOCVER=LOCFOB+NREF
	CALL WLSN2(A(LOCFO),A(LOCAC),A(LOCST),A(LOCE),IREF,NAT,
     1A(LOCSPS),BOV,SCALE,A(LOCFOB))
C      CALL WLSN2(A(LOCFO),A(LOCST),A(LOCE),IREF,NAT,
C     1 A(LOCSPS),BOV,SCALE,A(LOCFOB))
      IFIRST=EVEN(LOCVER+10*NREF)
	JFIRST=EVEN(LOCMRC+NREF)
	LOCAF=IFIRST
	IFIRST=IFIRST+NREF
	LOCBF=IFIRST
	IFIRST=IFIRST+NREF
      NRS=NSYM*NREF
      NRS2=2*NRS
      LOCSYM=IFIRST
	LOCBYM=JFIRST
      CALL GRID(NX,NY,NZ,A(LOCSPS))
      NRX=MAX0(2*NY*(MH(3)+1)*(2*MH(1)+1),(NY+2)*(NX+2)*(NZ+2),NRS)
      IFIRST=EVEN(LOCSYM+NRX)
	JFIRST=EVEN(LOCBYM+NRX)
      LSTORE=IFIRST
      IFIRST=EVEN(LSTORE+NRX)
      LBORE=JFIRST
      JFIRST=EVEN(LBORE+NRX)
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,0,LO)
      LOCIH=JFIRST
      LOCG=EVEN(IFIRST+NRS)
      JFIRST=EVEN(LOCIH+NRS)
      IFIRST=EVEN(LOCG+NRS2)
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,0,LO)
      NAT6=6*NAT
      LOCPAR=IFIRST
      IFIRST=EVEN(LOCPAR+2*NAT6)
      LOCIAR=JFIRST
      JFIRST=LOCIAR+4*NAT
      LOCC=IFIRST
      IFIRST=EVEN(LOCC+NAT+1)
      LOCS=IFIRST
      IFIRST=EVEN(LOCS+NAT+1)
      LOCTST=JFIRST
      NTRF=40
      JFIRST=EVEN(JFIRST+3*NTRF)
      LOCBES=IFIRST
      IFIRST=IFIRST+NAT6
      LOCBIS=JFIRST
      JFIRST=JFIRST+NAT*2
      LOCBAS=JFIRST
      JFIRST=JFIRST+NAT*2
      LOCPO=IFIRST
      IFIRST=IFIRST+10*NAT
C     LOCVC=IFIRST
C	NAT=NAT+1
C     IFIRST=LOCVC+NAT*2
C     LOCDEZ=IFIRST
C     IFIRST=LOCDEZ+NAT*2
C     LOCDIJ=IFIRST
C     IFIRST=LOCDIJ+NAT*NAT*4
      LOCS=IFIRST
      IFIRST=LOCS+NAT*2
      LOCC=IFIRST
      IFIRST=LOCC+NAT*2
	LOCW=IFIRST
	NATS=(2+3*NSYM)*NAT
	IFIRST=LOCW+(2+3*NSYM)*NAT
	LOCWI=JFIRST
	JFIRST=LOCWI+NAT
C	NAT=NAT-1
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,0,LO)
      CALL SYMTST(B(LOCTST),NTRF)
      CALL ATOMIN(A(LOCPAR),B(LOCIAR),NAT,NLEES,NPRS,PRES,A(LOCFT),NFAT,
     1 JFAT,PRES1,NEWFLAG)
      IPAT=0
      IDIV=0
      IFOUR=IFOUR1
      RBEST=1.0
      NBEST=1
      IFAIL=0
      R2=0.0
      R=0.0
C
C  CHECK AND PUT OUT INPUT MODEL
C
C  SORT ATOMS ON R-VALUE AT START OF THE CYCLES
C
C  DELETE ATOMS WHEN NECESSARY
C
      CALL SCHFT1(A(LOCPAR),B(LOCIAR),NAT,NLEES,NPRS,PRES,A(LOCFT),NFAT,
     1 A(LOCFAT),JFAT,A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),
     2 B(LOCK),B(LOCL),B(LBORE),IREF,PRES1,DELR,PRW,A(LOCC),A(LOCS),
     3 A(LOCSPS),STOPR,NWEG,OK,HFLAG,A(LOCFOB),A(LOCVER),A(LOCAF),
     4 A(LOCBF),A(LOCST),A(LOCW),NATS,B(LOCWI),R,R2)
      GO_ON=.TRUE.
 	ICHECK=0
 1000 CONTINUE
	NRPSO=NPRS
      IF(IPAT.EQ.1)GOTO 8
      NTOT=NQV*NPRS
C     CALL PLAATS(NREF,3*NTOT,0,LO)
      CALL PATT(A(LOCPAR),NAT,NPRS,A(LOCAC),NTOT,IPAT
     1  ,B(LOCTST),NTRF)
      CALL RFL2(A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),B(LOCK),
     1 B(LOCL),IREF,A(LOCFAT),JFAT,A(LOCPAR),B(LOCIAR),NAT,NPRS,0,0,
     2 R,R2,A(LOCC),A(LOCS),A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),
     3 A(LOCST),A(LOCW),NATS,B(LOCWI),RF)
      IF(IPAT.NE.1)GOTO 20
    8 CONTINUE
      REWIND LM
C
C  WORKING-LOOP
C
      IF(NCYCL.GT.0)THEN
      CALL SCHFT(A(LOCPAR),B(LOCIAR),NAT,NPRS,PRES,A(LOCFT),NFAT,
     1 A(LOCFAT),JFAT,A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),
     2 B(LOCK),B(LOCL),IREF,PRES1,DELR,PRW,A(LOCC),A(LOCS),NPRSO,
     3 GO_ON,STOPR,TOBAD,NLEES,HFLAG,R,R2,R2OLD,R2ANC,A(LOCFOB),
     4 A(LOCVER),A(LOCAF),A(LOCBF),A(LOCST),A(LOCW),NATS,B(LOCWI),
     5 FLAG,FLAGO)
      ENDIF
	IF(NPRS-1.EQ.NPRSO)THEN
	ICHECK=ICHECK+1
	IF(ICHECK.EQ.5)THEN
	ICHECK=0
	GOTO 2050
	ENDIF
	ELSE
	ICHECK=0
	ENDIF
      CALL ESTMTE(R2E,SR2E,PRES,A(LOCFO),A(LOCSN),IREF,0.)
      IF(NCYCL.LT.2.AND.R2*ECHK.GT.R2E) THEN
C
C  NOW ADAPT CHECK FILE FOR AUTOMATIC SOLUTION
C
      WRITE(10,4321)2
      STOP
      ENDIF
C
C  SAVE MODEL IF IT IS BETTER THAN THE BEST ONE SOFAR
C
      CALL SAVBES(A(LOCPAR),B(LOCIAR),A(LOCBES),B(LOCBIS),NPRS,NAT,NBEST
     1 ,RBEST,R2,0,DREMPL)
      IF(TOBAD)GOTO 2050
	IF(.NOT.GO_ON)THEN
	IF(R2.GT.STOPR)GOTO 2050
	IF(R2.LT.DREMPL)THEN
	IF(NPRS.EQ.NAT)GOTO 4
	IF(FLAG)GO TO 4
	IF(.NOT.READY)THEN
	READY=.TRUE.
C
C  Try to complete the model via a difference fourier map
C
	GOTO 20
	ELSE
	GOTO 4
	ENDIF
	GOTO 2000
      ELSE
	IF(.NOT.CLEAN)THEN
	CLEAN=.TRUE.
	IDIV=IDIV-1
	GOTO 2050
	ELSE
	GOTO 4
	ENDIF
	ENDIF
	ENDIF
      IF(PRES.GT.PERC.OR.NCYCL.GT.NCCH)IFOUR=IFOUR2
      IF(NCTOT.LT.150)GOTO 20
C
C Een nieuw labeltje
C
2050  CONTINUE
      TOBAD=.FALSE.
C
C  PUT OUT BEST POSSIBLE MAP, FURTHER ITERATIONS ARE USELESS
C  IF IDIV>=NSTOP
C
      IF(IDIV.GE.NSTOP)GOTO 2000
      CALL DIVERG(IDIV,NCYCL,A(LOCPAR),B(LOCIAR),NAT,NPRS,R2,R2OLD,
     1 R2ANC,R,NWEG,A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),B(LOCK)
     2 ,B(LOCL),A(LOCC),A(LOCS),A(LOCFAT),JFAT,IREF,NLEES,GO_ON,HFLAG
     3 ,B(LBORE),A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),A(LOCST),SR2E,
     4 A(LOCW),NATS,B(LOCWI))
	IF(R2.GT.STOPR)THEN
      CALL PRSNT(A(LOCPAR),B(LOCIAR),NAT,NPRS,PRES,A(LOCFT),NFAT
     1 ,JFAT,PRES1,0)
      R2OLD=1.
      R2ANC=1.
	RBEST=100.0
      IF(NPRS.LT.NLEES)THEN
      NTOT=NQV*NPRS
C     CALL PLAATS(NREF,3*NTOT,0,LO)
      CALL PATT(A(LOCPAR),NAT,NPRS,A(LOCAC),NTOT,IPAT
     1  ,B(LOCTST),NTRF)
	ENDIF
      NCYCL=0
      ENDIF
   20 CONTINUE
C
C IF READY=TRUE than the model is fine but incomplete; calculate a
C difference fourier and use a different method of adding atoms
C
      IF(R2ANC.GT.R2OLD)R2ANC=R2OLD
	IF(R2OLD.GT.R2)R2OLD=R2
      IF(LTST.NE.0.AND.(NCYCL.GT.0.OR..NOT.OK))CALL PRTST(A(LOCPAR),
     1  B(LOCIAR),NAT,NPRS,NCYCL,R2,R,A(LOCSPS))
      NCYCL=NCYCL+1
      NCTOT=NCTOT+1
C  LOCEFC toegevoegd
      CALL COEFFT(A(LOCFO),A(LOCAC),A(LOCBC),B(LOCMRC)
     1 ,IREF,IFOUR,PRES,A(LOCFOB),A(LOCAF),A(LOCBF)
     2 ,R2,NAT,NPRS,READY)
      CALL EXFFT(A(LOCFO),A(LOCAC),A(LOCBC),B(LOCH),B(LOCK),B(LOCL),
     1 IREF,A(LOCSYM),A(LSTORE),B(LBORE),NRX,B(LOCIH),A(LOCG),NRS,
     2 NX,NY,NZ)
      NPC=AMAX1(1.5*NPRS,1.5*NAT*PRES)
      IF(NPRS.LT.0.3*NAT)NPC=MIN0(NPC,NPRS+NINT(0.2*NAT))
      NPC=MIN0(NAT,NPC)
C     NPRSO=NPRS
      IFAIL=0
      CALL SEARCH(B(LBORE),B(LOCBYM),NX,NY,NZ,NRX,A(LOCPAR),B(LOCIAR)
     1 ,A(LOCPO),NAT,NPRS,NPC,NPIEK,A(LOCFT),NFAT,JFAT,IFAIL,R2
     2 ,READY)
      IF(IFAIL.EQ.-1)THEN
C
C  THERE ARE NOT ENOUGH SIGNIFICANT PEAKS IN THE MAP
C
      ICOUNT=ICOUNT+1
      IFAIL=0
      IF(ICOUNT.EQ.3)THEN
      Write(LO,55)
55    Format(/,' Model cannot be extended further. The map contains ',
     1'insufficient signifcant information')
      GOTO 2000
      ENDIF
      ENDIF
C
C  Build a new model from the old one and the output of Search
C
      CALL BUILD(A(LOCPAR),B(LOCIAR),NAT,NPRS,NPRSO,NPC,NPIEK,A(LOCFAT),
     1 JFAT,A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),B(LOCK),B(LOCL),
     2 A(LOCPO),B(LOCBAS),IREF,A(LOCC),A(LOCS),R,R2,HFLAG,NLEES,IPAT,
     3 PRES,R2OLD,R2ANC,A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),A(LOCST),
     4 SR2E,A(LOCW),NATS,B(LOCWI),READY,NATO)
C
C  Check whether Patterson is still solved
C

      NTOT=NQV*NPRS
C     CALL PLAATS(NREF,3*NTOT,0,LO)
      CALL PRSNT(A(LOCPAR),B(LOCIAR),NAT,NPRS,PRES,A(LOCFT),NFAT
     1 ,JFAT,PRES1,1)
C	IF(READY)GOTO 4
      IF(IFAIL.EQ.0)GOTO 1000
 2000 CONTINUE
C
C  SUCCESS AT LAST
C
	IF(R2.GE.DREMPL)THEN
      CALL SAVBES(A(LOCPAR),B(LOCIAR),A(LOCBES),B(LOCBIS),NPRS,NAT,NBEST
     1 ,RBEST,R2,1,DREMPL)
	ENDIF
      IF((NAT-NPRS.LE.NDIF).AND.IFAIL.NE.1.AND.STOPR.GE.R2)
     1 GOTO 4
      IFAIL=1
C     Write(lo,*)nprs,nat,ifail,stopr,r2
      WRITE(LO,5)NPRS,NAT,R2
    5 FORMAT(/,' Model incomplete or at least partially wrong: ',
     1 //' ',5X,'*** Nprs=',I5,//' ',
     2 5X,'*** Nat=',I6,//' ',5X,'*** R2= ',F6.4,//' ')
      NFAT=JFAT
      GOTO 6
    4 CONTINUE
	IF(R2.GT.RBEST)CALL
     1SAVBES(A(LOCPAR),B(LOCIAR),A(LOCBES),B(LOCBIS),NPRS,NAT,NBEST,
     2 RBEST,R2,1,DREMPL)
      CALL PRTST(A(LOCPAR),B(LOCIAR),NAT,NPRS,NCYCL,R2,R,A(LOCSPS))
C
C  NOW ADAPT CHECK FILE FOR AUTOMATIC SOLUTION
C
C  However, check first whether a centrosymmetric structure has been
C  solved in an acentric manner.
C  If so, attempt to find the shift and construct a centrosymmetric
C  model.
C
      IF(FLAG)THEN
      IBEST=0
	READY=.FALSE.
      LOCWRK=IFIRST
      IFIRST=LOCWRK+IREF
      CALL CENTRM(A(LOCFO),A(LOCAC),A(LOCBC),B(LOCH),B(LOCK),B(LOCL),
     1 A(LOCSN),A(LOCWRK),IREF,A(LOCSYM),A(LSTORE),B(LOCBYM),B(LBORE),
     2 B(LOCIH),A(LOCG),NRX,NRS,A(LOCFAT),JFAT,A(LOCC),A(LOCS),A(LOCPAR)
     3 ,B(LOCIAR),NX,NY,NZ,NAT,NPRS,IFAIL,A(LOCFOB),A(LOCVER),A(LOCAF),
     4 A(LOCBF),A(LOCST),B(LOCMRC),A(LOCW),NATS,B(LOCWI))
      IF(IFAIL.EQ.-1)THEN
      FLAG=.FALSE.
      WRITE(LO,123)
123   FORMAT(/,' Autofour is unable to find the centre of symmetry',/,
     1 ' The acentric result is put out')
      Ifail=0
      CALL PRTST(A(LOCPAR),B(LOCIAR),NAT,NPRS,NCYCL,R2,R,A(LOCSPS))
      Go to 4322
      Endif
      RBEST=100.0
      IFIRST=LOCWRK
C
C  Resume iterations
C
      R2ANC=1.0
      R2OLD=1.0
      NCYCL=1
      READY=.FALSE.
      FLAG=.FALSE.
	CLEAN=STOPR.GT.0.3
      CALL SYMTST(B(LOCTST),NTRF)
      CALL PRSNT(A(LOCPAR),B(LOCIAR),NAT,NPRS,PRES,A(LOCFT),NFAT
     1 ,JFAT,PRES1,1)
      CALL RFL2(A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),B(LOCK),
     1 B(LOCL),IREF,A(LOCFAT),JFAT,A(LOCPAR),B(LOCIAR),NAT,NPRS,0,0,
     2 R,R2,A(LOCC),A(LOCS),A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),
     3 A(LOCST),A(LOCW),NATS,B(LOCWI),RF)
      CALL SAVBES(A(LOCPAR),B(LOCIAR),A(LOCBES),B(LOCBIS),NPRS,NAT,NBEST
     1 ,RBEST,R2,0,DREMPL)
      GOTO 20
      ENDIF
 4322 Continue
      WRITE(10,4321)1
 4321 FORMAT(I1)
      NRF=30*NAT
      IF(NRF.GT.IREF-1)NRF=IREF-1
C
C  REORGANISE CORE.
C
      WRITE(LO,5002)
5002  FORMAT(/,' Reorganizing core')
      IFIRST=EVEN(LOCFAT+NFAT)
      CALL SCHAR(A,N,NREF,LOCFO,IFIRST)
      LOCFO=IFIRST
      IFIRST=LOCFO+NREF
      CALL SCHAR(A,N,NREF,LOCAC,IFIRST)
      LOCAC=IFIRST
      IFIRST=LOCAC+NREF
      CALL SCHAR(A,N,NREF,LOCBC,IFIRST)
      LOCBC=IFIRST
      IFIRST=LOCBC+NREF
      CALL SCHAR(A,N,NREF,LOCST,IFIRST)
      LOCST=IFIRST
	IFIRST=LOCST+NREF
      CALL SCHAR(A,N,NREF,LOCE,IFIRST)
      LOCE=IFIRST
	IFIRST=LOCE+NREF
      CALL SCHAR(A,N,NREF,LOCSN,IFIRST)
      LOCSN=IFIRST
      IFIRST=LOCSN+NREF
      CALL SCHAR(A,N,NREF,LOCFOB,IFIRST)
      LOCFOB=IFIRST
      IFIRST=IFIRST+NREF
      CALL SCHAR(A,N,10*NREF,LOCVER,IFIRST)
      LOCVER=IFIRST
      IFIRST=IFIRST+10*NREF
      CALL SCHAR(A,N,NREF,LOCAF,IFIRST)
      LOCAF=IFIRST
      IFIRST=IFIRST+NREF
      CALL SCHAR(A,N,NREF,LOCBF,IFIRST)
      LOCBF=IFIRST
      IFIRST=IFIRST+NREF
C  Tijdelijk
C     CALL SCHAR(A,N,NREF,LOCEFC,IFIRST)
C     LOCEFC=IFIRST
C     IFIRST=IFIRST+NREF
      CALL SCHAR(A,N,NAT6,LOCPAR,IFIRST)
      LOCPAR=IFIRST
      IFIRST=LOCPAR+NAT6
      CALL COUNT(B(LOCIAR),NAT,NVAST,A(LOCFAT),JFAT)
      NPR=NPRS-NVAST
      NP1=NPR+1
C
C  HERE THE DOUBLE PRECISION VALUES ARE USED
C  IF THERE ARE TO MANY ATOMS THIS IS NOT USED
C
	KFIRST=1
	NATMAX=SQRT(FLOAT(NC))/2
	IF(NAT.LT.NATMAX)THEN
      LOCVC=KFIRST
      KFIRST=LOCVC+NAT
      LOCDEZ=KFIRST
      KFIRST=LOCDEZ+NAT
      LOCDIJ=KFIRST
      KFIRST=LOCDIJ+NAT*NAT
	ELSE
	LOCVC=1
	LOCDEZ=1
	LOCDIJ=1
	ENDIF
      LOCS=IFIRST
      IFIRST=LOCS+NAT*2
      LOCC=IFIRST
      IFIRST=LOCC+NAT*2
	LOCW=IFIRST
	IFIRST=LOCW+(2+3*NSYM)*NAT
	LOCWI=JFIRST
	JFIRST=LOCWI+NAT
      CALL UNITY(A(LOCFAT),JFAT)
      IF(NPRS.EQ.NAT)THEN
      WRITE(LO,7)
7     FORMAT(/,' Model complete'/
     1 ' Determination of atomic numbers starts now')
      WRITE(LO,5001)
5001  FORMAT(/,' Calling DEVINE')
      CALL SAVBES(A(LOCPAR),B(LOCIAR),A(LOCBES),B(LOCBIS),NPRS,NAT,NBEST
     1 ,RBEST,R2,0,DREMPL)
      CALL DEVINE(A(LOCFO),B(LOCH),B(LOCK),B(LOCL),A(LOCSN),A(LOCFAT),
     1 NRF,JFAT,A(LOCFT),NFAT,C(LOCVC),C(LOCDEZ),A(LOCC),A(LOCS),
     2 C(LOCDIJ),NP1,A(LOCPAR),B(LOCIAR),NAME,NPRS,NAT,NPR,PRES
     3 ,A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),A(LOCST),A(LOCW),NATS,
     4 NATMAX,B(LOCWI))
      CALL RFLSIN(A(LOCFT),A(LOCFAT),NFAT)
      ELSE
      WRITE(LO,77)
77    FORMAT(/,' Model not complete, ',/,
     1' Autofour cannot find some of the relatively light atoms',/,
     2' View the atomic numbers given with healthy suspicion!')
      CALL DEVINE(A(LOCFO),B(LOCH),B(LOCK),B(LOCL),A(LOCSN),A(LOCFAT),
     1 NRF,JFAT,A(LOCFT),NFAT,C(LOCVC),C(LOCDEZ),A(LOCC),A(LOCS),
     2 C(LOCDIJ),NP1,A(LOCPAR),B(LOCIAR),NAME,NPRS,NAT,NPR,PRES
     3 ,A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),A(LOCST),
     4 A(LOCW),NATS,NATMAX,B(LOCWI))
      ENDIF
      LOCG=IFIRST
      IFIRST=EVEN(LOCG+NRS2)
      LOCC=IFIRST
      IFIRST=LOCC+NAT*2
      LOCS=IFIRST
      IFIRST=LOCS+NAT*2
      LOCSYM=IFIRST
      IFIRST=EVEN(LOCSYM+NRX)
      LSTORE=IFIRST
      IFIRST=EVEN(LSTORE+NRX)
      CALL PLAATS(N,IFIRST-1,NI,JFIRST-1,0,LO)
      READY=.FALSE.
    6 CONTINUE
C     CALL PHKL(A(LOCH),A(LOCK),A(LOCL),A(LOCFO),IREF,A(LOCFAT),NFAT)
      CALL RFL2(A(LOCFO),A(LOCAC),A(LOCBC),A(LOCSN),B(LOCH),B(LOCK),
     1 B(LOCL),IREF,A(LOCFAT),NFAT,A(LOCPAR),B(LOCIAR),NAT,NPRS,0,0,
     2 R,R2,A(LOCC),A(LOCS),A(LOCFOB),A(LOCVER),A(LOCAF),A(LOCBF),
     3 A(LOCST),A(LOCW),NATS,B(LOCWI),RF)
      CALL COEFFT(A(LOCFO),A(LOCAC),A(LOCBC),B(LOCMRC),
     1 IREF,IFOUR2,PRES,A(LOCFOB),A(LOCAF),A(LOCBF),
     2 R2,NAT,NPRS,READY)
      CALL EXFFT(A(LOCFO),A(LOCAC),A(LOCBC),B(LOCH),B(LOCK),B(LOCL),
     1 IREF,A(LOCSYM),A(LSTORE),B(LBORE),NRX,B(LOCIH),A(LOCG),
     2 NRS,NX,NY,NZ)
      IF(IFAIL.EQ.1)NCYCL=-1
      CALL AFWKL(B(LBORE),A(LOCSYM),A(LOCPAR),B(LOCIAR),NAME,NAT,
     1 NCYCL,R2,R,NX,NY,NZ,A(LOCSPS),B(LBORE),A(LOCBC),A(LOCFT),
     2 NFAT,JFAT,NRX,NPRS,BOV)
      RETURN
      END
