      SUBROUTINE RFL2(FO,AC,BC,SN,IH,IK,IL,NREF,FAT,NFAT,ATPR,ITPR,
     1 NAT,NPRS,ISW,IFT,R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,
     2 IWORK,RF)
      DIMENSION FOBS(NREF),VER(10,NREF),ACALC(NREF),BCALC(NREF)
      DIMENSION C(NAT),S(NAT)
C
C  CALCULATE R2 AND R, CALLS ROUTINE FCALC
C  ISW: 0, NORMAL STRUCTURE FACTOR CALCULATION
C   >0, ATOM(ISW) IS SUBTRACTED FROM STRUCTURE FACTORS BASED ON
C  THE MODEL OF NPRS ATOMS, TABLE IFT IS USED RESULT IS NOT STORED!
C   <0 as >0, ONLY THE CONTRIBUTION IS ADDED
C  IF NPRS EQUALS 0 THAN AC, BC AND FC ARE ZEROED
C
      DIMENSION FO(NREF),AC(NREF),BC(NREF),SN(NREF),IH(NREF),IK(NREF),
     1 IL(NREF),FAT(NFAT),ATPR(6,NAT),ITPR(2,NAT),ST(NREF),
     2 WORK(NATS),IWORK(NAT)
      COMMON/PNTR/IPNT(10),JPNT(10),SS(10),KPNT(10),NMO(10),KV(10),
     1 LPNT(10),ATOM(10),EXCL(10)
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      IF(NPRS.EQ.0)THEN
      R=1.0
      R2=1.0
      DO 200 IREF=1,NREF
      AC(IREF)=0.0
200   BC(IREF)=0.0
      RETURN
      ENDIF
	IF(ISW.NE.0)THEN
	ISTART=IABS(ISW)
	IFIN=ISTART
	ELSE
	ISTART=1
	IFIN=NPRS
	ENDIF
	M=0
	DO 300 I=ISTART,IFIN
	M=M+1
	ITBL=ITPR(1,I)
	TF=FAT(ITBL)*ATPR(6,I)
	IF(IFT.GT.0)TF=FAT(IFT)*ATPR(6,I)-TF
	MTBL=IPNT(ITBL)
	IF(MTBL.EQ.0)MTBL=1
	IWORK(I)=MTBL
	WORK(M)=TF
	M=M+1
	WORK(M)=ATPR(4,I)
	DO 301 J=1,3
	M=M+1
	WORK(M)=ATPR(J,I)
301	CONTINUE
	DO 302 NS=2,NSYM
	X=0.0
	Y=0.0
	Z=0.0
	DO 303 II=1,3
      X=ATPR(II,I)*RS(1,II,NS)+X
      Y=ATPR(II,I)*RS(2,II,NS)+Y
      Z=ATPR(II,I)*RS(3,II,NS)+Z
303   CONTINUE
	M=M+1
      WORK(M)=X+TX(1,NS)
	M=M+1
      WORK(M)=Y+TX(2,NS)
	M=M+1
      WORK(M)=Z+TX(3,NS)
302	CONTINUE
300   CONTINUE
      R=0.
      R2=0.
      RN=0.
      R2N=0.
	R2F=0.0
	R2FN=0.0
      DO 100 IREF=1,NREF
      EPS=SN(IREF)
      IF(EPS.EQ.0.)GOTO 100
      I=-IH(IREF)-IK(IREF)
      CALL FCALC(A,B,EPS,IH(IREF),IK(IREF),IL(IREF),I,WORK,
     1 IWORK,NATS,NAT,NPRS,ISW,IFT,C,S,VER(1,IREF),AF,BF)
C     IF(IREF/100*100.EQ.IREF)THEN
C     WRITE(6,*)IH(IREF),IK(IREF),IL(IREF),FO(IREF),A,B,EPS
C     IF(IREF.GT.1500)STOP
C     ENDIF
      IF(ISW)20,40,50
   20 CONTINUE
      A=AC(IREF)+A
      B=BC(IREF)+B
	AF=ACALC(IREF)+AF*ST(IREF)
	BF=BCALC(IREF)+BF*ST(IREF)
      GO TO 60
   40 CONTINUE
      AC(IREF)=A
      BC(IREF)=B
	ACALC(IREF)=AF*ST(IREF)
	BCALC(IREF)=BF*ST(IREF)
      GOTO 60
   50 CONTINUE
      A=AC(IREF)-A
      B=BC(IREF)-B
	AF=ACALC(IREF)-AF*ST(IREF)
	BF=BCALC(IREF)-BF*ST(IREF)
   60 CONTINUE
      FOB=FO(IREF)
      AIC=A*A+B*B
      FC=SQRT(AIC)
	AICF=AF**2+BF**2
	AIOF=FOBS(IREF)**2
      AIO=FOB*FOB
      DF=FOB-FC
      DI=AIO-AIC
      R=R+DF*DF
      R2=R2+DI*DI
      RN=RN+AIO
      R2N=R2N+AIO*AIO
	R2F=R2F+(AIOF-AICF)**2
	R2FN=R2FN+AIOF**2
  100 CONTINUE
      R=R/RN
      R2=R2/R2N
	RF=R2F/R2FN
      RETURN
      END
