      SUBROUTINE RSTRC(H,K,L,EPS,MRC)
C
C  SPOT RESTRICTED REFLEXIONS (CF MULTAN80)
C
      DIMENSION KHL(3),LHK(3)
      INTEGER H,EPS
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1  ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
C
C  PHASE IS RESTRICTED IF THERE IS AT LEAST ONE SYMMETRYOPERATION A SO
C  THAT A(H,K,L)=-H,-K,-L IN THE POINT GROUP.
C
      LHK(1)=H
      LHK(2)=K
      LHK(3)=L
      EPS=0
      GOTO (1000,20,30,40,50,60,70),LATT
   20 CONTINUE
C
C  A-LATTICE
C
      IF(MOD(K+L,2).NE.0)GOTO 2000
      GOTO 1000
   30 CONTINUE
C
C  B-LATTICE
C
      IF(MOD(H+L,2).NE.0)GOTO 2000
      GOTO 1000
   40 CONTINUE
C
C  C-LATTICE
C
      IF(MOD(H+K,2).NE.0)GOTO 2000
      GOTO 1000
   50 CONTINUE
C
C  I-LATTICE
C
      IF(MOD(H+K+L,2).NE.0)GOTO 2000
      GOTO 1000
   60 CONTINUE
C
C  F-LATTICE
C
      KK=MOD(H,2)
      IF(KK.NE.MOD(K,2))GOTO 2000
      IF(KK.NE.MOD(L,2))GOTO 2000
      GOTO 1000
   70 CONTINUE
C
C  R-LATTICE; HEXAGONAL SETTING
C
      IF(MOD(K+L-H,3).NE.0)GOTO 2000
 1000 EPS=1
C
C  REFLECTION NOT FORBIDDEN BY LATTICE; PERHAPS BY SYMMETRYELEMENTS
C
      MRC=1
      IF(MCENTR.NE.0)MRC=3
      IC=2*MCENTR+1
      DO 5 N=1,IC,2
      ISN=2-N
      DO 5 J=1,NSYM
      DO 1 KK=1,3
    1 KHL(KK)=0
      DO 3 KK=1,3
      DO 2 LL=1,2
      M=IABS(IS(LL,KK,J))
      IF(M.NE.0)KHL(M)=KHL(M)+ISN*LHK(KK)*ISIGN(1,IS(LL,KK,J))
    2 CONTINUE
    3 CONTINUE
      DO 4 KK=1,3
      IF(LHK(KK)+KHL(KK))7,4,7
    4 CONTINUE
      MRC=3
      GOTO 5
    7 CONTINUE
      DO 6 KK=1,3
      IF(LHK(KK)-KHL(KK))5,6,5
    6 CONTINUE
      S=0.
      DO 8 KK=1,3
    8 S=S+LHK(KK)*TS(KK,J)
      S=S-AINT(S)
C
C  SYSTEMATIC ABSENT REFLEXIONS ARE INDICATED BY EPS=0
C
      IF(S.NE.0.)EPS=0
    5 CONTINUE
 2000 RETURN
      END
