      SUBROUTINE SCHFT1(ATPR,ITPR,NAT,NLEES,
     1 NPRS,PRS,FAT,NFAT,FT,JFAT,FO,AC,BC,SN,H,K,IL,
     2 POINT,NR,P1,DELR,PRW,C,S,CELL,STOPR,NWEG,OK,HFLAG,
     3 FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,R,R2)
C
C  Version March 1998
C
      DIMENSION C(NAT),S(NAT),IWORK(NAT),WORK(NATS),CELL(6)
C
C  USE R2-CRITERION TO DISCARD WRONG ATOMS FROM INPUTMODEL
C
      DIMENSION FAT(32,NFAT),FT(JFAT),FO(NR),AC(NR),BC(NR),SN(NR),
     1 H(NR),K(NR),IL(NR),FOBS(NR)
      DIMENSION VER(10,NR),ACALC(NR),BCALC(NR),ST(NR)
      DIMENSION ATPR(6,NAT),ITPR(2,NAT)
      INTEGER H,POINT(NAT,2)
C	REAL*8 VC(N1),DE(N1),DIJ(N1,N1)
      LOGICAL OK,HFLAG
      COMMON/PNTR/IPNT(10),JPNT(10),Q(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),ATOM(10),EXCL(10)
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
C
C  Check inputmodel against specified atomic numbers
C  Assign best possible atomic number to atoms put in
C
C	NLEES=3
	SR2E=0.0
      CALL HEAVY4(ATPR,ITPR,NAT,NPRS,FT,JFAT,FO,AC,BC,SN,H,K,
     1            IL,POINT,NR,C,S,R,R2,NLEES,DUM,DUM,
     2 FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK)
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
C
C  INITIALIZE R2 FACTOR AND CALCULATE STRUCTUREFACTORS
C
C  REMOVE NON-HEAVY ATOMS FROM INPUT IF REQUIRED
C
      IF(HFLAG.AND.R2.GT.STOPR)THEN
      NU=0
      DO 1 I=1,NPRS
      IF(ITPR(1,I).NE.JFAT)THEN
      NU=NU+1
      ELSE
      NPRS=NU
      CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,JFAT,P1,1)
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
      RETURN
      ENDIF
1     CONTINUE
      CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,JFAT,P1,1)
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 R,R2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
	IF(NPRS.EQ.1)RETURN
      ENDIF
      CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,JFAT,P1,1)
      CALL PRTST(ATPR,ITPR,NAT,NPRS,-1,R2,R,CELL)
      CALL ESTMTE(R2E,SR2E,PRS,FO,SN,NR,0.)
      IF(NPRS.NE.1.AND.R2.GT.0.4) THEN
      CALL ESTMTE(R2E,SR2E,PRS,FO,SN,NR,P1)
      IF(R2E-SR2E.LT.R2.AND.NPRS.GT.NLEES) THEN
      WRITE(LO,100)R2,R2E
100   FORMAT(/,' SCHFT: R2,R2E=',2(F5.3,1X),'not all atoms are correct')
      OK=.FALSE.
      IWEG=MAX(NWEG*NPRS/100,1)
1000  CONTINUE
      DO 10 I=1,NPRS
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,I,0,
     1 R,ATPR(5,I),C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
   10 CONTINUE
      CALL SORT2(ATPR,6,NAT,NPRS,5,ITPR)
      NPRS=MIN(20,NPRS)
      NPRS=MAX(NLEES,NPRS-IWEG)
      CALL RFL2(FO,AC,BC,SN,H,K,IL,NR,FT,JFAT,ATPR,ITPR,NAT,NPRS,0,0,
     1 RR,RR2,C,S,FOBS,VER,ACALC,BCALC,ST,WORK,NATS,IWORK,RF)
      IF(NPRS.GT.NLEES)GO TO 1000
C     CALL GEOM(ATPR,NPRS)
C     CALL SORT2(ATPR,6,NAT,NPRS,5,ITPR)
      CALL PRSNT(ATPR,ITPR,NAT,NPRS,PRS,FAT,NFAT,JFAT,P1,1)
      ENDIF
      ENDIF
	OK=.TRUE.
      RETURN
      END
