	SUBROUTINE WLSN2(FO,PS,ST,SN,NREF,NAT,CEL,BOV,SCALE,FOBS)
      DIMENSION FO(NREF),SN(NREF),ST(NREF),FOBS(NREF),PS(NREF)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11),
     1 ISER(10),SF,SQ,DN,XN,MH(3),ITLE(20),DM,XM
C
C  THE FOLLOWING STATEMENTS ARE ONLY FOR USE IN THE LEIDEN
C  CRYSTALLOGRAPHIC SYSTEM.
C
      CHARACTER*4 A(2),B(2)
C
      DIMENSION CEL(6),CELL(6)
C
C  WILSON SCALE AND B-OVERALLFROM CARD
C  BOTH AS CALCULATED BY REDDIFC4
C
      REWIND LSQ
      WRITE(LSQ,4)(ITLE(ITL),ITL=1,18)
    4 FORMAT('TITLE   ',18A4)
      DO 7 J=1,6
    7 CELL(J)=CEL(J)
      PIR=3.14159265/180.
      DO 8 J=4,6
    8 CELL(J)=COS(CELL(J)*PIR)
      WRITE(LSQ,5)CELL
    5 FORMAT('CELL  ',F15.6,5F10.6)
      NGR=3
      NTW=0
      WRITE(LSQ,6)NAT,NGR,NTW
    6 FORMAT('NANTOM',I4,'NSCAL',I5,'NTWIN',I5)
      WRITE(LSQ,2)SCALE,SCALE,SCALE
C
C  THE FOLLOWING STATEMENTS ARE ONLY FOR USE IN THE LEIDEN
C  CRYSTALLOGRAPHIC SYSTEM.
C
C  VAX ADAPTATION
C
C     CALL DATIM(A,B)
      A(1)='    '
      A(2)='    '
      B(1)='    '
      B(2)='    '
      WRITE(LSQ,1001)BOV,A,B
 1001 FORMAT(F10.5,5X,'DATE:  ',2A4,'TIME:  ',2A4)
C
C     WRITE(LSQ,2)BOV
    2 FORMAT(8F10.5)
      WRITE(LO,3)BOV,SCALE
3     FORMAT(/,' WLSN2: B-overall: ',F7.4,5X,'Scale-factor: ',F7.4)
C
10    CONTINUE
      DO 100 I=1,NREF
      EPS=SN(I)
	SN(I)=PS(I)
      IF(EPS.EQ.0.)GOTO 100
      CORR=BOV*ST(I)
C
C FOBS is fobs op absolute schaal met Bov meegenomen.
C FO=Eobs
C ST(I) contains the damping due to the temperature factor
C
	ST(I)=EXP(-CORR)
      CORR=EXP(CORR)/EPS
	FOBS(I)=FO(I)*SCALE
      FO(I)=SCALE*CORR*FO(I)
C
C  FO NOW CONTAINS EO
C
  100 CONTINUE
      RETURN
      END
