       program conhkl
C
C  Convert arbitrary hkl F or F**2 file into .frefa file
C
       Integer h,number(20)
       Logical kwad
       Character eind*1,regel*80,string*80,upper*80
       eind='E'
C      scale=1.0
       Read(10,1)regel
       Call Getfo(regel,number,ifail,kwad)
       If(ifail.eq.-1)Then
       string='The header of your file is incorrect. Consult the manual'
C      Write(6,*)string
       Stop
4      Format(8A)
       Endif
       nrec=0
100    Continue
C      Read(10,1)h,k,l,obs,sobs
       Read(10,1,End=1000)regel
       nrec=nrec+1
       regel=upper(regel)
C      Write(*,*)nrec,regel
       Call Getf(regel,number,h,k,l,obs,sobs,nrec,ifail)
       If(ifail.ne.0)Then
       Write(6,101)nrec,regel
101    Format(' The following record, number',i5,
     1 ' cannot be interpreted',/' ',a79)
       Stop
       Endif
       If(h.eq.0.and.k.eq.0.and.l.eq.0)go to 1000
       If(kwad)Then
C      obs=obs*scale
C      sobs=sobs*scale
       if(obs.gt.1.0e-5)Then
       sobs=sobs/obs
       obs=sqrt(obs)
       sobs=0.5*sobs*obs
       Else
       obs=0.0
       sobs=1.0
       Endif
       Endif
C1      Format(3i4,2f8.0)  
1      Format(A80)
       kode=2
       If(obs.gt.4.0*sobs)kode=0
       if(sobs.gt.999.0)sobs=999.0
       Write(11,2)h,k,l,kode,obs,sobs
2      Format(I4,2I3,I2,F9.2,f7.2)
       Goto 100
1000   Write(11,3)Eind
3      Format(A1)
       string='Ready, normal end'
C      Write(6,*)string
       Stop
       End
      character*80 function upper(string)
      character*100 up,down
      character*(*) string
      character*80 onder
      character a
      UP  ='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      DOWN='abcdefghijklmnopqrstuvwxyz'
      onder=string
      lengte=len(string)
      Do 1 i=1,lengte
      a=onder(i:i)
      Do 2 j=1,26
      if(a.eq.down(j:j))Then
      a=up(j:j)
      goto 3
      endif
2     continue
3     onder(i:i)=a
1     continue
      upper=onder
      RETURN
      END
      REAL FUNCTION val(ST)
      character*(*) ST
      character a
      LOGICAL*4 SE,SM,EP,RE
      INTEGER*4 CH,IEX,LES,I,MAN,IREST,JEX
C     init
      SM=.false.
      EP=.FALSE.
      SE=.false.
      RE=.false.
      IEX=0
      JEX=1
      EX=1.0D0
      MAN=0
      IREST=0
      LES=LEN(ST)
      I=0
 10   I=I+1
      a=st(I:I)
      CH=ICHAR(a)
      if((CH.EQ.43).OR.(CH.EQ.45)) THEN
      if(.not.ep)Then
c-----sign mantisse
                IF(CH.EQ.45) SM=.TRUE.           ! +
                IF(CH.EQ.43) SM=.FALSE.          ! -
      Else
c-----sign exponent
                IF(CH.EQ.45) SE=.TRUE.
                IF(CH.EQ.43) SE=.FALSE.
      endif
      Elseif(ch.eq.46)Then
      re=.true.
      ELSEIF((CH.GE.48).AND.(CH.LE.57)) THEN     !0< CH < 9
      if(.not.ep)Then
      if(.not.re)Then
C-----MANTISSE
      MAN=MAN*10+CH-48
      Else
C-----mantisse achter de komma
      jex=jex*10
      irest=irest*10+ch-48
      endif
      Else
c-----exponent
      iex=iex*10+ch-48
      endif
      Elseif(ch.eq.69.or.ch.eq.101.or.ch.eq.68.or.ch.eq.100)Then  !d,e,D
C     EXPONENT
      ep=.true.
      endif
      If(i.lt.les)goto 10
      tisse=MAN+IREST/float(JEX)
      IF(EP) THEN
        EX=10.0**IEX
        IF (SE) EX=1.0/EX
      ENDIF
      tisse=tisse*ex
      IF(SM)tisse=-tisse
      val=tisse
      Return
      end
      Subroutine Getf(regel,number,h,k,l,obs,sobs,nrec,ifail)
      Integer h,number(20)
      Dimension X(20)
      Character*(*) regel
      Character blank*1,string*80,comma*1
      Do 40 i=1,20
40    x(i)=0.0
      blank=' '
      comma=','
      i=0
      nvar=0
      ifail=0
1     Continue
      i=i+1
      If(i.gt.80)Go to 10
      If(regel(i:i).eq.blank.or.regel(i:i).eq.comma)go to 1
      Iplek=i
      Do 2 j=iplek,80
      If(regel(j:j).eq.blank.or.regel(j:j).eq.comma)Then
      string(1:j-iplek)=regel(iplek:j-1)
      Call Calc(string(1:j-iplek),iplek,x,nvar,nrec,ifail)
C     Write(*,*)(x(jj),jj=1,nvar)
C     write(*,*)ifail
      i=j
      go to 1
      endif
2     Continue
10    Continue
      i=0
      nvar=0
20    i=i+1
      If(i.gt.20)Goto 30
      If(number(i).eq.1)Then
      h=x(i)+sign(0.1,x(i))
      k=x(i+1)+sign(0.1,x(i+1))
      l=x(i+2)+sign(0.1,x(i+2))
      i=i+2
      nvar=nvar+3
      endif
      If(number(i).eq.4)Then
      obs=x(i)
      nvar=nvar+1
      endif
      If(number(i).eq.5)Then
      sobs=x(i)
      nvar=nvar+1
      endif 
      Goto 20
30    Continue
      If(nvar.ne.5)Then
      string='Error in your file, abnormal end'
      Write(6,*)string
      Stop
      Endif
C     write(6,*)X
C     write(6,*)regel
C     write(6,*)number
C     write(6,*)h,k,l,obs,sobs
      Return
      End
      Subroutine Getfo(regel,number,ifail,kwad)
      Character*(*) regel
      Dimension number(20)
      Logical kwad
      Character*80 upper
      Character hkl*3,fobs*4,f2obs*5,sigma*5,skip*4,blank*1,word*10
      Do 10 i=1,20
10    number(i)=0
      skip='SKIP'
      fobs='FOBS'
      f2obs='F2OBS'
      sigma='SIGMA'
      hkl='HKL'
      kwad=.false.
      nword=0
      i=0
      blank=' '
1     Continue
      i=i+1
      If(i.gt.80)goto 1000
      If(regel(i:i).eq.blank)goto 1
      iplek=i
      Do 2 j=iplek,80
      If(regel(j:j).ne.blank)goto 2
      word=upper(regel(iplek:j-1))
      Goto 3
2     Continue
3     nword=nword+1
      If(word.eq.hkl)Then
      Do 11 m=1,3
      number(nword)=m
11    nword=nword+1
      nword=nword-1
      Endif
      If(word.eq.fobs)Then
      number(nword)=4
      Endif
      If(word.eq.f2obs)Then
      number(nword)=4
      kwad=.true.
      Endif
      If(word.eq.sigma)Then
      number(nword)=5
      Endif
      If(word.eq.skip)Then
      number(nword)=-1
      Endif
      i=j-1
      Goto 1
1000  Continue
      isum=0
      Do 20 i=1,20
      If(number(i).gt.0)isum=isum+number(i)
20    Continue
C     Write(*,*)number,isum
      If(isum.ne.15)ifail=-1
      Return
      End
      Subroutine Calc(string,iplek,x,nvar,nrec,ifail)
      Dimension x(20)
      Character*(*) string
      Character*1 dot,mi,plus,e,d,ch
      Logical ex
      dot='.'
      mi='-'
      plus='+'
      l=Len(string)
100   Continue
      ex=.false.
      e='E'
      d='D'
      ndot=0
      nteken=0
      nee=0
      nde=0
      nexp=0
      nvar=nvar+1
C     write(*,*)l,string
      Do 1 i=1,l
      ch=string(i:i)
      If(ndot.eq.0.and.ch.eq.dot)ndot=i
      If(i.gt.1)Then
      If(nteken.eq.0.and.ch.eq.mi)nteken=i
      If(nteken.eq.0.and.ch.eq.plus)nteken=i
      If(nee.eq.0.and.ch.eq.e)nee=i
      If(nde.eq.0.and.ch.eq.d)nde=i
      endif
1     Continue
      ex=(nee.ne.0.or.nde.ne.0)
      If(nee.gt.0.and.nde.gt.0)Then
      nexp=min(nee,nde)
      Else
      nexp=max(nee,nde)
      endif
      If(nteken.eq.0)Then
      x(nvar)=val(string(1:l))
      Return
      Else
      If(nteken.gt.ndot.and.(.not.ex))Then
      x(nvar)=val(string(1:nteken-1))
      j=0
      Do 10 i=nteken,l
      j=j+1
      string(j:j)=string(i:i)
10    Continue
      l=l-nteken+1
      if(l.lt.2)Then
      Return
      Else
      Goto 100
      endif
      Else
      If(.not.ex)Then
      x(nvar)=val(string(1:nteken-1))
      j=0
      Do 11 i=nteken,l
      j=j+1
      string(j:j)=string(i:i)
11    Continue
      l=l-nteken+1
      if(l.lt.2)Then
      Return
      Else
      Goto 100
      endif
      Else
C     write(*,*)nteken,nexp
      If(nteken.eq.nexp+1)Then
      lexp=0
      Do 4 i=nteken+1,l
      ch=string(i:i)
      If(ch.eq.dot)ifail=1
      If(ch.eq.plus.or.ch.eq.mi)Then
      left=l-i+1
      lexp=i
      Goto 3
      Endif
4     Continue
      left=0
3     Continue
      If(lexp-nteken.gt.3)ifail=1
      If(ifail.eq.0)Then
      x(nvar)=val(string(1:l-left+1))
      if(left.gt.1)Then
      j=0
      jj=lexp
      Do 12 i=1,left
      j=j+1
      string(j:j)=string(jj:jj)
      jj=jj+1
12    Continue
      l=left
      Goto 100
      Endif
      Endif
      Else
      x(nvar)=val(string(1:nteken-1))
      j=0
      Do 13 i=nteken,l
      j=j+1
      string(j:j)=string(i:i)
13    Continue
      l=l-nteken+1
      if(l.lt.2)Then
      Return
      Else
      Goto 100
      Endif
      Endif
      Endif
      Endif
      Endif
      Return
      End
