      SUBROUTINE SCHUIF(NNRM,NM,C,D,DC,W,FAS,G,IJP,IJQ,NFS,NIJQ)
C
C  NM = INPUT =
C  DECLARED DIMENSIONS OF THE MATRICES
C
C  C(NM,NM,NNRM),
C  D(NM,NM,NNRM), DC(NM,NNRM)
C
C  IJP,IJQ: = INPUT = SEE OPINIT
C  W(NFS): = OUTPUT = SHIFTS BEFORE FUDGE
C  FAS: = INPUT = PHASES
C  GRAD: = INPUT = GRADIENTS
C
      DIMENSION C(NM,NM,NNRM)
      DIMENSION D(NM,NM,NNRM)
      DIMENSION DC(NM,NNRM)
      DIMENSION IJP(7,NFS),IJQ(8,NIJQ),W(NFS)
      DIMENSION FAS(NFS),G(NFS)
	PI=4.0*ATAN(1.0)
	TWOPI=2.0*PI
	PID12=PI/12.0
      DO 280 I=1,NNRM
      CALL FASHI(C(1,1,I),D(1,1,I),DC(1,I),
     1 C(1,1,I),D(1,1,I),DC(1,I),NM,NM)
  280 CONTINUE
      DO 320 I=1,NFS
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      MA=IJP(3,I)
      IBE=IJP(4,I)
      IEI=IJP(5,I)
      MK=IJP(6,I)
      W(I)=0.0
C
C  ALPHA = PHASE IN A
C  BETA = PHASE IN INVERSE OF A
C  BEMALP = USED FOR DAMPING
C  DPA, DPB = CALCULATED TO OBTAIN AVERAGE BETA
C
      ALPHA=FAS(I)
      BETA=D(IKO,IRY,MA)
      BEMALP=AMOD(BETA-ALPHA,TWOPI)
      IF(BEMALP.LT.0) BEMALP=BEMALP+TWOPI
      BEMALP=ABS(SIN(BEMALP/2))
      FU=1
      DPA=SIN(BETA)
      DPB=COS(BETA)
      IF(IEI.EQ.0) GOTO 321
      DO 310 J=IBE,IEI
      JRY=IJQ(1,J)
      JKO=IJQ(2,J)
      JMA=IJQ(3,J)
      ISS=IJQ(7,J)
      IT=IJQ(8,J)
      BETA=D(JKO,JRY,JMA)
      F=ISS*PID12
C
C  BETA-F--->(BETA-F)
C
      BETA=(1-2*IT)*(BETA-F)
      DPA=DPA+SIN(BETA)
  310 DPB=DPB+COS(BETA)
      BETA=ATAN2(DPA,DPB)
      BEMALP=AMOD(BETA-ALPHA,TWOPI)
      IF(BEMALP.LT.0) BEMALP=BEMALP+TWOPI
C
C  NOW USE ABS OF SINUS !!!
C
      BEMALP=ABS(SIN(BEMALP/2.))
      FU=SQRT(DPA**2+DPB**2)/(IEI-IBE+2)
  321 CONTINUE
      FU=FU*BEMALP
      IF(ALPHA.GT.PI) ALPHA=ALPHA-TWOPI
      IF(ALPHA.LT.-PI) ALPHA=ALPHA+TWOPI
	S=ALPHA-BETA+PI
	IF(S.LT.-PI)S=S+TWOPI
	IF(S.GT.PI)S=S-TWOPI
	S=S*FU
      W(I)=S
  320 CONTINUE
C
C  ZERO CALCULATED SHIFT IF SIGN DOES NOT MATCH GRADIENT
C  SD = TOTAL ABS SHIFT, ND = NUMBER OF PHASES WITH NONZERO SHIFT
C
      SD=0
      ND=0
      DO 450 I=1,NFS
C     IF(IJP(6,1).EQ.1) THEN
C     IF(W(I)*G(I).LT.0) THEN
C	W(I)=0.0
C	GOTO 450
C	ENDIF
C	ENDIF
      SD=SD+ABS(W(I))
      ND=ND+1
  450 CONTINUE
      IF(ND.NE.0) SD=SD/ND
      IF(ND.EQ.0) SD=PI/50.
C
C  ADD SHIFT IN DIRECTION OF GRADIENT
C
      DO 455 I=1,NFS
      IF(IJP(6,I).NE.1) GOTO 455
      W(I)=W(I)+SIGN(SD,G(I))
  455 CONTINUE
      RETURN
      END
