      SUBROUTINE WRFOUR(MX,NNRM,NM,IJP,NIJP,IJQ,NIJQ,EMX,
     1 PMX,GMX,HMX,NUMSET,H,K,L,A,B,NW,E0,ISU,ISUSP,IFAP)
C
C  PREPARE FOURIERFILE: H, K, L, A, B IN BLOCKS OF NW
C  (NW=60 FOR EXFFT)
C  A AND B FROM PHASES OF MATRIX AND INVERTED MATRIX
C  IJP, NIJP, IJQ, NIJQ ETC. AS USUAL
C  NUMSET=SETNUMBER, IFAP=FILENUMBER OF FOURIERFILE
C  NUMSET=0: WRITE END OF FILE
C
      INTEGER H,HMAX
      REAL*4 EMX(NM,NM,NNRM),PMX(NM,NM,NNRM),GMX(NM,NM,NNRM),
     1 HMX(NM,NM,NNRM)
      INTEGER ISU(NM,NM,NNRM)
      DIMENSION MX(NM,NNRM)
      DIMENSION IJP(7,NIJP),IJQ(8,NIJQ)
      DIMENSION H(NW)
      DIMENSION K(NW)
      DIMENSION L(NW)
      DIMENSION A(NW)
      DIMENSION B(NW)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
      NDEL=0
      MAXH=0
      MAXK=0
      MAXL=0
      M128=8421504
      PI=3.141592650
      PID12=PI/12.0
C
C  MARK START OF SERIES (-1001)
C
      ND=-1001
      WRITE(IFAP) ND
      WRITE(IFAP) NUMSET
      IF(NUMSET.LT.0) GOTO 4000
C
C  GET NUMBER OF PEAKS TO BE SEARCHED
C  (SUBROUTINE FIRST FROM MULTAN)
C
      NAT=0
      DO 1010 I=1,8
      IF(JZ(I).NE.1) NAT=NAT+JN(I)
 1010 CONTINUE
      NN=2
      IF(LATT.EQ.1) NN=1
      IF(LATT.EQ.6) NN=4
      IF(LATT.NE.7) GOTO 1060
      DO 1040 I=1,NSYM
      IF(IABS(IS(1,1,I)).EQ.3) GOTO 1050
 1040 CONTINUE
      NN=3
      GOTO 1060
 1050 NN=1
 1060 CONTINUE
      NAT=(NAT/NN+NSYM*(ICENT+1)-1)/(NSYM*(ICENT+1))
      WRITE(IFAP) ITLE,ICENT,LATT,NSYM,
     1 ((TS(I,J),(IS(M,I,J),M=1,2),I=1,3),J=1,NSYM),
     2 MAXH,MAXK,MAXL,PARA,NAT
C
C  GET H, K, L, A, B FROM MATRIX
C
      E=1.0
      J=0
      DO 2100 I=1,NIJP
      IRY=IJP(1,I)
      KOL=IJP(2,I)
      IMA=IJP(3,I)
C
C  DELETE SUSPECTED REFLECTIONS IF ISUSP > 0
C
      IF (ISUSP.GT.0) THEN
      IEIPAR=IJP(5,I)
      IF (ISU(IRY,KOL,IMA).EQ.1) GOTO 1234
      IF (IEIPAR.GT.0) THEN
      IBEPAR=IJP(4,I)
      DO 123 ID=IBEPAR,IEIPAR
      IRYDEP=IJQ(1,ID)
      IKODEP=IJQ(2,ID)
      IMADEP=IJQ(3,ID)
      IF (ISU(IRYDEP,IKODEP,IMADEP).EQ.1) GOTO 1234
  123 CONTINUE
      ENDIF
      NDEL=NDEL+1
      GOTO 2100
      ENDIF
 1234 CONTINUE
      IF(E.LT.0.1) J=J-1
C
C  KEEP COUNT FOR BUFFER : H, K, L, A, B
C
      J=J+1
      IF(J.LE.NW) GOTO 2030
C
C  EMPTY BUFFER
C
      WRITE(IFAP) H,K,L,A,B
      J=1
 2030 CONTINUE
      E=E0*EMX(IRY,KOL,IMA)
      IF(E.LT.0.1) GOTO 2100
      P=PMX(IRY,KOL,IMA)
      A(J)=E*COS(P)
      B(J)=E*SIN(P)
C
C  HKL + 128 IN BYTE 2, 3, 4 OF M
C
      M=M128+MX(KOL,IMA)-MX(IRY,IMA)
      CALL UNPK1(M,H(J),K(J),L(J))
 2100 CONTINUE
      WRITE(LO,456) NDEL
  456 FORMAT(' ',I5,' SUSPECTED INDEPENDENTS REMOVED FROM FOURIER')
C
C  END OF FILE H=-1000
C
      J=J+1
      IF(J.LE.NW) GOTO 2130
      WRITE(IFAP) H,K,L,A,B
      J=1
 2130 CONTINUE
      H(J)=-1000
      WRITE(IFAP) H,K,L,A,B
      WRITE(LO,2131) NUMSET
 2131 FORMAT(' FOURIER FILE OF MATRIX,NUMSET=',I5,' WRITTEN')
C
C  INVERSE FOURIER FILE END OF FILE
C
      ND=-1002
      WRITE(IFAP) ND
      WRITE(IFAP) NUMSET
C
C  LATTICE AS NUMBER ON FILE
C
      WRITE(IFAP) ITLE,ICENT,LATT,NSYM,
     1 ((TS(I,J),(IS(M,I,J),M=1,2),I=1,3),J=1,NSYM),
     2 MAXH,MAXK,MAXL,PARA,NAT
      J=0
      DO 3200 I=1,NIJP
      IRY=IJP(1,I)
      KOL=IJP(2,I)
      IMA=IJP(3,I)
      M=M128+MX(KOL,IMA)-MX(IRY,IMA)
      J=J+1
      IF(J.LE.NW) GOTO 3130
      WRITE(IFAP) H,K,L,A,B
      J=1
 3130 CONTINUE
      CALL UNPK1(M,H(J),K(J),L(J))
      SA=GMX(IRY,KOL,IMA)
      SB=HMX(IRY,KOL,IMA)
C
C  SUM OF DEPENDENT REFLEXIONS
C
      IEI=IJP(5,I)
      IF(IEI.EQ.0) GOTO 3180
      IF(ABS(SA).LT.1.0E-6.AND.ABS(SB).LT.1.0E-6) THEN
      BETA=0.0
	ELSE
	BETA=ATAN2(SB,SA)
	ENDIF
      IBE=IJP(4,I)
      DO 3150 II=IBE,IEI
      IRY1=IJQ(4,II)
      KOL1=IJQ(5,II)
      IMA1=IJQ(6,II)
      ISS=IJQ(7,II)
      IT=IJQ(8,II)
      A1=GMX(IRY1,KOL1,IMA1)
      B1=HMX(IRY1,KOL1,IMA1)
      IF(ABS(A1).LT.1.0E-6.AND.ABS(B1).LT.1.0E-6) THEN
      BET1=0.0
	ELSE
	BET1=ATAN2(B1,A1)
	ENDIF
      BET1=(1-2*IT)*BET1-ISS*PID12
      E1=SQRT(A1**2+B1**2)
      SA=SA+E1*COS(BET1)
      SB=SB+E1*SIN(BET1)
 3150 CONTINUE
 3180 CONTINUE
      AB=SQRT(SA**2+SB**2)
      IF(AB.GT.1.0E-3) GOTO 5010
      A(J)=0
      B(J)=0
      GO TO 3200
 5010 CONTINUE
      E=E0*EMX(IRY,KOL,IMA)
      A(J)=E*SA/AB
      B(J)=E*SB/AB
 3200 CONTINUE
      J=J+1
      IF(J.LE.NW) GOTO 3230
      WRITE(IFAP) H,K,L,A,B
      J=1
 3230 CONTINUE
      H(J)=-1000
      WRITE(IFAP) H,K,L,A,B
      WRITE(LO,3231) NUMSET
 3231 FORMAT(' FOURIERFILE OF INVERSE MATRIX,NUMSET=',I5,' WRITTEN')
      GOTO 5000
 4000 CONTINUE
C
C  SIGNAL EOF
C
      ND=-2000
      WRITE(IFAP) ND
      WRITE(LO,4001)
 4001 FORMAT(' END OF FILE WRITTEN ON FOURIERFILE')
 5000 CONTINUE
      RETURN
      END
