C  ******************************************************************
C  FERNOC80.FOR, 26-03-91, RDG
C  Unformatted REDDIF-file (*.RED) ---> Formatted REDDIF-file (*.RDF)
C  ******************************************************************
C  Omzetten van binaire REDDIF files op de VAX naar de geformateerde 
C  vorm (oorspronkelijke vorm naar transporteerbare vorm).
C  Dit omzetten bestaat uit het terugveranderen van de ongeformateerde 
C  REDDIF-file in de geformateerde versie. De geformateerde versie
C  wordt op de IBM gemaakt om de REDDIF-file over te kunnen zenden.
C  Op de IBM is hiervoor het programma CONREF80/CONRFIBM gebruikt in 
C  werkgebied 'ASKA3A.ANCH0.GELDER'.
C  ******************************************************************
      PROGRAM FERNOC80
      IA=1                                                                      
      IB=2                                                                      
      CALL COPY(IA,IB)                                                  
      STOP                                                                      
      END                                                                       
C                                                                               
      SUBROUTINE COPY(IA,IB)                                            
C
C  MAAKT LETTERLIJKE COPIE VAN REFLECTIE DATASET:                    
C  IA IS INPUT, IB IS OUTPUT                                         
C
      DIMENSION IH(3),W(20)                                             
      CALL SPES(IA,IB)                                                  
      ITEL=0                                                            
    1 READ(IA) MARC,IH,NGR,W                                            
      WRITE(IB,110) MARC,IH,NGR                                         
      WRITE(IB,120) W                                                   
  110 FORMAT(5I5)                                                               
  120 FORMAT(10F8.3)                                                            
      IF(MARC.EQ.999)RETURN                                             
      GOTO 1                                                            
      END                                                               
C                                                                               
      SUBROUTINE SPES(IA,IB)                                            
C
C  COPIEERT SPECIFIEKE GEGEVENS EN PRINT DEZE EVENTUEEL              
C  INPUT = IA, OUTPUT = IB                                           
C
      DIMENSION TI(20),CE(26),SY(24,3,4),FA(10,32),WR(10)  
      DIMENSION FAB(10),ATGEW(10)             
      REAL LAB                                                          
      INTEGER HM 
      CHARACTER NTYP(10)*4,SPAT*4
      REWIND IA                                                         
      REWIND IB                                                         
      READ(IA)MARC,TI                                                   
      WRITE(IB,100)MARC                                                 
      WRITE(IB,200)TI                                                   
  100 FORMAT(I5)                                                                
  200 FORMAT(20A4)                                                              
      READ(IA)MARC,MRE,MSC,MCE,MSY,NFA,CE                               
      WRITE(IB,101)MARC,MRE,MSC,MCE,MSY,NFA                             
      WRITE(IB,201)CE                                                   
  101 FORMAT(6I5)                                                               
  201 FORMAT(8F10.5)                                                            
      DO 1 N=1,MSY                                                      
      READ(IA)MARC,((SY(N,I,J),J=1,4),I=1,3)                            
      WRITE(IB,102)MARC,((SY(N,I,J),J=1,4),I=1,3)                       
  102 FORMAT(I5,12F5.2)                                                         
    1 CONTINUE
      READ(IA)MARC
      BACKSPACE IA
      IF(MARC.EQ.993) THEN
      READ(IA)MARC,(NTYP(I),SPAT,FAB(I),ATGEW(I),I=1,NFA)
      WRITE(IB,100)MARC
      WRITE(IB,1107)(NTYP(I),FAB(I),ATGEW(I),I=1,NFA)
 1107 FORMAT(5X,A4,2F12.6)
      ENDIF
      READ(IA)MARC,HM,KM,LM,XLAB                                        
      WRITE(IB,103)MARC,HM,KM,LM,XLAB                                   
  103 FORMAT(4I5,F10.5)                                                         
      DO 2 N=1,NFA                                                      
      READ(IA)MARC,(FA(N,I),I=1,32)                                     
      WRITE(IB,104)MARC                                                 
      WRITE(IB,204)(FA(N,I),I=1,32)                                     
  104 FORMAT(I5)                                                                
  204 FORMAT(8F10.5)                                                            
    2 CONTINUE                                                          
      READ(IA)MARC,NGR                                                  
      WRITE(IB,105)MARC,NGR                                             
  105 FORMAT(2I5)                                                               
      READ(IA)MARC,FOOO,(WR(N),N=1,10)                                  
      WRITE(IB,106)MARC,FOOO                                            
      WRITE(IB,206)(WR(N),N=1,10)                                       
  106 FORMAT(I5,F10.2)                                                          
  206 FORMAT(8F10.5)                                                            
      RETURN                                                            
      END                                                                       
